open BinInt
open BinPos
open Datatypes
open List0
open ListSet
open Wf_nat
open ZArith_dec
open Zdiv

type __ = Obj.t
let __ = let rec f _ = Obj.repr f in Obj.repr f

(** val peq : positive -> positive -> bool **)

let peq x y =
  match coq_Pcompare x y Eq with
    | Eq -> true
    | _ -> false

(** val plt : positive -> positive -> bool **)

let plt x y =
  coq_Z_lt_dec (Zpos x) (Zpos y)

(** val positive_rec : 'a1 -> (positive -> 'a1 -> 'a1) -> positive -> 'a1 **)

let positive_rec v1 f =
  let iter = fun x p ->
    if peq x Coq_xH then v1 else f (coq_Ppred x) (p (coq_Ppred x) __)
  in
  (fun x -> let rec fix_F x0 =
              iter x0 (fun y _ -> fix_F y)
            in fix_F x)

(** val zeq : coq_Z -> coq_Z -> bool **)

let zeq =
  coq_Z_eq_dec

(** val zlt : coq_Z -> coq_Z -> bool **)

let zlt =
  coq_Z_lt_ge_dec

(** val zle : coq_Z -> coq_Z -> bool **)

let zle =
  coq_Z_le_gt_dec

(** val coq_Zdivide_dec : coq_Z -> coq_Z -> bool **)

let coq_Zdivide_dec p q =
  zeq (coq_Zmod q p) Z0

(** val nat_of_Z : coq_Z -> nat **)

let nat_of_Z = function
  | Zpos p -> nat_of_P p
  | _ -> O

(** val coq_ZRdiv : coq_Z -> coq_Z -> coq_Z **)

let coq_ZRdiv a b =
  if zeq (coq_Zmod a b) Z0
  then coq_Zdiv a b
  else coq_Zplus (coq_Zdiv a b) (Zpos Coq_xH)

(** val align : coq_Z -> coq_Z -> coq_Z **)

let align n amount =
  coq_Zmult (coq_Zdiv (coq_Zminus (coq_Zplus n amount) (Zpos Coq_xH)) amount)
    amount

(** val option_map : ('a1 -> 'a2) -> 'a1 option -> 'a2 option **)

let option_map f = function
  | Some y -> Some (f y)
  | None -> None

(** val sum_left_map : ('a1 -> 'a2) -> ('a1, 'a3) sum -> ('a2, 'a3) sum **)

let sum_left_map f = function
  | Coq_inl y -> Coq_inl (f y)
  | Coq_inr z -> Coq_inr z

(** val list_length_z_aux : 'a1 list -> coq_Z -> coq_Z **)

let rec list_length_z_aux l acc =
  match l with
    | [] -> acc
    | hd::tl -> list_length_z_aux tl (coq_Zsucc acc)

(** val list_length_z : 'a1 list -> coq_Z **)

let list_length_z l =
  list_length_z_aux l Z0

(** val list_nth_z : 'a1 list -> coq_Z -> 'a1 option **)

let rec list_nth_z l n =
  match l with
    | [] -> None
    | hd::tl -> if zeq n Z0 then Some hd else list_nth_z tl (coq_Zpred n)

(** val eq_rew_r_dep : 'a1 -> 'a1 -> 'a2 -> 'a2 **)

let eq_rew_r_dep x y hC =
  hC

type 'a incl_dec_prop = 'a list -> 'a list -> __ -> bool

(** val incl_dec_aux :
    ('a1 -> 'a1 -> bool) -> nat -> 'a1 list -> 'a1 list -> bool **)

let incl_dec_aux hdec n l1 l2 =
  lt_wf_rec n (fun n0 h l3 l4 _ ->
    match l3 with
      | [] -> true
      | a::l5 ->
          let s = h (length (remove hdec a l5)) __ (remove hdec a l5) l4 in
          if s __ then in_dec hdec a l4 else false) l1 l2 __

(** val incl_dec : ('a1 -> 'a1 -> bool) -> 'a1 list -> 'a1 list -> bool **)

let incl_dec hdec l1 =
  let j = incl_dec_aux hdec (length l1) in (fun l2 -> j l1 l2)

(** val list_disjoint_dec :
    ('a1 -> 'a1 -> bool) -> 'a1 list -> 'a1 list -> bool **)

let rec list_disjoint_dec eqA_dec l1 l2 =
  match l1 with
    | [] -> true
    | y::l ->
        if in_dec eqA_dec y l2 then false else list_disjoint_dec eqA_dec l l2

(** val list_norepet_dec : ('a1 -> 'a1 -> bool) -> 'a1 list -> bool **)

let rec list_norepet_dec eqA_dec = function
  | [] -> true
  | y::l0 ->
      if list_norepet_dec eqA_dec l0
      then if in_dec eqA_dec y l0 then false else true
      else false

(** val list_drop : nat -> 'a1 list -> 'a1 list **)

let rec list_drop n x =
  match n with
    | O -> x
    | S n' -> (match x with
                 | [] -> []
                 | hd::tl -> list_drop n' tl)

(** val list_repeat : nat -> 'a1 -> 'a1 list **)

let rec list_repeat n x =
  match n with
    | O -> []
    | S m -> x::(list_repeat m x)

(** val proj_sumbool : bool -> bool **)

let proj_sumbool = function
  | true -> true
  | false -> false

(** val remove_redundant : ('a1 -> 'a1 -> bool) -> 'a1 list -> 'a1 list **)

let rec remove_redundant hdec input = match input with
  | [] -> input
  | a::input' ->
      (match input' with
         | [] -> input
         | b::l ->
             if hdec a b
             then remove_redundant hdec input'
             else a::(remove_redundant hdec input'))

(** val remove_redundancy :
    ('a1 -> 'a1 -> bool) -> 'a1 list -> 'a1 list -> 'a1 list **)

let rec remove_redundancy hdec acc = function
  | [] -> acc
  | v::vs' ->
      if in_dec hdec v acc
      then remove_redundancy hdec acc vs'
      else remove_redundancy hdec (v::acc) vs'

module AtomSet = 
 struct 
  (** val set_eq_dec : ('a1 -> 'a1 -> bool) -> 'a1 set -> 'a1 set -> bool **)
  
  let set_eq_dec hdec l1 l2 =
    let s = incl_dec hdec l1 l2 in if s then incl_dec hdec l2 l1 else false
  
  (** val elements_of_set : ('a1 -> 'a1 -> bool) -> 'a1 list -> 'a1 list **)
  
  let elements_of_set hdec ls1 =
    remove_redundancy hdec [] ls1
 end

(** val coq_P_of_plus_nat : positive -> nat -> positive **)

let rec coq_P_of_plus_nat p = function
  | O -> p
  | S x -> coq_Psucc (coq_P_of_plus_nat p x)

