open BinPos
open Coqlib
open Datatypes
open Integers
open Maps

module OrderedPositive : 
 sig 
  type t = positive
  
  val compare : t -> t -> positive OrderedType.coq_Compare
  
  val eq_dec : t -> t -> bool
 end

module OrderedInt : 
 sig 
  val wordsize_one : nat
  
  type t = Int.int
  
  val compare : t -> t -> t OrderedType.coq_Compare
  
  val eq_dec : t -> t -> bool
 end

module OrderedIndexed : 
 functor (A:INDEXED_TYPE) ->
 sig 
  type t = A.t
  
  val compare : t -> t -> t OrderedType.coq_Compare
  
  val eq_dec : t -> t -> bool
 end

module OrderedPair : 
 functor (A:OrderedType.OrderedType) ->
 functor (B:OrderedType.OrderedType) ->
 sig 
  type t = A.t*B.t
  
  val compare : t -> t -> t OrderedType.coq_Compare
  
  val eq_dec : t -> t -> bool
 end

