open Datatypes
open Kildall
open Lattice
open List0
open Maps
open MetatheoryAtom
open Dom_set
open Infrastructure
open Syntax

module ReachDS : 
 sig 
  module L : 
   SEMILATTICE
  
  val fixpoint :
    AtomImpl.atom list ATree.t -> (AtomImpl.atom -> L.t -> L.t) ->
    (AtomImpl.atom*L.t) list -> L.t AMap.t option
 end

val areachable_aux : LLVMsyntax.fdef -> bool AMap.t option

val areachable : LLVMsyntax.fdef -> bool AMap.t

val get_reachable_labels :
  LLVMsyntax.l list -> bool AMap.t -> LLVMsyntax.l list -> LLVMsyntax.l list

val reachablity_analysis : LLVMsyntax.fdef -> LLVMsyntax.l list option

val cmds_dominates_cmd :
  LLVMsyntax.cmds -> LLVMsyntax.id -> AtomImpl.atom list

val inscope_of_block :
  LLVMsyntax.fdef -> LLVMsyntax.l -> AtomImpl.atom list option ->
  LLVMsyntax.l -> AtomImpl.atom list option

val init_scope :
  LLVMsyntax.fdef -> LLVMsyntax.phinodes -> LLVMsyntax.cmds -> LLVMsyntax.id
  -> AtomImpl.atom list

val inscope_of_id :
  LLVMsyntax.fdef -> LLVMsyntax.block -> LLVMsyntax.id -> AtomImpl.atom list
  option

val inscope_of_cmd :
  LLVMsyntax.fdef -> LLVMsyntax.block -> LLVMsyntax.cmd -> AtomImpl.atom list
  option

val inscope_of_tmn :
  LLVMsyntax.fdef -> LLVMsyntax.block -> LLVMsyntax.terminator ->
  AtomImpl.atom list option

val defs_dominate :
  LLVMsyntax.fdef -> LLVMsyntax.block -> LLVMsyntax.block -> LLVMsyntax.insn
  -> AtomImpl.atom list option

