open BinInt
open Datatypes

module Size = 
 struct 
  type t = int
  
  (** val dec : t -> t -> bool **)
  
  let dec = ( = )
  
  (** val coq_Zero : t **)
  
  let coq_Zero = 0
  
  (** val coq_One : t **)
  
  let coq_One = 1
  
  (** val coq_Two : t **)
  
  let coq_Two = 2
  
  (** val coq_Four : t **)
  
  let coq_Four = 4
  
  (** val coq_Eight : t **)
  
  let coq_Eight = 8
  
  (** val coq_Sixteen : t **)
  
  let coq_Sixteen = 16
  
  (** val coq_ThirtyTwo : t **)
  
  let coq_ThirtyTwo = 32
  
  (** val coq_SixtyFour : t **)
  
  let coq_SixtyFour = 64
  
  (** val from_nat : nat -> t **)
  
  let from_nat = Camlcoq.camlint_of_nat
  
  (** val to_nat : t -> nat **)
  
  let to_nat = fun x -> Camlcoq.nat_of_camlint(Int32.of_int x)
  
  (** val to_Z : t -> coq_Z **)
  
  let to_Z = fun x -> Camlcoq.z_of_camlint (Int32.of_int x)
  
  (** val from_Z : coq_Z -> t **)
  
  let from_Z = fun x -> Int32.to_int (Camlcoq.camlint_of_z x)
  
  (** val add : t -> t -> t **)
  
  let add = ( + )
  
  (** val sub : t -> t -> t **)
  
  let sub = ( - )
  
  (** val mul : t -> t -> t **)
  
  let mul = ( * )
  
  (** val div : t -> t -> t **)
  
  let div = ( / )
 end

module Align = 
 struct 
  type t = int
  
  (** val dec : t -> t -> bool **)
  
  let dec = ( = )
  
  (** val coq_Zero : t **)
  
  let coq_Zero = 0
  
  (** val coq_One : t **)
  
  let coq_One = 1
  
  (** val coq_Two : t **)
  
  let coq_Two = 2
  
  (** val coq_Four : t **)
  
  let coq_Four = 4
  
  (** val coq_Eight : t **)
  
  let coq_Eight = 8
  
  (** val coq_Sixteen : t **)
  
  let coq_Sixteen = 16
  
  (** val coq_ThirtyTwo : t **)
  
  let coq_ThirtyTwo = 32
  
  (** val coq_SixtyFour : t **)
  
  let coq_SixtyFour = 64
  
  (** val from_nat : nat -> t **)
  
  let from_nat = Camlcoq.camlint_of_nat
  
  (** val to_nat : t -> nat **)
  
  let to_nat = fun x -> Camlcoq.nat_of_camlint(Int32.of_int x)
  
  (** val to_Z : t -> coq_Z **)
  
  let to_Z = fun x -> Camlcoq.z_of_camlint (Int32.of_int x)
  
  (** val from_Z : coq_Z -> t **)
  
  let from_Z = fun x -> Int32.to_int (Camlcoq.camlint_of_z x)
  
  (** val add : t -> t -> t **)
  
  let add = ( + )
  
  (** val sub : t -> t -> t **)
  
  let sub = ( - )
  
  (** val mul : t -> t -> t **)
  
  let mul = ( * )
  
  (** val div : t -> t -> t **)
  
  let div = ( / )
 end

module INTEGER = 
 struct 
  type t = Llvm.APInt.t
  
  (** val dec : t -> t -> bool **)
  
  let dec = Llvm.APInt.compare
  
  (** val to_nat : t -> nat **)
  
  let to_nat = Camlcoq.llapint2nat
  
  (** val to_Z : t -> coq_Z **)
  
  let to_Z = Camlcoq.llapint2z
  
  (** val of_Z : coq_Z -> coq_Z -> bool -> t **)
  
  let of_Z = Camlcoq.z2llapint
 end

module FLOAT = 
 struct 
  type t = Llvm.APFloat.t
  
  (** val dec : t -> t -> bool **)
  
  let dec = Llvm.APFloat.bcompare
 end

