open BinInt
open Datatypes

module Size : 
 sig 
  type t = int
  
  val dec : t -> t -> bool
  
  val coq_Zero : t
  
  val coq_One : t
  
  val coq_Two : t
  
  val coq_Four : t
  
  val coq_Eight : t
  
  val coq_Sixteen : t
  
  val coq_ThirtyTwo : t
  
  val coq_SixtyFour : t
  
  val from_nat : nat -> t
  
  val to_nat : t -> nat
  
  val to_Z : t -> coq_Z
  
  val from_Z : coq_Z -> t
  
  val add : t -> t -> t
  
  val sub : t -> t -> t
  
  val mul : t -> t -> t
  
  val div : t -> t -> t
 end

module Align : 
 sig 
  type t = int
  
  val dec : t -> t -> bool
  
  val coq_Zero : t
  
  val coq_One : t
  
  val coq_Two : t
  
  val coq_Four : t
  
  val coq_Eight : t
  
  val coq_Sixteen : t
  
  val coq_ThirtyTwo : t
  
  val coq_SixtyFour : t
  
  val from_nat : nat -> t
  
  val to_nat : t -> nat
  
  val to_Z : t -> coq_Z
  
  val from_Z : coq_Z -> t
  
  val add : t -> t -> t
  
  val sub : t -> t -> t
  
  val mul : t -> t -> t
  
  val div : t -> t -> t
 end

module INTEGER : 
 sig 
  type t = Llvm.APInt.t
  
  val dec : t -> t -> bool
  
  val to_nat : t -> nat
  
  val to_Z : t -> coq_Z
  
  val of_Z : coq_Z -> coq_Z -> bool -> t
 end

module FLOAT : 
 sig 
  type t = Llvm.APFloat.t
  
  val dec : t -> t -> bool
 end

