open BinPos
open Datatypes
open Maps
open Specif
open Syntax

type __ = Obj.t

type coq_Frame = { coq_Fr_name : LLVMsyntax.l; coq_Fr_scs : LLVMsyntax.ls }

val coq_Frame_rect :
  (LLVMsyntax.l -> LLVMsyntax.ls -> 'a1) -> coq_Frame -> 'a1

val coq_Frame_rec :
  (LLVMsyntax.l -> LLVMsyntax.ls -> 'a1) -> coq_Frame -> 'a1

val coq_Fr_name : coq_Frame -> LLVMsyntax.l

val coq_Fr_scs : coq_Frame -> LLVMsyntax.ls

val find_next_visit_in_scs :
  unit ATree.t -> LLVMsyntax.ls -> (LLVMsyntax.l*LLVMsyntax.ls) option

type coq_PostOrder = { coq_PO_cnt : positive; coq_PO_a2p : positive ATree.t }

val coq_PostOrder_rect :
  (positive -> positive ATree.t -> 'a1) -> coq_PostOrder -> 'a1

val coq_PostOrder_rec :
  (positive -> positive ATree.t -> 'a1) -> coq_PostOrder -> 'a1

val coq_PO_cnt : coq_PostOrder -> positive

val coq_PO_a2p : coq_PostOrder -> positive ATree.t

val postorder_inc : coq_PostOrder -> LLVMsyntax.l -> coq_PostOrder

val find_next_visit_in_stk :
  LLVMsyntax.ls ATree.t -> unit ATree.t -> coq_PostOrder -> coq_Frame list ->
  ((LLVMsyntax.l*coq_Frame list)*coq_PostOrder, coq_PostOrder) sum

val dfs_aux1_func :
  (LLVMsyntax.ls ATree.t, (unit ATree.t, (coq_PostOrder, (coq_Frame list, __)
  sigT) sigT) sigT) sigT -> coq_PostOrder

val dfs_aux1 :
  LLVMsyntax.ls ATree.t -> unit ATree.t -> coq_PostOrder -> coq_Frame list ->
  coq_PostOrder

val iter : nat -> ('a1 -> 'a1) -> 'a1 -> 'a1

type dfs_aux_type =
  LLVMsyntax.ls ATree.t -> unit ATree.t -> coq_PostOrder -> coq_Frame list ->
  coq_PostOrder

val dfs_aux_F :
  dfs_aux_type -> LLVMsyntax.ls ATree.t -> unit ATree.t -> coq_PostOrder ->
  coq_Frame list -> coq_PostOrder

val dfs_aux_terminates_func_obligation_4 :
  LLVMsyntax.ls ATree.t -> unit ATree.t -> coq_PostOrder -> coq_Frame list ->
  (LLVMsyntax.ls ATree.t -> unit ATree.t -> coq_PostOrder -> coq_Frame list
  -> __ -> __ -> coq_PostOrder) -> LLVMsyntax.l -> coq_Frame list ->
  coq_PostOrder -> coq_PostOrder

val dfs_aux_terminates_func :
  (LLVMsyntax.ls ATree.t, (unit ATree.t, (coq_PostOrder, (coq_Frame list, __)
  sigT) sigT) sigT) sigT -> coq_PostOrder

val dfs_aux_terminates :
  LLVMsyntax.ls ATree.t -> unit ATree.t -> coq_PostOrder -> coq_Frame list ->
  coq_PostOrder

val dfs_aux :
  LLVMsyntax.ls ATree.t -> unit ATree.t -> coq_PostOrder -> coq_Frame list ->
  coq_PostOrder

val dfs : LLVMsyntax.ls ATree.t -> LLVMsyntax.l -> positive -> coq_PostOrder

module Inv : 
 sig 
  
 end

module Order : 
 sig 
  
 end

module ReachableEntry : 
 sig 
  
 end

module ReachableSucc : 
 sig 
  
 end

module NumberedAreReachable : 
 sig 
  
 end

module Injective : 
 sig 
  
 end

