open BinPos
open List0
open Maps
open Dom_tree
open Push_iter

(** val compute_sdom_chains_aux :
    (positive -> LDoms.t) -> positive list -> (positive*positive list) list
    -> (positive*positive list) list **)

let rec compute_sdom_chains_aux res bd acc =
  match bd with
    | [] -> acc
    | l0::bd' ->
        (match res l0 with
           | Some dts0 ->
               compute_sdom_chains_aux res bd' ((l0,(rev (l0::dts0)))::acc)
           | None -> compute_sdom_chains_aux res bd' acc)

(** val compute_sdom_chains :
    (positive -> LDoms.t) -> positive list -> (positive*positive list) list **)

let compute_sdom_chains res rd =
  compute_sdom_chains_aux res rd []

(** val create_dtree :
    positive -> positive list -> (positive -> LDoms.t) -> positive coq_DTree **)

let create_dtree pe rd res =
  let chains = compute_sdom_chains res rd in
  create_dtree_from_chains positive_eq_dec pe chains

(** val entrypoints : positive -> (positive*LDoms.t) list **)

let entrypoints pe =
  (pe,LDoms.top)::[]

(** val predecessors : positive list PTree.t -> PTree.elt list PTree.t **)

let predecessors psuccs =
  XPTree.make_predecessors psuccs

