open Coqlib
open Datatypes
open List0
open ListSet
open MetatheoryAtom
open Analysis
open Dom_set
open Dom_tree
open Infrastructure
open Syntax

val dtree_dom : AtomImpl.atom coq_DTree -> AtomSetImpl.t

val dtrees_dom : AtomImpl.atom coq_DTrees -> AtomSetImpl.t

val gt_sdom :
  (LLVMsyntax.l -> LLVMsyntax.l set) -> LLVMsyntax.l -> LLVMsyntax.l -> bool

val find_min :
  (LLVMsyntax.l -> LLVMsyntax.l set) -> LLVMsyntax.l -> LLVMsyntax.l set ->
  LLVMsyntax.l

val insert_sort_sdom_iter :
  (LLVMsyntax.l -> LLVMsyntax.l set) -> LLVMsyntax.l -> LLVMsyntax.l list ->
  LLVMsyntax.l list -> LLVMsyntax.l list

val insert_sort_sdom :
  (LLVMsyntax.l -> LLVMsyntax.l set) -> LLVMsyntax.l list -> LLVMsyntax.l
  list -> LLVMsyntax.l list

val sort_sdom :
  (LLVMsyntax.l -> LLVMsyntax.l set) -> LLVMsyntax.l list -> LLVMsyntax.l
  list

val remove_redundant : LLVMsyntax.l list -> LLVMsyntax.l list

val compute_sdom_chains_aux :
  (LLVMsyntax.l -> LLVMsyntax.l set) -> LLVMsyntax.l list ->
  (LLVMsyntax.l*LLVMsyntax.l list) list -> (LLVMsyntax.l*LLVMsyntax.l list)
  list

val compute_sdom_chains :
  (LLVMsyntax.l -> LLVMsyntax.l set) -> LLVMsyntax.l list ->
  (LLVMsyntax.l*LLVMsyntax.l list) list

val find_idom_aux :
  (LLVMsyntax.l -> LLVMsyntax.l set) -> LLVMsyntax.l -> LLVMsyntax.l set ->
  LLVMsyntax.l option

val find_idom :
  (LLVMsyntax.l -> LLVMsyntax.l set) -> LLVMsyntax.l -> LLVMsyntax.l option

val compute_idoms :
  (LLVMsyntax.l -> LLVMsyntax.l set) -> LLVMsyntax.l list ->
  (LLVMsyntax.l*LLVMsyntax.l) list -> (LLVMsyntax.l*LLVMsyntax.l) list

val create_dtree : LLVMsyntax.fdef -> AtomImpl.atom coq_DTree option

