open AST
open Datatypes
open Integers
open List0
open MetatheoryAtom
open Values
open Genericvalues

type __ = Obj.t
let __ = let rec f _ = Obj.repr f in Obj.repr f

module Genv = 
 struct 
  type 'gV t = { genv_vars : (AtomImpl.atom*'gV) list;
                 genv_find_symbol : (AtomImpl.atom -> block option);
                 genv_find_var_info : (block -> 'gV option) }
  
  (** val t_rect :
      ((AtomImpl.atom*'a1) list -> (AtomImpl.atom -> block option) -> (block
      -> 'a1 option) -> __ -> 'a2) -> 'a1 t -> 'a2 **)
  
  let t_rect f t0 =
    let { genv_vars = x; genv_find_symbol = x0; genv_find_var_info = x1 } =
      t0
    in
    f x x0 x1 __
  
  (** val t_rec :
      ((AtomImpl.atom*'a1) list -> (AtomImpl.atom -> block option) -> (block
      -> 'a1 option) -> __ -> 'a2) -> 'a1 t -> 'a2 **)
  
  let t_rec f t0 =
    let { genv_vars = x; genv_find_symbol = x0; genv_find_var_info = x1 } =
      t0
    in
    f x x0 x1 __
  
  (** val genv_vars : 'a1 t -> (AtomImpl.atom*'a1) list **)
  
  let genv_vars x = x.genv_vars
  
  (** val genv_find_symbol : 'a1 t -> AtomImpl.atom -> block option **)
  
  let genv_find_symbol x = x.genv_find_symbol
  
  (** val genv_find_var_info : 'a1 t -> block -> 'a1 option **)
  
  let genv_find_var_info x = x.genv_find_var_info
  
  (** val find_symbol : 'a1 t -> AtomImpl.atom -> block option **)
  
  let find_symbol ge id =
    ge.genv_find_symbol id
  
  (** val find_var_info : 'a1 t -> block -> 'a1 option **)
  
  let find_var_info ge b =
    ge.genv_find_var_info b
 end

type eventval =
  | EVint of nat * Int.int
  | EVfloat of float
  | EVptr_global of AtomImpl.atom * Int.int

(** val eventval_rect :
    (nat -> Int.int -> 'a1) -> (float -> 'a1) -> (AtomImpl.atom -> Int.int ->
    'a1) -> eventval -> 'a1 **)

let eventval_rect f f0 f1 = function
  | EVint (x, x0) -> f x x0
  | EVfloat x -> f0 x
  | EVptr_global (x, x0) -> f1 x x0

(** val eventval_rec :
    (nat -> Int.int -> 'a1) -> (float -> 'a1) -> (AtomImpl.atom -> Int.int ->
    'a1) -> eventval -> 'a1 **)

let eventval_rec f f0 f1 = function
  | EVint (x, x0) -> f x x0
  | EVfloat x -> f0 x
  | EVptr_global (x, x0) -> f1 x x0

type eventgv = eventval list

type event =
  | Event_syscall of AtomImpl.atom * eventgv list * eventgv option

(** val event_rect :
    (AtomImpl.atom -> eventgv list -> eventgv option -> 'a1) -> event -> 'a1 **)

let event_rect f = function
  | Event_syscall (x, x0, x1) -> f x x0 x1

(** val event_rec :
    (AtomImpl.atom -> eventgv list -> eventgv option -> 'a1) -> event -> 'a1 **)

let event_rec f = function
  | Event_syscall (x, x0, x1) -> f x x0 x1

type trace = event list

(** val coq_E0 : trace **)

let coq_E0 =
  []

(** val coq_Eapp : trace -> trace -> trace **)

let coq_Eapp t1 t2 =
  app t1 t2

type traceinf = __traceinf Lazy.t
and __traceinf =
  | Econsinf of event * traceinf

(** val coq_Eappinf : trace -> traceinf -> traceinf **)

let rec coq_Eappinf t0 t1 =
  match t0 with
    | [] -> t1
    | ev::t' -> lazy (Econsinf (ev, (coq_Eappinf t' t1)))

type traceinf' = __traceinf' Lazy.t
and __traceinf' =
  | Econsinf' of trace * traceinf'

(** val split_traceinf'_obligation_1 :
    trace -> traceinf' -> event*traceinf' **)

let split_traceinf'_obligation_1 t0 t1 =
  assert false (* absurd case *)

(** val split_traceinf' : trace -> traceinf' -> event*traceinf' **)

let split_traceinf' t0 t1 =
  let branch_0 = fun _ -> split_traceinf'_obligation_1 t0 t1 in
  let branch_1 = fun e -> e,t1 in
  let branch_2 = fun e t' -> e,(lazy (Econsinf' (t', t1))) in
  (match t0 with
     | [] -> branch_0 __
     | e::t' ->
         (match t' with
            | [] -> branch_1 e
            | e0::l -> let t'0 = e0::l in branch_2 e t'0))

(** val traceinf_of_traceinf' : traceinf' -> traceinf **)

let rec traceinf_of_traceinf' t' =
  let Econsinf' (t0, t'') = Lazy.force t' in
  let e,tl = split_traceinf' t0 t'' in
  lazy (Econsinf (e, (traceinf_of_traceinf' tl)))

(** val eventval_type : eventval -> typ **)

let eventval_type = function
  | EVfloat f0 -> Tfloat
  | _ -> Tint

(** val eventgv_type :
    LLVMgv.coq_GenericValue Genv.t -> eventgv -> typ list **)

let eventgv_type ge egv =
  map eventval_type egv

