open AST
open Datatypes
open Integers
open List0
open MetatheoryAtom
open Values
open Genericvalues

type __ = Obj.t

module Genv : 
 sig 
  type 'gV t = { genv_vars : (AtomImpl.atom*'gV) list;
                 genv_find_symbol : (AtomImpl.atom -> block option);
                 genv_find_var_info : (block -> 'gV option) }
  
  val t_rect :
    ((AtomImpl.atom*'a1) list -> (AtomImpl.atom -> block option) -> (block ->
    'a1 option) -> __ -> 'a2) -> 'a1 t -> 'a2
  
  val t_rec :
    ((AtomImpl.atom*'a1) list -> (AtomImpl.atom -> block option) -> (block ->
    'a1 option) -> __ -> 'a2) -> 'a1 t -> 'a2
  
  val genv_vars : 'a1 t -> (AtomImpl.atom*'a1) list
  
  val genv_find_symbol : 'a1 t -> AtomImpl.atom -> block option
  
  val genv_find_var_info : 'a1 t -> block -> 'a1 option
  
  val find_symbol : 'a1 t -> AtomImpl.atom -> block option
  
  val find_var_info : 'a1 t -> block -> 'a1 option
 end

type eventval =
  | EVint of nat * Int.int
  | EVfloat of float
  | EVptr_global of AtomImpl.atom * Int.int

val eventval_rect :
  (nat -> Int.int -> 'a1) -> (float -> 'a1) -> (AtomImpl.atom -> Int.int ->
  'a1) -> eventval -> 'a1

val eventval_rec :
  (nat -> Int.int -> 'a1) -> (float -> 'a1) -> (AtomImpl.atom -> Int.int ->
  'a1) -> eventval -> 'a1

type eventgv = eventval list

type event =
  | Event_syscall of AtomImpl.atom * eventgv list * eventgv option

val event_rect :
  (AtomImpl.atom -> eventgv list -> eventgv option -> 'a1) -> event -> 'a1

val event_rec :
  (AtomImpl.atom -> eventgv list -> eventgv option -> 'a1) -> event -> 'a1

type trace = event list

val coq_E0 : trace

val coq_Eapp : trace -> trace -> trace

type traceinf = __traceinf Lazy.t
and __traceinf =
  | Econsinf of event * traceinf

val coq_Eappinf : trace -> traceinf -> traceinf

type traceinf' = __traceinf' Lazy.t
and __traceinf' =
  | Econsinf' of trace * traceinf'

val split_traceinf'_obligation_1 : trace -> traceinf' -> event*traceinf'

val split_traceinf' : trace -> traceinf' -> event*traceinf'

val traceinf_of_traceinf' : traceinf' -> traceinf

val eventval_type : eventval -> typ

val eventgv_type : LLVMgv.coq_GenericValue Genv.t -> eventgv -> typ list

