open Coqlib
open List0
open MetatheoryAtom
open Values
open Alist
open Datatype_base
open Events
open Genericvalues
open Syntax
open Targetdata

type __ = Obj.t
let __ = let rec f _ = Obj.repr f in Obj.repr f

(** val find_symbol :
    LLVMtd.coq_TargetData -> (LLVMsyntax.id*LLVMgv.coq_GenericValue) list ->
    LLVMsyntax.id -> block option **)

let find_symbol tD ge gid =
  match lookupAL ge gid with
    | Some gv ->
        (match LLVMgv.coq_GV2ptr tD (LLVMtd.getPointerSize tD) gv with
           | Some v -> (match v with
                          | Vptr (b, i) -> Some b
                          | _ -> None)
           | None -> None)
    | None -> None

(** val find_var_info :
    LLVMtd.coq_TargetData -> (LLVMsyntax.id*LLVMgv.coq_GenericValue) list ->
    block -> LLVMgv.coq_GenericValue option **)

let find_var_info tD ge b =
  fold_left (fun acc elt ->
    let y,gv = elt in
    (match acc with
       | Some y0 -> acc
       | None ->
           (match LLVMgv.coq_GV2ptr tD (LLVMtd.getPointerSize tD) gv with
              | Some v ->
                  (match v with
                     | Vptr (b', i) -> if zeq b b' then Some gv else None
                     | _ -> None)
              | None -> None))) ge None

(** val globals2Genv :
    LLVMtd.coq_TargetData -> (LLVMsyntax.id*LLVMgv.coq_GenericValue) list ->
    LLVMgv.coq_GenericValue Genv.t **)

let globals2Genv tD gl =
  { Genv.genv_vars = gl; Genv.genv_find_symbol = (find_symbol tD gl);
    Genv.genv_find_var_info = (find_var_info tD gl) }

(** val extcall_properties_rect :
    LLVMtd.coq_TargetData -> LLVMsyntax.typ -> LLVMsyntax.typ list -> (__ ->
    __ -> __ -> __ -> __ -> __ -> __ -> __ -> __ -> __ -> 'a1) -> 'a1 **)

let extcall_properties_rect tD tret targs f =
  f __ __ __ __ __ __ __ __ __ __

(** val extcall_properties_rec :
    LLVMtd.coq_TargetData -> LLVMsyntax.typ -> LLVMsyntax.typ list -> (__ ->
    __ -> __ -> __ -> __ -> __ -> __ -> __ -> __ -> __ -> 'a1) -> 'a1 **)

let extcall_properties_rec tD tret targs f =
  f __ __ __ __ __ __ __ __ __ __

(** val callIOFunction :
    LLVMtd.coq_TargetData -> (AtomImpl.atom*LLVMgv.coq_GenericValue) list ->
    LLVMgv.mem -> LLVMsyntax.id -> LLVMsyntax.typ -> LLVMsyntax.typ list ->
    LLVMgv.coq_GenericValue list -> ((LLVMgv.coq_GenericValue
    option*trace)*LLVMgv.mem) option **)

let callIOFunction = fun x y z a b c d -> assert false

(** val callExternalFunction :
    LLVMtd.coq_TargetData -> (AtomImpl.atom*LLVMgv.coq_GenericValue) list ->
    LLVMgv.mem -> LLVMsyntax.id -> LLVMsyntax.typ -> LLVMsyntax.typ list ->
    LLVMgv.coq_GenericValue list -> (LLVMgv.coq_GenericValue
    option*LLVMgv.mem) option **)

let callExternalFunction = fun x y z a b c d -> assert false

(** val callIntrinsics :
    LLVMtd.coq_TargetData -> (AtomImpl.atom*LLVMgv.coq_GenericValue) list ->
    LLVMgv.mem -> LLVMsyntax.intrinsic_id -> LLVMsyntax.typ -> LLVMsyntax.typ
    list -> LLVMgv.coq_GenericValue list -> (LLVMgv.coq_GenericValue
    option*LLVMgv.mem) option **)

let callIntrinsics = fun x y z a b c d -> assert false

(** val callMalloc :
    LLVMtd.coq_TargetData -> LLVMgv.mem -> LLVMgv.coq_GenericValue list ->
    (LLVMgv.coq_GenericValue option*LLVMgv.mem) option **)

let callMalloc tD m = function
  | [] -> None
  | gn::l ->
      (match LLVMgv.malloc tD m Size.coq_One gn Align.coq_Four with
         | Some p -> let m',mb = p in Some ((Some (LLVMgv.blk2GV tD mb)),m')
         | None -> None)

(** val callFree :
    LLVMtd.coq_TargetData -> LLVMgv.mem -> LLVMgv.coq_GenericValue list ->
    (LLVMgv.coq_GenericValue option*LLVMgv.mem) option **)

let callFree tD m = function
  | [] -> None
  | ptr::l ->
      (match LLVMgv.free tD m ptr with
         | Some m' -> Some (None,m')
         | None -> None)

(** val add_empty_trace :
    (LLVMgv.coq_GenericValue option*LLVMgv.mem) option ->
    ((LLVMgv.coq_GenericValue option*trace)*LLVMgv.mem) option **)

let add_empty_trace = function
  | Some p -> let or0,m' = p in Some ((or0,coq_E0),m')
  | None -> None

(** val callExternalOrIntrinsics :
    LLVMtd.coq_TargetData -> (AtomImpl.atom*LLVMgv.coq_GenericValue) list ->
    LLVMgv.mem -> LLVMsyntax.id -> LLVMsyntax.typ -> LLVMsyntax.typ list ->
    LLVMsyntax.deckind -> LLVMgv.coq_GenericValue list ->
    ((LLVMgv.coq_GenericValue option*trace)*LLVMgv.mem) option **)

let callExternalOrIntrinsics = Llvmcaml2.callExternalFunction

