open AST
open BinInt
open CoqEqDec
open Coqlib
open Datatypes
open List0
open ListSet
open MetatheoryAtom
open Peano
open Alist
open Datatype_base
open Monad
open Syntax
open Targetdata

type __ = Obj.t
let __ = let rec f _ = Obj.repr f in Obj.repr f

module LLVMinfra = 
 struct 
  (** val id_dec : LLVMsyntax.id -> LLVMsyntax.id -> bool **)
  
  let id_dec =
    AtomImpl.eq_atom_dec
  
  (** val l_dec : LLVMsyntax.l -> LLVMsyntax.l -> bool **)
  
  let l_dec =
    AtomImpl.eq_atom_dec
  
  (** val inbounds_dec :
      LLVMsyntax.inbounds -> LLVMsyntax.inbounds -> bool **)
  
  let inbounds_dec = (=)
  
  (** val tailc_dec : LLVMsyntax.tailc -> LLVMsyntax.tailc -> bool **)
  
  let tailc_dec = (=)
  
  (** val noret_dec : LLVMsyntax.noret -> LLVMsyntax.noret -> bool **)
  
  let noret_dec = (=)
  
  (** val lempty_set : LLVMsyntax.l set **)
  
  let lempty_set =
    empty_set
  
  (** val lset_add : LLVMsyntax.l -> LLVMsyntax.ls -> LLVMsyntax.l set **)
  
  let lset_add l1 ls2 =
    set_add (eq_dec (coq_EqDec_eq_of_EqDec coq_EqDec_atom)) l1 ls2
  
  (** val lset_union : LLVMsyntax.ls -> LLVMsyntax.ls -> LLVMsyntax.l set **)
  
  let lset_union ls1 ls2 =
    set_union (eq_dec (coq_EqDec_eq_of_EqDec coq_EqDec_atom)) ls1 ls2
  
  (** val lset_inter : LLVMsyntax.ls -> LLVMsyntax.ls -> LLVMsyntax.l set **)
  
  let lset_inter ls1 ls2 =
    set_inter (eq_dec (coq_EqDec_eq_of_EqDec coq_EqDec_atom)) ls1 ls2
  
  (** val lset_eqb : LLVMsyntax.ls -> LLVMsyntax.ls -> bool **)
  
  let lset_eqb ls1 ls2 =
    match lset_inter ls1 ls2 with
      | [] -> true
      | l0::l1 -> false
  
  (** val lset_neqb : LLVMsyntax.ls -> LLVMsyntax.ls -> bool **)
  
  let lset_neqb ls1 ls2 =
    match lset_inter ls1 ls2 with
      | [] -> false
      | l0::l1 -> true
  
  (** val lset_single : LLVMsyntax.l -> LLVMsyntax.l set **)
  
  let lset_single l0 =
    lset_add l0 lempty_set
  
  (** val lset_mem : LLVMsyntax.l -> LLVMsyntax.ls -> bool **)
  
  let lset_mem l0 ls0 =
    set_mem (eq_dec (coq_EqDec_eq_of_EqDec coq_EqDec_atom)) l0 ls0
  
  (** val getCmdLoc : LLVMsyntax.cmd -> LLVMsyntax.id **)
  
  let getCmdLoc = function
    | LLVMsyntax.Coq_insn_bop (id0, bop5, sz0, v1, v2) -> id0
    | LLVMsyntax.Coq_insn_fbop
        (id0, fbop5, floating_point5, value1, value2) -> id0
    | LLVMsyntax.Coq_insn_extractvalue (id0, typs, id1, c1, typ') -> id0
    | LLVMsyntax.Coq_insn_insertvalue (id0, typs, id1, typ1, v1, c2) -> id0
    | LLVMsyntax.Coq_insn_malloc (id0, typ5, value5, align5) -> id0
    | LLVMsyntax.Coq_insn_free (id0, typ5, value5) -> id0
    | LLVMsyntax.Coq_insn_alloca (id0, typ5, value5, align5) -> id0
    | LLVMsyntax.Coq_insn_load (id0, typ1, v1, align5) -> id0
    | LLVMsyntax.Coq_insn_store (id0, typ1, v1, v2, align5) -> id0
    | LLVMsyntax.Coq_insn_gep (id0, inbounds5, typ5, value_5, l0, typ') ->
        id0
    | LLVMsyntax.Coq_insn_trunc (id0, truncop5, typ1, v1, typ2) -> id0
    | LLVMsyntax.Coq_insn_ext (id0, extop5, sz1, v1, sz2) -> id0
    | LLVMsyntax.Coq_insn_cast (id0, castop5, typ1, v1, typ2) -> id0
    | LLVMsyntax.Coq_insn_icmp (id0, cond0, typ0, v1, v2) -> id0
    | LLVMsyntax.Coq_insn_fcmp (id0, cond0, typ0, v1, v2) -> id0
    | LLVMsyntax.Coq_insn_select (id0, v0, typ0, v1, v2) -> id0
    | LLVMsyntax.Coq_insn_call
        (id0, noret5, clattrs5, typ5, varg5, v0, paraml) -> id0
  
  (** val getTerminatorID : LLVMsyntax.terminator -> LLVMsyntax.id **)
  
  let getTerminatorID = function
    | LLVMsyntax.Coq_insn_return (id0, t, v) -> id0
    | LLVMsyntax.Coq_insn_return_void id0 -> id0
    | LLVMsyntax.Coq_insn_br (id0, v, l1, l2) -> id0
    | LLVMsyntax.Coq_insn_br_uncond (id0, l0) -> id0
    | LLVMsyntax.Coq_insn_unreachable id0 -> id0
  
  (** val getPhiNodeID : LLVMsyntax.phinode -> LLVMsyntax.id **)
  
  let getPhiNodeID = function
    | LLVMsyntax.Coq_insn_phi (id0, typ5, l0) -> id0
  
  (** val getValueID : LLVMsyntax.value -> LLVMsyntax.id option **)
  
  let getValueID = function
    | LLVMsyntax.Coq_value_id id0 -> Some id0
    | LLVMsyntax.Coq_value_const const5 -> None
  
  (** val getInsnLoc : LLVMsyntax.insn -> LLVMsyntax.id **)
  
  let getInsnLoc = function
    | LLVMsyntax.Coq_insn_phinode p -> getPhiNodeID p
    | LLVMsyntax.Coq_insn_cmd c -> getCmdLoc c
    | LLVMsyntax.Coq_insn_terminator t -> getTerminatorID t
  
  (** val isPhiNodeB : LLVMsyntax.insn -> bool **)
  
  let isPhiNodeB = function
    | LLVMsyntax.Coq_insn_phinode p -> true
    | _ -> false
  
  (** val getCmdID : LLVMsyntax.cmd -> LLVMsyntax.id option **)
  
  let getCmdID = function
    | LLVMsyntax.Coq_insn_bop (id0, bop5, sz0, v1, v2) -> Some id0
    | LLVMsyntax.Coq_insn_fbop
        (id0, fbop5, floating_point5, value1, value2) -> Some id0
    | LLVMsyntax.Coq_insn_extractvalue (id0, typs, id1, c1, typ') -> Some id0
    | LLVMsyntax.Coq_insn_insertvalue (id0, typs, id1, typ1, v1, c2) -> Some
        id0
    | LLVMsyntax.Coq_insn_malloc (id0, typ5, value5, align5) -> Some id0
    | LLVMsyntax.Coq_insn_alloca (id0, typ5, value5, align5) -> Some id0
    | LLVMsyntax.Coq_insn_load (id0, typ1, v1, align5) -> Some id0
    | LLVMsyntax.Coq_insn_gep (id0, inbounds5, typ5, value_5, l0, typ') ->
        Some id0
    | LLVMsyntax.Coq_insn_trunc (id0, truncop5, typ1, v1, typ2) -> Some id0
    | LLVMsyntax.Coq_insn_ext (id0, extop5, sz1, v1, sz2) -> Some id0
    | LLVMsyntax.Coq_insn_cast (id0, castop5, typ1, v1, typ2) -> Some id0
    | LLVMsyntax.Coq_insn_icmp (id0, cond0, typ0, v1, v2) -> Some id0
    | LLVMsyntax.Coq_insn_fcmp (id0, cond0, typ0, v1, v2) -> Some id0
    | LLVMsyntax.Coq_insn_select (id0, v0, typ0, v1, v2) -> Some id0
    | LLVMsyntax.Coq_insn_call
        (id0, nr, clattrs5, typ5, varg5, v0, paraml) ->
        if nr then None else Some id0
    | _ -> None
  
  (** val getCmdsIDs : LLVMsyntax.cmds -> AtomImpl.atom list **)
  
  let rec getCmdsIDs = function
    | [] -> []
    | c::cs' ->
        (match getCmdID c with
           | Some id1 -> id1::(getCmdsIDs cs')
           | None -> getCmdsIDs cs')
  
  (** val getPhiNodesIDs : LLVMsyntax.phinodes -> AtomImpl.atom list **)
  
  let getPhiNodesIDs ps =
    map getPhiNodeID ps
  
  (** val getBlockIDs : LLVMsyntax.block -> AtomImpl.atom list **)
  
  let getBlockIDs = function
    | LLVMsyntax.Coq_block_intro (l5, ps, cs, terminator5) ->
        app (getPhiNodesIDs ps) (getCmdsIDs cs)
  
  (** val label_of_block : LLVMsyntax.block -> LLVMsyntax.l **)
  
  let label_of_block = function
    | LLVMsyntax.Coq_block_intro (l1, phinodes5, cmds5, terminator5) -> l1
  
  (** val getArgsIDs : LLVMsyntax.args -> AtomImpl.atom list **)
  
  let rec getArgsIDs = function
    | [] -> []
    | p::la' -> let p0,id1 = p in id1::(getArgsIDs la')
  
  (** val getArgsOfFdef : LLVMsyntax.fdef -> LLVMsyntax.args **)
  
  let getArgsOfFdef = function
    | LLVMsyntax.Coq_fdef_intro (fheader5, blocks5) ->
        let LLVMsyntax.Coq_fheader_intro (fnattrs5, typ5, id5, la, varg5) =
          fheader5
        in
        la
  
  (** val getArgsIDsOfFdef : LLVMsyntax.fdef -> AtomImpl.atom list **)
  
  let getArgsIDsOfFdef = function
    | LLVMsyntax.Coq_fdef_intro (fheader5, blocks5) ->
        let LLVMsyntax.Coq_fheader_intro (fnattrs5, typ5, id5, la, varg5) =
          fheader5
        in
        getArgsIDs la
  
  (** val getInsnID : LLVMsyntax.insn -> LLVMsyntax.id option **)
  
  let getInsnID = function
    | LLVMsyntax.Coq_insn_phinode p -> Some (getPhiNodeID p)
    | LLVMsyntax.Coq_insn_cmd c -> getCmdID c
    | LLVMsyntax.Coq_insn_terminator t -> None
  
  (** val mgetoffset_aux :
      LLVMtd.coq_TargetData -> LLVMsyntax.typ -> coq_Z list -> coq_Z ->
      (coq_Z*LLVMsyntax.typ) option **)
  
  let rec mgetoffset_aux = Llvmcaml.TargetData.mgetoffset_aux
  
  (** val mgetoffset :
      LLVMtd.coq_TargetData -> LLVMsyntax.typ -> coq_Z list ->
      (coq_Z*LLVMsyntax.typ) option **)
  
  let mgetoffset = Llvmcaml.TargetData.mgetoffset
  
  (** val intConsts2Nats :
      LLVMtd.coq_TargetData -> LLVMsyntax.const list -> coq_Z list option **)
  
  let rec intConsts2Nats tD = function
    | [] -> Some []
    | c::lv' ->
        (match c with
           | LLVMsyntax.Coq_const_int (sz0, n) ->
               if Size.dec sz0 Size.coq_ThirtyTwo
               then (match intConsts2Nats tD lv' with
                       | Some ns -> Some ((INTEGER.to_Z n)::ns)
                       | None -> None)
               else None
           | _ -> None)
  
  (** val getSubTypFromConstIdxs :
      LLVMsyntax.const list -> LLVMsyntax.typ -> LLVMsyntax.typ option **)
  
  let rec getSubTypFromConstIdxs idxs t =
    match idxs with
      | [] -> Some t
      | idx::idxs' ->
          (match t with
             | LLVMsyntax.Coq_typ_array (sz0, t') ->
                 getSubTypFromConstIdxs idxs' t'
             | LLVMsyntax.Coq_typ_struct lt ->
                 (match idx with
                    | LLVMsyntax.Coq_const_int (sz0, i0) ->
                        (match nth_error lt (INTEGER.to_nat i0) with
                           | Some t' -> getSubTypFromConstIdxs idxs' t'
                           | None -> None)
                    | _ -> None)
             | _ -> None)
  
  (** val getConstGEPTyp :
      LLVMsyntax.const list -> LLVMsyntax.typ -> LLVMsyntax.typ option **)
  
  let getConstGEPTyp idxs t =
    match idxs with
      | [] -> None
      | idx::idxs' ->
          (match t with
             | LLVMsyntax.Coq_typ_pointer t0 ->
                 (match getSubTypFromConstIdxs idxs' t0 with
                    | Some t' -> Some (LLVMsyntax.Coq_typ_pointer t')
                    | None -> None)
             | _ -> None)
  
  (** val getSubTypFromValueIdxs :
      (LLVMsyntax.sz*LLVMsyntax.value) list -> LLVMsyntax.typ ->
      LLVMsyntax.typ option **)
  
  let rec getSubTypFromValueIdxs idxs t =
    match idxs with
      | [] -> Some t
      | p::idxs' ->
          let s,idx = p in
          (match t with
             | LLVMsyntax.Coq_typ_array (sz0, t') ->
                 getSubTypFromValueIdxs idxs' t'
             | LLVMsyntax.Coq_typ_struct lt ->
                 (match idx with
                    | LLVMsyntax.Coq_value_id id5 -> None
                    | LLVMsyntax.Coq_value_const const5 ->
                        (match const5 with
                           | LLVMsyntax.Coq_const_int (
                               sz0, i0) ->
                               (match nth_error lt (INTEGER.to_nat i0) with
                                  | Some t' ->
                                      getSubTypFromValueIdxs idxs' t'
                                  | None -> None)
                           | _ -> None))
             | _ -> None)
  
  (** val getGEPTyp :
      (LLVMsyntax.sz*LLVMsyntax.value) list -> LLVMsyntax.typ ->
      LLVMsyntax.typ option **)
  
  let getGEPTyp idxs t =
    match idxs with
      | [] -> None
      | p::idxs' ->
          (match getSubTypFromValueIdxs idxs' t with
             | Some t' -> Some (LLVMsyntax.Coq_typ_pointer t')
             | None -> None)
  
  (** val getCmdTyp : LLVMsyntax.cmd -> LLVMsyntax.typ option **)
  
  let getCmdTyp = function
    | LLVMsyntax.Coq_insn_bop (id5, bop5, sz0, value1, value2) -> Some
        (LLVMsyntax.Coq_typ_int sz0)
    | LLVMsyntax.Coq_insn_fbop (id5, fbop5, ft, value1, value2) -> Some
        (LLVMsyntax.Coq_typ_floatpoint ft)
    | LLVMsyntax.Coq_insn_extractvalue (id5, typ0, value5, idxs, typ') ->
        Some typ'
    | LLVMsyntax.Coq_insn_insertvalue
        (id5, typ0, value5, typ', value', l0) -> Some typ0
    | LLVMsyntax.Coq_insn_malloc (id5, typ0, value5, align5) -> Some
        (LLVMsyntax.Coq_typ_pointer typ0)
    | LLVMsyntax.Coq_insn_free (id5, typ0, value5) -> Some
        LLVMsyntax.Coq_typ_void
    | LLVMsyntax.Coq_insn_alloca (id5, typ0, value5, align5) -> Some
        (LLVMsyntax.Coq_typ_pointer typ0)
    | LLVMsyntax.Coq_insn_load (id5, typ0, value1, align5) -> Some typ0
    | LLVMsyntax.Coq_insn_store (id5, typ5, value1, value2, align5) -> Some
        LLVMsyntax.Coq_typ_void
    | LLVMsyntax.Coq_insn_gep (id5, inbounds5, typ0, value_5, idxs, typ') ->
        Some (LLVMsyntax.Coq_typ_pointer typ')
    | LLVMsyntax.Coq_insn_trunc (id5, truncop5, typ1, value1, typ0) -> Some
        typ0
    | LLVMsyntax.Coq_insn_ext (id5, extop5, typ1, value5, typ2) -> Some typ2
    | LLVMsyntax.Coq_insn_cast (id5, castop5, typ1, value1, typ0) -> Some
        typ0
    | LLVMsyntax.Coq_insn_select (id5, value0, typ0, value1, value2) -> Some
        typ0
    | LLVMsyntax.Coq_insn_call
        (id5, noret5, clattrs5, rt, varg5, value0, params5) ->
        if noret5 then Some LLVMsyntax.Coq_typ_void else Some rt
    | _ -> Some (LLVMsyntax.Coq_typ_int Size.coq_One)
  
  (** val getTerminatorTyp : LLVMsyntax.terminator -> LLVMsyntax.typ **)
  
  let getTerminatorTyp = function
    | LLVMsyntax.Coq_insn_return (id5, typ0, value5) -> typ0
    | _ -> LLVMsyntax.Coq_typ_void
  
  (** val getPhiNodeTyp : LLVMsyntax.phinode -> LLVMsyntax.typ **)
  
  let getPhiNodeTyp = function
    | LLVMsyntax.Coq_insn_phi (id5, typ0, l0) -> typ0
  
  (** val getInsnTyp : LLVMsyntax.insn -> LLVMsyntax.typ option **)
  
  let getInsnTyp = function
    | LLVMsyntax.Coq_insn_phinode p -> Some (getPhiNodeTyp p)
    | LLVMsyntax.Coq_insn_cmd c -> getCmdTyp c
    | LLVMsyntax.Coq_insn_terminator t -> Some (getTerminatorTyp t)
  
  (** val getPointerEltTyp : LLVMsyntax.typ -> LLVMsyntax.typ option **)
  
  let getPointerEltTyp = function
    | LLVMsyntax.Coq_typ_pointer t' -> Some t'
    | _ -> None
  
  (** val getValueIDs : LLVMsyntax.value -> LLVMsyntax.ids **)
  
  let getValueIDs v =
    match getValueID v with
      | Some id0 -> id0::[]
      | None -> []
  
  (** val values2ids : LLVMsyntax.value list -> LLVMsyntax.ids **)
  
  let rec values2ids = function
    | [] -> []
    | v::vs' ->
        (match v with
           | LLVMsyntax.Coq_value_id id0 -> id0::(values2ids vs')
           | LLVMsyntax.Coq_value_const const5 -> values2ids vs')
  
  (** val getParamsOperand : LLVMsyntax.params -> LLVMsyntax.ids **)
  
  let getParamsOperand lp =
    let l0,vs = split lp in values2ids vs
  
  (** val list_prj1 : ('a1*'a2) list -> 'a1 list **)
  
  let rec list_prj1 = function
    | [] -> []
    | p::ls' -> let x,y = p in x::(list_prj1 ls')
  
  (** val list_prj2 : ('a1*'a2) list -> 'a2 list **)
  
  let rec list_prj2 = function
    | [] -> []
    | p::ls' -> let x,y = p in y::(list_prj2 ls')
  
  (** val getCmdOperands : LLVMsyntax.cmd -> LLVMsyntax.ids **)
  
  let getCmdOperands = function
    | LLVMsyntax.Coq_insn_bop (id5, bop5, sz5, v1, v2) ->
        app (getValueIDs v1) (getValueIDs v2)
    | LLVMsyntax.Coq_insn_fbop (id5, fbop5, floating_point5, v1, v2) ->
        app (getValueIDs v1) (getValueIDs v2)
    | LLVMsyntax.Coq_insn_extractvalue (id5, typ5, v, l0, typ') ->
        getValueIDs v
    | LLVMsyntax.Coq_insn_insertvalue (id5, typ5, v1, typ', v2, l0) ->
        app (getValueIDs v1) (getValueIDs v2)
    | LLVMsyntax.Coq_insn_malloc (id5, typ5, v, align5) -> getValueIDs v
    | LLVMsyntax.Coq_insn_free (id5, typ5, v) -> getValueIDs v
    | LLVMsyntax.Coq_insn_alloca (id5, typ5, v, align5) -> getValueIDs v
    | LLVMsyntax.Coq_insn_load (id5, typ5, v, align5) -> getValueIDs v
    | LLVMsyntax.Coq_insn_store (id5, typ5, v1, v2, align5) ->
        app (getValueIDs v1) (getValueIDs v2)
    | LLVMsyntax.Coq_insn_gep (id5, inbounds5, typ5, v, vs, typ') ->
        app (getValueIDs v) (values2ids (map snd vs))
    | LLVMsyntax.Coq_insn_trunc (id5, truncop5, typ1, v, typ2) ->
        getValueIDs v
    | LLVMsyntax.Coq_insn_ext (id5, extop5, typ1, v1, typ2) -> getValueIDs v1
    | LLVMsyntax.Coq_insn_cast (id5, castop5, typ1, v, typ2) -> getValueIDs v
    | LLVMsyntax.Coq_insn_icmp (id5, cond5, typ5, v1, v2) ->
        app (getValueIDs v1) (getValueIDs v2)
    | LLVMsyntax.Coq_insn_fcmp (id5, fcond5, floating_point5, v1, v2) ->
        app (getValueIDs v1) (getValueIDs v2)
    | LLVMsyntax.Coq_insn_select (id5, v0, typ5, v1, v2) ->
        app (getValueIDs v0) (app (getValueIDs v1) (getValueIDs v2))
    | LLVMsyntax.Coq_insn_call
        (id5, noret5, clattrs5, typ5, varg5, v0, lp) ->
        app (getValueIDs v0) (getParamsOperand lp)
  
  (** val getTerminatorOperands : LLVMsyntax.terminator -> LLVMsyntax.ids **)
  
  let getTerminatorOperands = function
    | LLVMsyntax.Coq_insn_return (id5, typ5, v) -> getValueIDs v
    | LLVMsyntax.Coq_insn_br (id5, v, l1, l2) -> getValueIDs v
    | _ -> []
  
  (** val getPhiNodeOperands : LLVMsyntax.phinode -> LLVMsyntax.ids **)
  
  let getPhiNodeOperands = function
    | LLVMsyntax.Coq_insn_phi (id5, typ5, ls0) -> values2ids (list_prj1 ls0)
  
  (** val getInsnOperands : LLVMsyntax.insn -> LLVMsyntax.ids **)
  
  let getInsnOperands = function
    | LLVMsyntax.Coq_insn_phinode p -> getPhiNodeOperands p
    | LLVMsyntax.Coq_insn_cmd c -> getCmdOperands c
    | LLVMsyntax.Coq_insn_terminator t -> getTerminatorOperands t
  
  (** val getCmdLabels : LLVMsyntax.cmd -> LLVMsyntax.ls **)
  
  let getCmdLabels i0 =
    []
  
  (** val getTerminatorLabels : LLVMsyntax.terminator -> LLVMsyntax.ls **)
  
  let getTerminatorLabels = function
    | LLVMsyntax.Coq_insn_br (id5, value5, l1, l2) -> l1::(l2::[])
    | LLVMsyntax.Coq_insn_br_uncond (id5, l0) -> l0::[]
    | _ -> []
  
  (** val getPhiNodeLabels : LLVMsyntax.phinode -> LLVMsyntax.ls **)
  
  let getPhiNodeLabels = function
    | LLVMsyntax.Coq_insn_phi (id5, typ5, ls0) -> list_prj2 ls0
  
  (** val getInsnLabels : LLVMsyntax.insn -> LLVMsyntax.ls **)
  
  let getInsnLabels = function
    | LLVMsyntax.Coq_insn_phinode p -> getPhiNodeLabels p
    | LLVMsyntax.Coq_insn_cmd c -> getCmdLabels c
    | LLVMsyntax.Coq_insn_terminator tmn -> getTerminatorLabels tmn
  
  (** val args2Typs : LLVMsyntax.args -> LLVMsyntax.typ list **)
  
  let rec args2Typs = function
    | [] -> []
    | p::la' -> let p0,id0 = p in let t,a = p0 in t::(args2Typs la')
  
  (** val getFheaderTyp : LLVMsyntax.fheader -> LLVMsyntax.typ **)
  
  let getFheaderTyp = function
    | LLVMsyntax.Coq_fheader_intro (fnattrs5, t, id5, la, va) ->
        LLVMsyntax.Coq_typ_function (t, (args2Typs la), va)
  
  (** val getFdecTyp : LLVMsyntax.fdec -> LLVMsyntax.typ **)
  
  let getFdecTyp = function
    | LLVMsyntax.Coq_fdec_intro (fheader0, deckind5) ->
        getFheaderTyp fheader0
  
  (** val getFdefTyp : LLVMsyntax.fdef -> LLVMsyntax.typ **)
  
  let getFdefTyp = function
    | LLVMsyntax.Coq_fdef_intro (fheader0, blocks5) -> getFheaderTyp fheader0
  
  (** val fheaderOfFdef : LLVMsyntax.fdef -> LLVMsyntax.fheader **)
  
  let fheaderOfFdef = function
    | LLVMsyntax.Coq_fdef_intro (fh, blocks5) -> fh
  
  (** val getBindingTyp : LLVMsyntax.id_binding -> LLVMsyntax.typ option **)
  
  let getBindingTyp = function
    | LLVMsyntax.Coq_id_binding_none -> None
    | LLVMsyntax.Coq_id_binding_cmd i0 -> getCmdTyp i0
    | LLVMsyntax.Coq_id_binding_phinode i0 -> Some (getPhiNodeTyp i0)
    | LLVMsyntax.Coq_id_binding_terminator i0 -> Some (getTerminatorTyp i0)
    | LLVMsyntax.Coq_id_binding_gvar gvar5 ->
        (match gvar5 with
           | LLVMsyntax.Coq_gvar_intro
               (id5, linkage5, gvar_spec5, t, const5, align5) -> Some
               (LLVMsyntax.Coq_typ_pointer t)
           | LLVMsyntax.Coq_gvar_external (id5, gvar_spec5, t) -> Some
               (LLVMsyntax.Coq_typ_pointer t))
    | LLVMsyntax.Coq_id_binding_fdec fdec0 -> Some (getFdecTyp fdec0)
    | LLVMsyntax.Coq_id_binding_arg arg5 ->
        let p,id0 = arg5 in let t,a = p in Some t
  
  (** val getCmdsFromBlock : LLVMsyntax.block -> LLVMsyntax.cmds **)
  
  let getCmdsFromBlock = function
    | LLVMsyntax.Coq_block_intro (l0, phinodes5, li, terminator5) -> li
  
  (** val getPhiNodesFromBlock : LLVMsyntax.block -> LLVMsyntax.phinodes **)
  
  let getPhiNodesFromBlock = function
    | LLVMsyntax.Coq_block_intro (l0, li, cmds5, terminator5) -> li
  
  (** val getTerminatorFromBlock :
      LLVMsyntax.block -> LLVMsyntax.terminator **)
  
  let getTerminatorFromBlock = function
    | LLVMsyntax.Coq_block_intro (l0, phinodes5, cmds5, t) -> t
  
  (** val getFheaderID : LLVMsyntax.fheader -> LLVMsyntax.id **)
  
  let getFheaderID = function
    | LLVMsyntax.Coq_fheader_intro (fnattrs5, typ5, id0, args5, varg5) -> id0
  
  (** val getFdecID : LLVMsyntax.fdec -> LLVMsyntax.id **)
  
  let getFdecID = function
    | LLVMsyntax.Coq_fdec_intro (fh, deckind5) -> getFheaderID fh
  
  (** val getFdefID : LLVMsyntax.fdef -> LLVMsyntax.id **)
  
  let getFdefID = function
    | LLVMsyntax.Coq_fdef_intro (fh, blocks5) -> getFheaderID fh
  
  (** val getLabelViaIDFromList :
      (LLVMsyntax.value*LLVMsyntax.l) list -> LLVMsyntax.id -> LLVMsyntax.l
      option **)
  
  let rec getLabelViaIDFromList ls0 branch =
    match ls0 with
      | [] -> None
      | p::ls' ->
          let v,l0 = p in
          (match v with
             | LLVMsyntax.Coq_value_id id0 ->
                 if eq_dec (coq_EqDec_eq_of_EqDec coq_EqDec_atom) id0 branch
                 then Some l0
                 else getLabelViaIDFromList ls' branch
             | LLVMsyntax.Coq_value_const const5 ->
                 getLabelViaIDFromList ls' branch)
  
  (** val getLabelViaIDFromPhiNode :
      LLVMsyntax.phinode -> LLVMsyntax.id -> LLVMsyntax.l option **)
  
  let getLabelViaIDFromPhiNode phi branch =
    let LLVMsyntax.Coq_insn_phi (id5, typ5, ls0) = phi in
    getLabelViaIDFromList ls0 branch
  
  (** val getLabelsFromIdls :
      (LLVMsyntax.value*LLVMsyntax.l) list -> LLVMsyntax.ls **)
  
  let rec getLabelsFromIdls = function
    | [] -> lempty_set
    | p::idls' -> let v,l0 = p in lset_add l0 (getLabelsFromIdls idls')
  
  (** val getLabelsFromPhiNode : LLVMsyntax.phinode -> LLVMsyntax.ls **)
  
  let getLabelsFromPhiNode = function
    | LLVMsyntax.Coq_insn_phi (id5, typ5, ls0) -> getLabelsFromIdls ls0
  
  (** val getLabelsFromPhiNodes :
      LLVMsyntax.phinode list -> LLVMsyntax.ls **)
  
  let rec getLabelsFromPhiNodes = function
    | [] -> lempty_set
    | phi::phis' ->
        lset_union (getLabelsFromPhiNode phi) (getLabelsFromPhiNodes phis')
  
  (** val getIDLabelsFromPhiNode :
      LLVMsyntax.phinode -> (LLVMsyntax.value*LLVMsyntax.l) list **)
  
  let getIDLabelsFromPhiNode = function
    | LLVMsyntax.Coq_insn_phi (id5, typ5, idls) -> idls
  
  (** val getLabelViaIDFromIDLabels :
      (LLVMsyntax.value*LLVMsyntax.l) list -> LLVMsyntax.id -> LLVMsyntax.l
      option **)
  
  let rec getLabelViaIDFromIDLabels idls id0 =
    match idls with
      | [] -> None
      | y::idls' ->
          let y0,l0 = y in
          (match y0 with
             | LLVMsyntax.Coq_value_id id1 ->
                 if eq_dec (coq_EqDec_eq_of_EqDec coq_EqDec_atom) id0 id1
                 then Some l0
                 else getLabelViaIDFromIDLabels idls' id0
             | LLVMsyntax.Coq_value_const const5 ->
                 getLabelViaIDFromIDLabels idls' id0)
  
  (** val _getLabelViaIDPhiNode :
      LLVMsyntax.phinode -> LLVMsyntax.id -> LLVMsyntax.l option **)
  
  let _getLabelViaIDPhiNode p id0 =
    let LLVMsyntax.Coq_insn_phi (id5, typ5, ls0) = p in
    getLabelViaIDFromIDLabels ls0 id0
  
  (** val getLabelViaIDPhiNode :
      LLVMsyntax.insn -> LLVMsyntax.id -> LLVMsyntax.l option **)
  
  let getLabelViaIDPhiNode phi id0 =
    match phi with
      | LLVMsyntax.Coq_insn_phinode p -> _getLabelViaIDPhiNode p id0
      | _ -> None
  
  (** val getReturnTyp : LLVMsyntax.fdef -> LLVMsyntax.typ **)
  
  let getReturnTyp = function
    | LLVMsyntax.Coq_fdef_intro (fheader5, blocks5) ->
        let LLVMsyntax.Coq_fheader_intro (fnattrs5, t, id5, args5, varg5) =
          fheader5
        in
        t
  
  (** val getGvarID : LLVMsyntax.gvar -> LLVMsyntax.id **)
  
  let getGvarID = function
    | LLVMsyntax.Coq_gvar_intro
        (id0, linkage5, gvar_spec5, typ5, const5, align5) -> id0
    | LLVMsyntax.Coq_gvar_external (id0, gvar_spec5, typ5) -> id0
  
  (** val getCalledValue : LLVMsyntax.insn -> LLVMsyntax.value option **)
  
  let getCalledValue = function
    | LLVMsyntax.Coq_insn_cmd cmd5 ->
        (match cmd5 with
           | LLVMsyntax.Coq_insn_call
               (id5, noret5, clattrs5, typ5, varg5, v0, params5) -> Some v0
           | _ -> None)
    | _ -> None
  
  (** val getCalledValueID : LLVMsyntax.insn -> LLVMsyntax.id option **)
  
  let getCalledValueID i0 =
    match getCalledValue i0 with
      | Some v -> getValueID v
      | None -> None
  
  (** val getCallerReturnID : LLVMsyntax.cmd -> LLVMsyntax.id option **)
  
  let getCallerReturnID = function
    | LLVMsyntax.Coq_insn_call
        (fid, noret5, clattrs5, typ5, varg5, value0, params5) ->
        if noret5 then None else Some fid
    | _ -> None
  
  (** val getValueViaLabelFromValuels :
      (LLVMsyntax.value*LLVMsyntax.l) list -> LLVMsyntax.l ->
      LLVMsyntax.value option **)
  
  let rec getValueViaLabelFromValuels vls l0 =
    match vls with
      | [] -> None
      | p::vls' ->
          let v,l1 = p in
          if eq_dec (coq_EqDec_eq_of_EqDec coq_EqDec_atom) l1 l0
          then Some v
          else getValueViaLabelFromValuels vls' l0
  
  (** val getValueViaBlockFromValuels :
      (LLVMsyntax.value*LLVMsyntax.l) list -> LLVMsyntax.block ->
      LLVMsyntax.value option **)
  
  let getValueViaBlockFromValuels vls = function
    | LLVMsyntax.Coq_block_intro (l0, phinodes5, cmds5, terminator5) ->
        getValueViaLabelFromValuels vls l0
  
  (** val getValueViaBlockFromPHINode :
      LLVMsyntax.phinode -> LLVMsyntax.block -> LLVMsyntax.value option **)
  
  let getValueViaBlockFromPHINode i0 b =
    let LLVMsyntax.Coq_insn_phi (id5, typ5, vls) = i0 in
    getValueViaBlockFromValuels vls b
  
  (** val getPHINodesFromBlock :
      LLVMsyntax.block -> LLVMsyntax.phinode list **)
  
  let getPHINodesFromBlock = function
    | LLVMsyntax.Coq_block_intro (l5, lp, cmds5, terminator5) -> lp
  
  (** val getEntryBlock : LLVMsyntax.fdef -> LLVMsyntax.block option **)
  
  let getEntryBlock = function
    | LLVMsyntax.Coq_fdef_intro (fheader5, blocks5) ->
        (match blocks5 with
           | [] -> None
           | b::l0 -> Some b)
  
  (** val getEntryLabel : LLVMsyntax.fdef -> LLVMsyntax.l option **)
  
  let getEntryLabel = function
    | LLVMsyntax.Coq_fdef_intro (fheader5, blocks5) ->
        (match blocks5 with
           | [] -> None
           | b::l0 ->
               let LLVMsyntax.Coq_block_intro
                 (l1, phinodes5, cmds5, terminator5) = b
               in
               Some l1)
  
  (** val getEntryCmds : LLVMsyntax.block -> LLVMsyntax.cmds **)
  
  let getEntryCmds = function
    | LLVMsyntax.Coq_block_intro (l5, phinodes5, lc, terminator5) -> lc
  
  (** val floating_point_order :
      LLVMsyntax.floating_point -> LLVMsyntax.floating_point -> bool **)
  
  let floating_point_order fp1 fp2 =
    match fp1 with
      | LLVMsyntax.Coq_fp_float ->
          (match fp2 with
             | LLVMsyntax.Coq_fp_float -> false
             | _ -> true)
      | LLVMsyntax.Coq_fp_double ->
          (match fp2 with
             | LLVMsyntax.Coq_fp_float -> false
             | LLVMsyntax.Coq_fp_double -> false
             | _ -> true)
      | LLVMsyntax.Coq_fp_x86_fp80 ->
          (match fp2 with
             | LLVMsyntax.Coq_fp_fp128 -> true
             | LLVMsyntax.Coq_fp_ppc_fp128 -> true
             | _ -> false)
      | _ -> false
  
  (** val wf_fcond : LLVMsyntax.fcond -> bool **)
  
  let wf_fcond = function
    | LLVMsyntax.Coq_fcond_ord -> false
    | LLVMsyntax.Coq_fcond_uno -> false
    | _ -> true
  
  (** val lookupCmdViaIDFromCmds :
      LLVMsyntax.cmds -> LLVMsyntax.id -> LLVMsyntax.cmd option **)
  
  let rec lookupCmdViaIDFromCmds li id0 =
    match li with
      | [] -> None
      | i0::li' ->
          if AtomImpl.eq_atom_dec id0 (getCmdLoc i0)
          then Some i0
          else lookupCmdViaIDFromCmds li' id0
  
  (** val lookupPhiNodeViaIDFromPhiNodes :
      LLVMsyntax.phinodes -> LLVMsyntax.id -> LLVMsyntax.phinode option **)
  
  let rec lookupPhiNodeViaIDFromPhiNodes li id0 =
    match li with
      | [] -> None
      | i0::li' ->
          if eq_dec (coq_EqDec_eq_of_EqDec coq_EqDec_atom) 
               (getPhiNodeID i0) id0
          then Some i0
          else lookupPhiNodeViaIDFromPhiNodes li' id0
  
  (** val lookupInsnViaIDFromBlock :
      LLVMsyntax.block -> LLVMsyntax.id -> LLVMsyntax.insn option **)
  
  let lookupInsnViaIDFromBlock b id0 =
    let LLVMsyntax.Coq_block_intro (l5, ps, cs, t) = b in
    (match lookupPhiNodeViaIDFromPhiNodes ps id0 with
       | Some re -> Some (LLVMsyntax.Coq_insn_phinode re)
       | None ->
           (match lookupCmdViaIDFromCmds cs id0 with
              | Some c -> Some (LLVMsyntax.Coq_insn_cmd c)
              | None ->
                  if eq_dec (coq_EqDec_eq_of_EqDec coq_EqDec_atom)
                       (getTerminatorID t) id0
                  then Some (LLVMsyntax.Coq_insn_terminator t)
                  else None))
  
  (** val lookupInsnViaIDFromBlocks :
      LLVMsyntax.blocks -> LLVMsyntax.id -> LLVMsyntax.insn option **)
  
  let rec lookupInsnViaIDFromBlocks lb id0 =
    match lb with
      | [] -> None
      | b::lb' ->
          (match lookupInsnViaIDFromBlock b id0 with
             | Some i0 -> Some i0
             | None -> lookupInsnViaIDFromBlocks lb' id0)
  
  (** val lookupInsnViaIDFromFdef :
      LLVMsyntax.fdef -> LLVMsyntax.id -> LLVMsyntax.insn option **)
  
  let lookupInsnViaIDFromFdef f id0 =
    let LLVMsyntax.Coq_fdef_intro (fheader5, bs) = f in
    lookupInsnViaIDFromBlocks bs id0
  
  (** val lookupArgViaIDFromArgs :
      LLVMsyntax.args -> LLVMsyntax.id -> LLVMsyntax.arg option **)
  
  let rec lookupArgViaIDFromArgs la id0 =
    match la with
      | [] -> None
      | p::la' ->
          let p0,id' = p in
          if eq_dec (coq_EqDec_eq_of_EqDec coq_EqDec_atom) id' id0
          then Some (p0,id')
          else lookupArgViaIDFromArgs la' id0
  
  (** val getCmdsLocs : LLVMsyntax.cmd list -> LLVMsyntax.ids **)
  
  let rec getCmdsLocs = function
    | [] -> []
    | c::cs' -> (getCmdLoc c)::(getCmdsLocs cs')
  
  (** val getBlockLocs : LLVMsyntax.block -> LLVMsyntax.ids **)
  
  let getBlockLocs = function
    | LLVMsyntax.Coq_block_intro (l0, ps, cs, t) ->
        app (getPhiNodesIDs ps)
          (app (getCmdsLocs cs) ((getTerminatorID t)::[]))
  
  (** val lookupBlockViaIDFromBlocks :
      LLVMsyntax.blocks -> LLVMsyntax.id -> LLVMsyntax.block option **)
  
  let rec lookupBlockViaIDFromBlocks lb id1 =
    match lb with
      | [] -> None
      | b::lb' ->
          if in_dec (eq_dec (coq_EqDec_eq_of_EqDec coq_EqDec_atom)) id1
               (getBlockIDs b)
          then Some b
          else lookupBlockViaIDFromBlocks lb' id1
  
  (** val lookupBlockViaIDFromFdef :
      LLVMsyntax.fdef -> LLVMsyntax.id -> LLVMsyntax.block option **)
  
  let lookupBlockViaIDFromFdef fd id0 =
    let LLVMsyntax.Coq_fdef_intro (fh, lb) = fd in
    lookupBlockViaIDFromBlocks lb id0
  
  (** val lookupFdecViaIDFromProduct :
      LLVMsyntax.product -> LLVMsyntax.id -> LLVMsyntax.fdec option **)
  
  let lookupFdecViaIDFromProduct p i0 =
    match p with
      | LLVMsyntax.Coq_product_fdec fd ->
          if eq_dec (coq_EqDec_eq_of_EqDec coq_EqDec_atom) (getFdecID fd) i0
          then Some fd
          else None
      | _ -> None
  
  (** val lookupFdecViaIDFromProducts :
      LLVMsyntax.products -> LLVMsyntax.id -> LLVMsyntax.fdec option **)
  
  let rec lookupFdecViaIDFromProducts lp i0 =
    match lp with
      | [] -> None
      | p::lp' ->
          (match lookupFdecViaIDFromProduct p i0 with
             | Some fd -> Some fd
             | None -> lookupFdecViaIDFromProducts lp' i0)
  
  (** val lookupFdecViaIDFromModule :
      LLVMsyntax.coq_module -> LLVMsyntax.id -> LLVMsyntax.fdec option **)
  
  let lookupFdecViaIDFromModule m i0 =
    let LLVMsyntax.Coq_module_intro (os, dts, ps) = m in
    lookupFdecViaIDFromProducts ps i0
  
  (** val lookupFdecViaIDFromModules :
      LLVMsyntax.modules -> LLVMsyntax.id -> LLVMsyntax.fdec option **)
  
  let rec lookupFdecViaIDFromModules lm i0 =
    match lm with
      | [] -> None
      | m::lm' ->
          (match lookupFdecViaIDFromModule m i0 with
             | Some fd -> Some fd
             | None -> lookupFdecViaIDFromModules lm' i0)
  
  (** val lookupFdecViaIDFromSystem :
      LLVMsyntax.system -> LLVMsyntax.id -> LLVMsyntax.fdec option **)
  
  let lookupFdecViaIDFromSystem s i0 =
    lookupFdecViaIDFromModules s i0
  
  (** val lookupFdefViaIDFromProduct :
      LLVMsyntax.product -> LLVMsyntax.id -> LLVMsyntax.fdef option **)
  
  let lookupFdefViaIDFromProduct p i0 =
    match p with
      | LLVMsyntax.Coq_product_fdef fd ->
          if eq_dec (coq_EqDec_eq_of_EqDec coq_EqDec_atom) (getFdefID fd) i0
          then Some fd
          else None
      | _ -> None
  
  (** val lookupFdefViaIDFromProducts :
      LLVMsyntax.products -> LLVMsyntax.id -> LLVMsyntax.fdef option **)
  
  let rec lookupFdefViaIDFromProducts lp i0 =
    match lp with
      | [] -> None
      | p::lp' ->
          (match lookupFdefViaIDFromProduct p i0 with
             | Some fd -> Some fd
             | None -> lookupFdefViaIDFromProducts lp' i0)
  
  (** val lookupFdefViaIDFromModule :
      LLVMsyntax.coq_module -> LLVMsyntax.id -> LLVMsyntax.fdef option **)
  
  let lookupFdefViaIDFromModule m i0 =
    let LLVMsyntax.Coq_module_intro (os, dts, ps) = m in
    lookupFdefViaIDFromProducts ps i0
  
  (** val lookupFdefViaIDFromModules :
      LLVMsyntax.modules -> LLVMsyntax.id -> LLVMsyntax.fdef option **)
  
  let rec lookupFdefViaIDFromModules lm i0 =
    match lm with
      | [] -> None
      | m::lm' ->
          (match lookupFdefViaIDFromModule m i0 with
             | Some fd -> Some fd
             | None -> lookupFdefViaIDFromModules lm' i0)
  
  (** val lookupFdefViaIDFromSystem :
      LLVMsyntax.system -> LLVMsyntax.id -> LLVMsyntax.fdef option **)
  
  let lookupFdefViaIDFromSystem s i0 =
    lookupFdefViaIDFromModules s i0
  
  (** val lookupTypViaIDFromCmd :
      LLVMsyntax.cmd -> LLVMsyntax.id -> LLVMsyntax.typ option **)
  
  let lookupTypViaIDFromCmd i0 id0 =
    match getCmdTyp i0 with
      | Some t ->
          if eq_dec (coq_EqDec_eq_of_EqDec coq_EqDec_atom) id0 (getCmdLoc i0)
          then Some t
          else None
      | None -> None
  
  (** val lookupTypViaIDFromCmds :
      LLVMsyntax.cmds -> LLVMsyntax.id -> LLVMsyntax.typ option **)
  
  let rec lookupTypViaIDFromCmds li id0 =
    match li with
      | [] -> None
      | i0::li' ->
          (match lookupTypViaIDFromCmd i0 id0 with
             | Some t -> Some t
             | None -> lookupTypViaIDFromCmds li' id0)
  
  (** val lookupTypViaIDFromPhiNode :
      LLVMsyntax.phinode -> LLVMsyntax.id -> LLVMsyntax.typ option **)
  
  let lookupTypViaIDFromPhiNode i0 id0 =
    if eq_dec (coq_EqDec_eq_of_EqDec coq_EqDec_atom) id0 (getPhiNodeID i0)
    then Some (getPhiNodeTyp i0)
    else None
  
  (** val lookupTypViaIDFromPhiNodes :
      LLVMsyntax.phinodes -> LLVMsyntax.id -> LLVMsyntax.typ option **)
  
  let rec lookupTypViaIDFromPhiNodes li id0 =
    match li with
      | [] -> None
      | i0::li' ->
          (match lookupTypViaIDFromPhiNode i0 id0 with
             | Some t -> Some t
             | None -> lookupTypViaIDFromPhiNodes li' id0)
  
  (** val lookupTypViaIDFromTerminator :
      LLVMsyntax.terminator -> LLVMsyntax.id -> LLVMsyntax.typ option **)
  
  let lookupTypViaIDFromTerminator i0 id0 =
    if eq_dec (coq_EqDec_eq_of_EqDec coq_EqDec_atom) id0 (getTerminatorID i0)
    then Some (getTerminatorTyp i0)
    else None
  
  (** val lookupTypViaIDFromBlock :
      LLVMsyntax.block -> LLVMsyntax.id -> LLVMsyntax.typ option **)
  
  let lookupTypViaIDFromBlock b id0 =
    let LLVMsyntax.Coq_block_intro (l0, ps, cs, t) = b in
    (match lookupTypViaIDFromPhiNodes ps id0 with
       | Some t0 -> Some t0
       | None ->
           (match lookupTypViaIDFromCmds cs id0 with
              | Some t0 -> Some t0
              | None -> lookupTypViaIDFromTerminator t id0))
  
  (** val lookupTypViaIDFromBlocks :
      LLVMsyntax.blocks -> LLVMsyntax.id -> LLVMsyntax.typ option **)
  
  let rec lookupTypViaIDFromBlocks lb id0 =
    match lb with
      | [] -> None
      | b::lb' ->
          (match lookupTypViaIDFromBlock b id0 with
             | Some t -> Some t
             | None -> lookupTypViaIDFromBlocks lb' id0)
  
  (** val lookupTypViaIDFromArgs :
      LLVMsyntax.args -> LLVMsyntax.id -> LLVMsyntax.typ option **)
  
  let rec lookupTypViaIDFromArgs la id0 =
    match la with
      | [] -> None
      | p::la' ->
          let p0,id1 = p in
          let t1,a = p0 in
          if eq_dec (coq_EqDec_eq_of_EqDec coq_EqDec_atom) id0 id1
          then Some t1
          else lookupTypViaIDFromArgs la' id0
  
  (** val lookupTypViaIDFromFdef :
      LLVMsyntax.fdef -> LLVMsyntax.id -> LLVMsyntax.typ option **)
  
  let lookupTypViaIDFromFdef fd id0 =
    let LLVMsyntax.Coq_fdef_intro (fheader5, lb) = fd in
    let LLVMsyntax.Coq_fheader_intro (fnattrs5, typ5, id5, la, varg5) =
      fheader5
    in
    (match lookupTypViaIDFromArgs la id0 with
       | Some t -> Some t
       | None -> lookupTypViaIDFromBlocks lb id0)
  
  (** val lookupTypViaGIDFromProduct :
      LLVMsyntax.product -> LLVMsyntax.id -> LLVMsyntax.typ option **)
  
  let lookupTypViaGIDFromProduct p id0 =
    match p with
      | LLVMsyntax.Coq_product_gvar gvar5 ->
          (match gvar5 with
             | LLVMsyntax.Coq_gvar_intro
                 (id1, linkage5, spec, t, const5, align5) ->
                 if eq_dec (coq_EqDec_eq_of_EqDec coq_EqDec_atom) id0 id1
                 then Some t
                 else None
             | LLVMsyntax.Coq_gvar_external (id1, spec, t) ->
                 if eq_dec (coq_EqDec_eq_of_EqDec coq_EqDec_atom) id0 id1
                 then Some t
                 else None)
      | LLVMsyntax.Coq_product_fdec fc -> Some (getFdecTyp fc)
      | LLVMsyntax.Coq_product_fdef fd -> Some (getFdefTyp fd)
  
  (** val lookupTypViaGIDFromProducts :
      LLVMsyntax.products -> LLVMsyntax.id -> LLVMsyntax.typ option **)
  
  let rec lookupTypViaGIDFromProducts lp id0 =
    match lp with
      | [] -> None
      | p::lp' ->
          (match lookupTypViaGIDFromProduct p id0 with
             | Some t -> Some t
             | None -> lookupTypViaGIDFromProducts lp' id0)
  
  (** val lookupTypViaGIDFromModule :
      LLVMsyntax.coq_module -> LLVMsyntax.id -> LLVMsyntax.typ option **)
  
  let lookupTypViaGIDFromModule m id0 =
    let LLVMsyntax.Coq_module_intro (os, dts, ps) = m in
    lookupTypViaGIDFromProducts ps id0
  
  (** val lookupTypViaGIDFromModules :
      LLVMsyntax.modules -> LLVMsyntax.id -> LLVMsyntax.typ option **)
  
  let rec lookupTypViaGIDFromModules lm id0 =
    match lm with
      | [] -> None
      | m::lm' ->
          (match lookupTypViaGIDFromModule m id0 with
             | Some t -> Some t
             | None -> lookupTypViaGIDFromModules lm' id0)
  
  (** val lookupTypViaGIDFromSystem :
      LLVMsyntax.system -> LLVMsyntax.id -> LLVMsyntax.typ option **)
  
  let lookupTypViaGIDFromSystem s id0 =
    lookupTypViaGIDFromModules s id0
  
  (** val lookupTypViaTIDFromNamedts :
      LLVMsyntax.namedts -> LLVMsyntax.id -> LLVMsyntax.typ option **)
  
  let rec lookupTypViaTIDFromNamedts nts id0 =
    match nts with
      | [] -> None
      | n::nts' ->
          let id1,typ1 = n in
          if eq_dec (coq_EqDec_eq_of_EqDec coq_EqDec_atom) id0 id1
          then Some (LLVMsyntax.Coq_typ_struct typ1)
          else lookupTypViaTIDFromNamedts nts' id0
  
  (** val lookupTypViaTIDFromModule :
      LLVMsyntax.coq_module -> LLVMsyntax.id -> LLVMsyntax.typ option **)
  
  let lookupTypViaTIDFromModule m id0 =
    let LLVMsyntax.Coq_module_intro (os, dts, ps) = m in
    lookupTypViaTIDFromNamedts dts id0
  
  (** val lookupTypViaTIDFromModules :
      LLVMsyntax.modules -> LLVMsyntax.id -> LLVMsyntax.typ option **)
  
  let rec lookupTypViaTIDFromModules lm id0 =
    match lm with
      | [] -> None
      | m::lm' ->
          (match lookupTypViaTIDFromModule m id0 with
             | Some t -> Some t
             | None -> lookupTypViaTIDFromModules lm' id0)
  
  (** val lookupTypViaTIDFromSystem :
      LLVMsyntax.system -> LLVMsyntax.id -> LLVMsyntax.typ option **)
  
  let lookupTypViaTIDFromSystem s id0 =
    lookupTypViaTIDFromModules s id0
  
  type l2block = (LLVMsyntax.l*LLVMsyntax.block) list
  
  (** val genLabel2Block_block : LLVMsyntax.block -> l2block **)
  
  let genLabel2Block_block b = match b with
    | LLVMsyntax.Coq_block_intro (l0, phinodes5, cmds5, terminator5) ->
        (l0,b)::[]
  
  (** val genLabel2Block_blocks : LLVMsyntax.blocks -> l2block **)
  
  let rec genLabel2Block_blocks = function
    | [] -> []
    | b::bs' -> app (genLabel2Block_block b) (genLabel2Block_blocks bs')
  
  (** val genLabel2Block_fdef : LLVMsyntax.fdef -> l2block **)
  
  let genLabel2Block_fdef = function
    | LLVMsyntax.Coq_fdef_intro (fheader0, blocks0) ->
        genLabel2Block_blocks blocks0
  
  (** val genLabel2Block_product : LLVMsyntax.product -> l2block **)
  
  let rec genLabel2Block_product = function
    | LLVMsyntax.Coq_product_fdef f -> genLabel2Block_fdef f
    | _ -> []
  
  (** val genLabel2Block_products : LLVMsyntax.products -> l2block **)
  
  let rec genLabel2Block_products = function
    | [] -> []
    | p::ps' -> app (genLabel2Block_product p) (genLabel2Block_products ps')
  
  (** val genLabel2Block : LLVMsyntax.coq_module -> l2block **)
  
  let genLabel2Block = function
    | LLVMsyntax.Coq_module_intro (os, dts, ps) -> genLabel2Block_products ps
  
  (** val getNonEntryOfFdef : LLVMsyntax.fdef -> LLVMsyntax.blocks **)
  
  let getNonEntryOfFdef = function
    | LLVMsyntax.Coq_fdef_intro (fheader0, blocks0) ->
        (match blocks0 with
           | [] -> []
           | b::blocks' -> blocks')
  
  (** val lookupBlockViaLabelFromBlocks :
      LLVMsyntax.blocks -> LLVMsyntax.l -> LLVMsyntax.block option **)
  
  let lookupBlockViaLabelFromBlocks bs l0 =
    lookupAL (genLabel2Block_blocks bs) l0
  
  (** val lookupBlockViaLabelFromFdef :
      LLVMsyntax.fdef -> LLVMsyntax.l -> LLVMsyntax.block option **)
  
  let lookupBlockViaLabelFromFdef f l0 =
    lookupAL (genLabel2Block_fdef f) l0
  
  (** val getLabelsFromBlocks : LLVMsyntax.blocks -> LLVMsyntax.ls **)
  
  let rec getLabelsFromBlocks = function
    | [] -> lempty_set
    | b::lb' ->
        let LLVMsyntax.Coq_block_intro (l0, phinodes5, cmds5, terminator5) =
          b
        in
        lset_add l0 (getLabelsFromBlocks lb')
  
  (** val update_udb :
      LLVMsyntax.usedef_block -> LLVMsyntax.l -> LLVMsyntax.l ->
      LLVMsyntax.usedef_block **)
  
  let update_udb udb lu ld =
    let ls0 = match lookupAL udb ld with
                | Some ls0 -> ls0
                | None -> [] in
    if in_dec l_dec lu ls0 then udb else updateAddAL udb ld (lu::ls0)
  
  (** val genBlockUseDef_block :
      LLVMsyntax.block -> LLVMsyntax.usedef_block -> LLVMsyntax.usedef_block **)
  
  let genBlockUseDef_block b udb =
    let LLVMsyntax.Coq_block_intro (l0, phinodes5, cmds5, tmn2) = b in
    (match tmn2 with
       | LLVMsyntax.Coq_insn_br (id5, value5, l1, l2) ->
           update_udb (update_udb udb l0 l2) l0 l1
       | LLVMsyntax.Coq_insn_br_uncond (id5, l1) -> update_udb udb l0 l1
       | _ -> udb)
  
  (** val genBlockUseDef_blocks :
      LLVMsyntax.block list -> LLVMsyntax.usedef_block ->
      LLVMsyntax.usedef_block **)
  
  let rec genBlockUseDef_blocks bs udb =
    match bs with
      | [] -> udb
      | b::bs' -> genBlockUseDef_blocks bs' (genBlockUseDef_block b udb)
  
  (** val genBlockUseDef_fdef :
      LLVMsyntax.fdef -> LLVMsyntax.usedef_block **)
  
  let genBlockUseDef_fdef = function
    | LLVMsyntax.Coq_fdef_intro (fheader5, lb2) ->
        genBlockUseDef_blocks lb2 []
  
  (** val getBlockLabel : LLVMsyntax.block -> LLVMsyntax.l **)
  
  let getBlockLabel = function
    | LLVMsyntax.Coq_block_intro (l0, phinodes5, cmds5, terminator5) -> l0
  
  (** val getBlockTmn : LLVMsyntax.block -> LLVMsyntax.terminator **)
  
  let getBlockTmn = function
    | LLVMsyntax.Coq_block_intro (l5, phinodes5, cmds5, tmn) -> tmn
  
  (** val getBlockUseDef :
      LLVMsyntax.usedef_block -> LLVMsyntax.block -> LLVMsyntax.l list option **)
  
  let getBlockUseDef udb b =
    lookupAL udb (getBlockLabel b)
  
  (** val getTerminator : LLVMsyntax.block -> LLVMsyntax.terminator **)
  
  let getTerminator = function
    | LLVMsyntax.Coq_block_intro (l0, phinodes5, cmds5, t) -> t
  
  (** val getLabelsFromSwitchCases :
      (LLVMsyntax.const*LLVMsyntax.l) list -> LLVMsyntax.ls **)
  
  let rec getLabelsFromSwitchCases = function
    | [] -> lempty_set
    | p::cs' -> let c,l0 = p in lset_add l0 (getLabelsFromSwitchCases cs')
  
  (** val getLabelsFromTerminator :
      LLVMsyntax.terminator -> LLVMsyntax.ls **)
  
  let getLabelsFromTerminator = function
    | LLVMsyntax.Coq_insn_br (id5, v, l1, l2) ->
        lset_add l1 (lset_add l2 lempty_set)
    | LLVMsyntax.Coq_insn_br_uncond (id5, l0) -> lset_add l0 lempty_set
    | _ -> empty_set
  
  (** val getBlocksFromLabels :
      LLVMsyntax.ls -> l2block -> LLVMsyntax.blocks **)
  
  let rec getBlocksFromLabels ls0 l2b =
    match ls0 with
      | [] -> []
      | l0::ls0' ->
          (match lookupAL l2b l0 with
             | Some b -> b::(getBlocksFromLabels ls0' l2b)
             | None -> getBlocksFromLabels ls0' l2b)
  
  (** val succOfBlock :
      LLVMsyntax.block -> LLVMsyntax.coq_module -> LLVMsyntax.blocks **)
  
  let succOfBlock b m =
    getBlocksFromLabels (getLabelsFromTerminator (getTerminator b))
      (genLabel2Block m)
  
  (** val predOfBlock :
      LLVMsyntax.block -> LLVMsyntax.usedef_block -> LLVMsyntax.l list **)
  
  let predOfBlock b udb =
    match lookupAL udb (getBlockLabel b) with
      | Some re -> re
      | None -> []
  
  (** val hasSinglePredecessor :
      LLVMsyntax.block -> LLVMsyntax.usedef_block -> bool **)
  
  let hasSinglePredecessor b udb =
    match predOfBlock b udb with
      | [] -> false
      | l0::l1 -> (match l1 with
                     | [] -> true
                     | l2::l3 -> false)
  
  (** val hasNonePredecessor :
      LLVMsyntax.block -> LLVMsyntax.usedef_block -> bool **)
  
  let hasNonePredecessor b udb =
    match predOfBlock b udb with
      | [] -> true
      | l0::l1 -> false
  
  (** val successors_terminator : LLVMsyntax.terminator -> LLVMsyntax.ls **)
  
  let successors_terminator = function
    | LLVMsyntax.Coq_insn_br (id5, value5, l1, l2) -> l1::(l2::[])
    | LLVMsyntax.Coq_insn_br_uncond (id5, l1) -> l1::[]
    | _ -> []
  
  (** val isPointerTypB : LLVMsyntax.typ -> bool **)
  
  let isPointerTypB = function
    | LLVMsyntax.Coq_typ_pointer typ5 -> true
    | _ -> false
  
  (** val isFunctionPointerTypB : LLVMsyntax.typ -> bool **)
  
  let isFunctionPointerTypB = function
    | LLVMsyntax.Coq_typ_pointer typ5 ->
        (match typ5 with
           | LLVMsyntax.Coq_typ_function (typ_5, l0, varg5) -> true
           | _ -> false)
    | _ -> false
  
  (** val isArrayTypB : LLVMsyntax.typ -> bool **)
  
  let isArrayTypB = function
    | LLVMsyntax.Coq_typ_array (sz5, typ5) -> true
    | _ -> false
  
  (** val isReturnInsnB : LLVMsyntax.terminator -> bool **)
  
  let isReturnInsnB = function
    | LLVMsyntax.Coq_insn_return (id5, typ5, value5) -> true
    | LLVMsyntax.Coq_insn_return_void id5 -> true
    | _ -> false
  
  (** val _isCallInsnB : LLVMsyntax.cmd -> bool **)
  
  let _isCallInsnB = function
    | LLVMsyntax.Coq_insn_call
        (id5, noret5, clattrs5, typ5, varg5, value0, params5) -> true
    | _ -> false
  
  (** val isCallInsnB : LLVMsyntax.insn -> bool **)
  
  let isCallInsnB = function
    | LLVMsyntax.Coq_insn_cmd c -> _isCallInsnB c
    | _ -> false
  
  (** val isNotValidReturnTypB : LLVMsyntax.typ -> bool **)
  
  let isNotValidReturnTypB = function
    | LLVMsyntax.Coq_typ_label -> true
    | LLVMsyntax.Coq_typ_metadata -> true
    | _ -> false
  
  (** val isValidReturnTypB : LLVMsyntax.typ -> bool **)
  
  let isValidReturnTypB t =
    negb (isNotValidReturnTypB t)
  
  (** val isNotFirstClassTypB : LLVMsyntax.typ -> bool **)
  
  let isNotFirstClassTypB = function
    | LLVMsyntax.Coq_typ_void -> true
    | LLVMsyntax.Coq_typ_function (typ_5, l0, varg5) -> true
    | _ -> false
  
  (** val isFirstClassTypB : LLVMsyntax.typ -> bool **)
  
  let isFirstClassTypB t =
    negb (isNotFirstClassTypB t)
  
  (** val isValidArgumentTypB : LLVMsyntax.typ -> bool **)
  
  let isValidArgumentTypB t =
    isFirstClassTypB t
  
  (** val isNotValidElementTypB : LLVMsyntax.typ -> bool **)
  
  let isNotValidElementTypB = function
    | LLVMsyntax.Coq_typ_void -> true
    | LLVMsyntax.Coq_typ_label -> true
    | LLVMsyntax.Coq_typ_metadata -> true
    | LLVMsyntax.Coq_typ_function (typ_5, l0, varg5) -> true
    | _ -> false
  
  (** val isValidElementTypB : LLVMsyntax.typ -> bool **)
  
  let isValidElementTypB t =
    negb (isNotValidElementTypB t)
  
  (** val isBindingFdecB : LLVMsyntax.id_binding -> bool **)
  
  let isBindingFdecB = function
    | LLVMsyntax.Coq_id_binding_fdec fdec0 -> true
    | _ -> false
  
  (** val isBindingGvarB : LLVMsyntax.id_binding -> bool **)
  
  let isBindingGvarB = function
    | LLVMsyntax.Coq_id_binding_gvar gvar5 -> true
    | _ -> false
  
  (** val isBindingArgB : LLVMsyntax.id_binding -> bool **)
  
  let isBindingArgB = function
    | LLVMsyntax.Coq_id_binding_arg arg0 -> true
    | _ -> false
  
  (** val isBindingCmdB : LLVMsyntax.id_binding -> bool **)
  
  let isBindingCmdB = function
    | LLVMsyntax.Coq_id_binding_cmd cmd5 -> true
    | _ -> false
  
  (** val isBindingTerminatorB : LLVMsyntax.id_binding -> bool **)
  
  let isBindingTerminatorB = function
    | LLVMsyntax.Coq_id_binding_terminator terminator5 -> true
    | _ -> false
  
  (** val isBindingPhiNodeB : LLVMsyntax.id_binding -> bool **)
  
  let isBindingPhiNodeB = function
    | LLVMsyntax.Coq_id_binding_phinode phinode5 -> true
    | _ -> false
  
  (** val isBindingInsnB : LLVMsyntax.id_binding -> bool **)
  
  let isBindingInsnB ib =
    if if isBindingCmdB ib then true else isBindingTerminatorB ib
    then true
    else isBindingPhiNodeB ib
  
  (** val isBindingFdec : LLVMsyntax.id_binding -> LLVMsyntax.fdec option **)
  
  let isBindingFdec = function
    | LLVMsyntax.Coq_id_binding_fdec f -> Some f
    | _ -> None
  
  (** val isBindingArg : LLVMsyntax.id_binding -> LLVMsyntax.arg option **)
  
  let isBindingArg = function
    | LLVMsyntax.Coq_id_binding_arg a -> Some a
    | _ -> None
  
  (** val isBindingGvar : LLVMsyntax.id_binding -> LLVMsyntax.gvar option **)
  
  let isBindingGvar = function
    | LLVMsyntax.Coq_id_binding_gvar g -> Some g
    | _ -> None
  
  (** val isBindingCmd : LLVMsyntax.id_binding -> LLVMsyntax.cmd option **)
  
  let isBindingCmd = function
    | LLVMsyntax.Coq_id_binding_cmd c -> Some c
    | _ -> None
  
  (** val isBindingPhiNode :
      LLVMsyntax.id_binding -> LLVMsyntax.phinode option **)
  
  let isBindingPhiNode = function
    | LLVMsyntax.Coq_id_binding_phinode p -> Some p
    | _ -> None
  
  (** val isBindingTerminator :
      LLVMsyntax.id_binding -> LLVMsyntax.terminator option **)
  
  let isBindingTerminator = function
    | LLVMsyntax.Coq_id_binding_terminator tmn -> Some tmn
    | _ -> None
  
  (** val isBindingInsn : LLVMsyntax.id_binding -> LLVMsyntax.insn option **)
  
  let isBindingInsn = function
    | LLVMsyntax.Coq_id_binding_cmd c -> Some (LLVMsyntax.Coq_insn_cmd c)
    | LLVMsyntax.Coq_id_binding_phinode p -> Some
        (LLVMsyntax.Coq_insn_phinode p)
    | LLVMsyntax.Coq_id_binding_terminator tmn -> Some
        (LLVMsyntax.Coq_insn_terminator tmn)
    | _ -> None
  
  (** val is_terminator : LLVMsyntax.insn -> bool **)
  
  let is_terminator = function
    | LLVMsyntax.Coq_insn_terminator t -> true
    | _ -> false
  
  (** val getBlocksLocs : LLVMsyntax.block list -> LLVMsyntax.ids **)
  
  let rec getBlocksLocs = function
    | [] -> []
    | b::bs' -> app (getBlockLocs b) (getBlocksLocs bs')
  
  (** val getBlocksLabels : LLVMsyntax.block list -> LLVMsyntax.ls **)
  
  let rec getBlocksLabels = function
    | [] -> []
    | y::bs' ->
        let LLVMsyntax.Coq_block_intro (l0, phinodes5, cmds5, terminator5) =
          y
        in
        l0::(getBlocksLabels bs')
  
  (** val getProductID : LLVMsyntax.product -> LLVMsyntax.id **)
  
  let getProductID = function
    | LLVMsyntax.Coq_product_gvar g -> getGvarID g
    | LLVMsyntax.Coq_product_fdec f -> getFdecID f
    | LLVMsyntax.Coq_product_fdef f -> getFdefID f
  
  (** val getProductsIDs : LLVMsyntax.product list -> LLVMsyntax.ids **)
  
  let rec getProductsIDs = function
    | [] -> []
    | p::ps' -> (getProductID p)::(getProductsIDs ps')
  
  (** val getFdefsIDs : LLVMsyntax.product list -> LLVMsyntax.ids **)
  
  let rec getFdefsIDs = function
    | [] -> []
    | y::ps' ->
        (match y with
           | LLVMsyntax.Coq_product_fdef f ->
               (getFdefID f)::(getFdefsIDs ps')
           | _ -> getFdefsIDs ps')
  
  (** val getNamedtsIDs : LLVMsyntax.namedts -> LLVMsyntax.ids **)
  
  let rec getNamedtsIDs = function
    | [] -> []
    | n::dts' -> let id0,l0 = n in id0::(getNamedtsIDs dts')
  
  (** val sumbool2bool : bool -> bool **)
  
  let sumbool2bool = function
    | true -> true
    | false -> false
  
  (** val floating_point_dec :
      LLVMsyntax.floating_point -> LLVMsyntax.floating_point -> bool **)
  
  let floating_point_dec fp1 fp2 =
    LLVMsyntax.floating_point_rect (fun fp0 ->
      match fp0 with
        | LLVMsyntax.Coq_fp_float -> true
        | _ -> false) (fun fp0 ->
      match fp0 with
        | LLVMsyntax.Coq_fp_double -> true
        | _ -> false) (fun fp0 ->
      match fp0 with
        | LLVMsyntax.Coq_fp_fp128 -> true
        | _ -> false) (fun fp0 ->
      match fp0 with
        | LLVMsyntax.Coq_fp_x86_fp80 -> true
        | _ -> false) (fun fp0 ->
      match fp0 with
        | LLVMsyntax.Coq_fp_ppc_fp128 -> true
        | _ -> false) fp1 fp2
  
  (** val varg_dec : LLVMsyntax.varg -> LLVMsyntax.varg -> bool **)
  
  let varg_dec x y =
    match x with
      | Some s -> (match y with
                     | Some s0 -> Size.dec s s0
                     | None -> false)
      | None -> (match y with
                   | Some s -> false
                   | None -> true)
  
  type typ_dec_prop = LLVMsyntax.typ -> bool
  
  type list_typ_dec_prop = LLVMsyntax.typ list -> bool
  
  (** val typ_mutrec_dec_subproof :
      LLVMsyntax.sz -> LLVMsyntax.typ -> bool **)
  
  let typ_mutrec_dec_subproof s = function
    | LLVMsyntax.Coq_typ_int sz5 -> Size.dec s sz5
    | _ -> false
  
  (** val typ_mutrec_dec_subproof0 :
      LLVMsyntax.floating_point -> LLVMsyntax.typ -> bool **)
  
  let typ_mutrec_dec_subproof0 f0 = function
    | LLVMsyntax.Coq_typ_floatpoint floating_point5 ->
        floating_point_dec f0 floating_point5
    | _ -> false
  
  (** val typ_mutrec_dec_subproof1 : LLVMsyntax.typ -> bool **)
  
  let typ_mutrec_dec_subproof1 = function
    | LLVMsyntax.Coq_typ_void -> true
    | _ -> false
  
  (** val typ_mutrec_dec_subproof2 : LLVMsyntax.typ -> bool **)
  
  let typ_mutrec_dec_subproof2 = function
    | LLVMsyntax.Coq_typ_label -> true
    | _ -> false
  
  (** val typ_mutrec_dec_subproof3 : LLVMsyntax.typ -> bool **)
  
  let typ_mutrec_dec_subproof3 = function
    | LLVMsyntax.Coq_typ_metadata -> true
    | _ -> false
  
  (** val typ_mutrec_dec_subproof4 :
      LLVMsyntax.sz -> LLVMsyntax.typ -> (LLVMsyntax.typ -> bool) ->
      LLVMsyntax.typ -> bool **)
  
  let typ_mutrec_dec_subproof4 s t h = function
    | LLVMsyntax.Coq_typ_array (sz5, t3) ->
        let s0 = Size.dec s sz5 in if s0 then h t3 else false
    | _ -> false
  
  (** val typ_mutrec_dec_subproof5 :
      LLVMsyntax.typ -> (LLVMsyntax.typ -> bool) -> LLVMsyntax.typ list ->
      (LLVMsyntax.typ list -> bool) -> LLVMsyntax.varg -> LLVMsyntax.typ ->
      bool **)
  
  let typ_mutrec_dec_subproof5 t h l0 h0 v = function
    | LLVMsyntax.Coq_typ_function (t3, l1, varg5) ->
        let s = h t3 in
        if s
        then let s0 = h0 l1 in if s0 then varg_dec v varg5 else false
        else false
    | _ -> false
  
  (** val typ_mutrec_dec_subproof6 :
      LLVMsyntax.typ list -> (LLVMsyntax.typ list -> bool) -> LLVMsyntax.typ
      -> bool **)
  
  let typ_mutrec_dec_subproof6 l0 h = function
    | LLVMsyntax.Coq_typ_struct l1 -> h l1
    | _ -> false
  
  (** val typ_mutrec_dec_subproof7 :
      LLVMsyntax.typ -> (LLVMsyntax.typ -> bool) -> LLVMsyntax.typ -> bool **)
  
  let typ_mutrec_dec_subproof7 t h = function
    | LLVMsyntax.Coq_typ_pointer t3 -> h t3
    | _ -> false
  
  (** val typ_mutrec_dec_subproof8 :
      LLVMsyntax.id -> LLVMsyntax.typ -> bool **)
  
  let typ_mutrec_dec_subproof8 i0 = function
    | LLVMsyntax.Coq_typ_namedt id5 -> id_dec i0 id5
    | _ -> false
  
  (** val typ_mutrec_dec_subproof9 : LLVMsyntax.typ list -> bool **)
  
  let typ_mutrec_dec_subproof9 = function
    | [] -> true
    | t::lt3 -> false
  
  (** val typ_mutrec_dec_subproof10 :
      LLVMsyntax.typ -> (LLVMsyntax.typ -> bool) -> LLVMsyntax.typ list ->
      (LLVMsyntax.typ list -> bool) -> LLVMsyntax.typ list -> bool **)
  
  let typ_mutrec_dec_subproof10 t h l0 h0 = function
    | [] -> false
    | t0::lt3 -> let s = h t0 in if s then h0 lt3 else false
  
  (** val typ_mutrec_dec :
      (LLVMsyntax.typ -> typ_dec_prop)*(LLVMsyntax.typ list ->
      list_typ_dec_prop) **)
  
  let typ_mutrec_dec =
    LLVMsyntax.typ_mutrec (fun s t2 -> typ_mutrec_dec_subproof s t2)
      (fun f0 t2 -> typ_mutrec_dec_subproof0 f0 t2) (fun t2 ->
      typ_mutrec_dec_subproof1 t2) (fun t2 -> typ_mutrec_dec_subproof2 t2)
      (fun t2 -> typ_mutrec_dec_subproof3 t2) (fun s t h t2 ->
      typ_mutrec_dec_subproof4 s t h t2) (fun t h l0 h0 v t2 ->
      typ_mutrec_dec_subproof5 t h l0 h0 v t2) (fun l0 h t2 ->
      typ_mutrec_dec_subproof6 l0 h t2) (fun t h t2 ->
      typ_mutrec_dec_subproof7 t h t2) (fun i0 t2 ->
      typ_mutrec_dec_subproof8 i0 t2) (fun lt2 ->
      typ_mutrec_dec_subproof9 lt2) (fun t h l0 h0 lt2 ->
      typ_mutrec_dec_subproof10 t h l0 h0 lt2)
  
  (** val typ_dec : LLVMsyntax.typ -> LLVMsyntax.typ -> bool **)
  
  let typ_dec =
    let t,l0 = typ_mutrec_dec in t
  
  (** val list_typ_dec :
      LLVMsyntax.typ list -> LLVMsyntax.typ list -> bool **)
  
  let list_typ_dec =
    let t,l0 = typ_mutrec_dec in l0
  
  (** val bop_dec : LLVMsyntax.bop -> LLVMsyntax.bop -> bool **)
  
  let bop_dec b1 b2 =
    LLVMsyntax.bop_rect (fun b0 ->
      match b0 with
        | LLVMsyntax.Coq_bop_add -> true
        | _ -> false) (fun b0 ->
      match b0 with
        | LLVMsyntax.Coq_bop_sub -> true
        | _ -> false) (fun b0 ->
      match b0 with
        | LLVMsyntax.Coq_bop_mul -> true
        | _ -> false) (fun b0 ->
      match b0 with
        | LLVMsyntax.Coq_bop_udiv -> true
        | _ -> false) (fun b0 ->
      match b0 with
        | LLVMsyntax.Coq_bop_sdiv -> true
        | _ -> false) (fun b0 ->
      match b0 with
        | LLVMsyntax.Coq_bop_urem -> true
        | _ -> false) (fun b0 ->
      match b0 with
        | LLVMsyntax.Coq_bop_srem -> true
        | _ -> false) (fun b0 ->
      match b0 with
        | LLVMsyntax.Coq_bop_shl -> true
        | _ -> false) (fun b0 ->
      match b0 with
        | LLVMsyntax.Coq_bop_lshr -> true
        | _ -> false) (fun b0 ->
      match b0 with
        | LLVMsyntax.Coq_bop_ashr -> true
        | _ -> false) (fun b0 ->
      match b0 with
        | LLVMsyntax.Coq_bop_and -> true
        | _ -> false) (fun b0 ->
      match b0 with
        | LLVMsyntax.Coq_bop_or -> true
        | _ -> false) (fun b0 ->
      match b0 with
        | LLVMsyntax.Coq_bop_xor -> true
        | _ -> false) b1 b2
  
  (** val fbop_dec : LLVMsyntax.fbop -> LLVMsyntax.fbop -> bool **)
  
  let fbop_dec b1 b2 =
    LLVMsyntax.fbop_rect (fun b0 ->
      match b0 with
        | LLVMsyntax.Coq_fbop_fadd -> true
        | _ -> false) (fun b0 ->
      match b0 with
        | LLVMsyntax.Coq_fbop_fsub -> true
        | _ -> false) (fun b0 ->
      match b0 with
        | LLVMsyntax.Coq_fbop_fmul -> true
        | _ -> false) (fun b0 ->
      match b0 with
        | LLVMsyntax.Coq_fbop_fdiv -> true
        | _ -> false) (fun b0 ->
      match b0 with
        | LLVMsyntax.Coq_fbop_frem -> true
        | _ -> false) b1 b2
  
  (** val extop_dec : LLVMsyntax.extop -> LLVMsyntax.extop -> bool **)
  
  let extop_dec e1 e2 =
    LLVMsyntax.extop_rect (fun e0 ->
      match e0 with
        | LLVMsyntax.Coq_extop_z -> true
        | _ -> false) (fun e0 ->
      match e0 with
        | LLVMsyntax.Coq_extop_s -> true
        | _ -> false) (fun e0 ->
      match e0 with
        | LLVMsyntax.Coq_extop_fp -> true
        | _ -> false) e1 e2
  
  (** val castop_dec : LLVMsyntax.castop -> LLVMsyntax.castop -> bool **)
  
  let castop_dec c1 c2 =
    LLVMsyntax.castop_rect (fun c0 ->
      match c0 with
        | LLVMsyntax.Coq_castop_fptoui -> true
        | _ -> false) (fun c0 ->
      match c0 with
        | LLVMsyntax.Coq_castop_fptosi -> true
        | _ -> false) (fun c0 ->
      match c0 with
        | LLVMsyntax.Coq_castop_uitofp -> true
        | _ -> false) (fun c0 ->
      match c0 with
        | LLVMsyntax.Coq_castop_sitofp -> true
        | _ -> false) (fun c0 ->
      match c0 with
        | LLVMsyntax.Coq_castop_ptrtoint -> true
        | _ -> false) (fun c0 ->
      match c0 with
        | LLVMsyntax.Coq_castop_inttoptr -> true
        | _ -> false) (fun c0 ->
      match c0 with
        | LLVMsyntax.Coq_castop_bitcast -> true
        | _ -> false) c1 c2
  
  (** val cond_dec : LLVMsyntax.cond -> LLVMsyntax.cond -> bool **)
  
  let cond_dec c1 c2 =
    LLVMsyntax.cond_rect (fun c0 ->
      match c0 with
        | LLVMsyntax.Coq_cond_eq -> true
        | _ -> false) (fun c0 ->
      match c0 with
        | LLVMsyntax.Coq_cond_ne -> true
        | _ -> false) (fun c0 ->
      match c0 with
        | LLVMsyntax.Coq_cond_ugt -> true
        | _ -> false) (fun c0 ->
      match c0 with
        | LLVMsyntax.Coq_cond_uge -> true
        | _ -> false) (fun c0 ->
      match c0 with
        | LLVMsyntax.Coq_cond_ult -> true
        | _ -> false) (fun c0 ->
      match c0 with
        | LLVMsyntax.Coq_cond_ule -> true
        | _ -> false) (fun c0 ->
      match c0 with
        | LLVMsyntax.Coq_cond_sgt -> true
        | _ -> false) (fun c0 ->
      match c0 with
        | LLVMsyntax.Coq_cond_sge -> true
        | _ -> false) (fun c0 ->
      match c0 with
        | LLVMsyntax.Coq_cond_slt -> true
        | _ -> false) (fun c0 ->
      match c0 with
        | LLVMsyntax.Coq_cond_sle -> true
        | _ -> false) c1 c2
  
  (** val fcond_dec : LLVMsyntax.fcond -> LLVMsyntax.fcond -> bool **)
  
  let fcond_dec c1 c2 =
    LLVMsyntax.fcond_rect (fun c0 ->
      match c0 with
        | LLVMsyntax.Coq_fcond_false -> true
        | _ -> false) (fun c0 ->
      match c0 with
        | LLVMsyntax.Coq_fcond_oeq -> true
        | _ -> false) (fun c0 ->
      match c0 with
        | LLVMsyntax.Coq_fcond_ogt -> true
        | _ -> false) (fun c0 ->
      match c0 with
        | LLVMsyntax.Coq_fcond_oge -> true
        | _ -> false) (fun c0 ->
      match c0 with
        | LLVMsyntax.Coq_fcond_olt -> true
        | _ -> false) (fun c0 ->
      match c0 with
        | LLVMsyntax.Coq_fcond_ole -> true
        | _ -> false) (fun c0 ->
      match c0 with
        | LLVMsyntax.Coq_fcond_one -> true
        | _ -> false) (fun c0 ->
      match c0 with
        | LLVMsyntax.Coq_fcond_ord -> true
        | _ -> false) (fun c0 ->
      match c0 with
        | LLVMsyntax.Coq_fcond_ueq -> true
        | _ -> false) (fun c0 ->
      match c0 with
        | LLVMsyntax.Coq_fcond_ugt -> true
        | _ -> false) (fun c0 ->
      match c0 with
        | LLVMsyntax.Coq_fcond_uge -> true
        | _ -> false) (fun c0 ->
      match c0 with
        | LLVMsyntax.Coq_fcond_ult -> true
        | _ -> false) (fun c0 ->
      match c0 with
        | LLVMsyntax.Coq_fcond_ule -> true
        | _ -> false) (fun c0 ->
      match c0 with
        | LLVMsyntax.Coq_fcond_une -> true
        | _ -> false) (fun c0 ->
      match c0 with
        | LLVMsyntax.Coq_fcond_uno -> true
        | _ -> false) (fun c0 ->
      match c0 with
        | LLVMsyntax.Coq_fcond_true -> true
        | _ -> false) c1 c2
  
  (** val truncop_dec : LLVMsyntax.truncop -> LLVMsyntax.truncop -> bool **)
  
  let truncop_dec t1 t2 =
    LLVMsyntax.truncop_rect (fun t0 ->
      match t0 with
        | LLVMsyntax.Coq_truncop_int -> true
        | LLVMsyntax.Coq_truncop_fp -> false) (fun t0 ->
      match t0 with
        | LLVMsyntax.Coq_truncop_int -> false
        | LLVMsyntax.Coq_truncop_fp -> true) t1 t2
  
  type const_dec_prop = LLVMsyntax.const -> bool
  
  type list_const_dec_prop = LLVMsyntax.const list -> bool
  
  (** val const_mutrec_dec_subproof :
      LLVMsyntax.typ -> LLVMsyntax.const -> bool **)
  
  let const_mutrec_dec_subproof t = function
    | LLVMsyntax.Coq_const_zeroinitializer typ5 -> typ_dec t typ5
    | _ -> false
  
  (** val const_mutrec_dec_subproof0 :
      LLVMsyntax.sz -> LLVMsyntax.coq_Int -> LLVMsyntax.const -> bool **)
  
  let const_mutrec_dec_subproof0 s i0 = function
    | LLVMsyntax.Coq_const_int (sz5, int5) ->
        let s0 = Size.dec s sz5 in if s0 then INTEGER.dec i0 int5 else false
    | _ -> false
  
  (** val const_mutrec_dec_subproof1 :
      LLVMsyntax.floating_point -> LLVMsyntax.coq_Float -> LLVMsyntax.const
      -> bool **)
  
  let const_mutrec_dec_subproof1 f1 f2 = function
    | LLVMsyntax.Coq_const_floatpoint (floating_point5, float5) ->
        let s = floating_point_dec f1 floating_point5 in
        if s then FLOAT.dec f2 float5 else false
    | _ -> false
  
  (** val const_mutrec_dec_subproof2 :
      LLVMsyntax.typ -> LLVMsyntax.const -> bool **)
  
  let const_mutrec_dec_subproof2 t = function
    | LLVMsyntax.Coq_const_undef typ5 -> typ_dec t typ5
    | _ -> false
  
  (** val const_mutrec_dec_subproof3 :
      LLVMsyntax.typ -> LLVMsyntax.const -> bool **)
  
  let const_mutrec_dec_subproof3 t = function
    | LLVMsyntax.Coq_const_null typ5 -> typ_dec t typ5
    | _ -> false
  
  (** val const_mutrec_dec_subproof4 :
      LLVMsyntax.typ -> LLVMsyntax.const list -> (LLVMsyntax.const list ->
      bool) -> LLVMsyntax.const -> bool **)
  
  let const_mutrec_dec_subproof4 t l0 h = function
    | LLVMsyntax.Coq_const_arr (typ5, l1) ->
        let s = typ_dec t typ5 in if s then h l1 else false
    | _ -> false
  
  (** val const_mutrec_dec_subproof5 :
      LLVMsyntax.typ -> LLVMsyntax.const list -> (LLVMsyntax.const list ->
      bool) -> LLVMsyntax.const -> bool **)
  
  let const_mutrec_dec_subproof5 t l0 h = function
    | LLVMsyntax.Coq_const_struct (typ5, l1) ->
        let s = typ_dec t typ5 in if s then h l1 else false
    | _ -> false
  
  (** val const_mutrec_dec_subproof6 :
      LLVMsyntax.typ -> LLVMsyntax.id -> LLVMsyntax.const -> bool **)
  
  let const_mutrec_dec_subproof6 t i0 = function
    | LLVMsyntax.Coq_const_gid (typ5, id5) ->
        let s = typ_dec t typ5 in if s then id_dec i0 id5 else false
    | _ -> false
  
  (** val const_mutrec_dec_subproof7 :
      LLVMsyntax.truncop -> LLVMsyntax.const -> (LLVMsyntax.const -> bool) ->
      LLVMsyntax.typ -> LLVMsyntax.const -> bool **)
  
  let const_mutrec_dec_subproof7 t c h t0 = function
    | LLVMsyntax.Coq_const_truncop (truncop5, c3, typ5) ->
        let s = truncop_dec t truncop5 in
        if s
        then let s0 = h c3 in if s0 then typ_dec t0 typ5 else false
        else false
    | _ -> false
  
  (** val const_mutrec_dec_subproof8 :
      LLVMsyntax.extop -> LLVMsyntax.const -> (LLVMsyntax.const -> bool) ->
      LLVMsyntax.typ -> LLVMsyntax.const -> bool **)
  
  let const_mutrec_dec_subproof8 e c h t = function
    | LLVMsyntax.Coq_const_extop (extop5, c3, typ5) ->
        let s = extop_dec e extop5 in
        if s
        then let s0 = h c3 in if s0 then typ_dec t typ5 else false
        else false
    | _ -> false
  
  (** val const_mutrec_dec_subproof9 :
      LLVMsyntax.castop -> LLVMsyntax.const -> (LLVMsyntax.const -> bool) ->
      LLVMsyntax.typ -> LLVMsyntax.const -> bool **)
  
  let const_mutrec_dec_subproof9 c c0 h t = function
    | LLVMsyntax.Coq_const_castop (castop5, c3, typ5) ->
        let s = castop_dec c castop5 in
        if s
        then let s0 = h c3 in if s0 then typ_dec t typ5 else false
        else false
    | _ -> false
  
  (** val const_mutrec_dec_subproof10 :
      LLVMsyntax.inbounds -> LLVMsyntax.const -> (LLVMsyntax.const -> bool)
      -> LLVMsyntax.const list -> (LLVMsyntax.const list -> bool) ->
      LLVMsyntax.const -> bool **)
  
  let const_mutrec_dec_subproof10 i0 c h l0 h0 = function
    | LLVMsyntax.Coq_const_gep (inbounds5, c3, l1) ->
        let s = inbounds_dec i0 inbounds5 in
        if s then let s0 = h c3 in if s0 then h0 l1 else false else false
    | _ -> false
  
  (** val const_mutrec_dec_subproof11 :
      LLVMsyntax.const -> (LLVMsyntax.const -> bool) -> LLVMsyntax.const ->
      (LLVMsyntax.const -> bool) -> LLVMsyntax.const -> (LLVMsyntax.const ->
      bool) -> LLVMsyntax.const -> bool **)
  
  let const_mutrec_dec_subproof11 c h c0 h0 c1 h1 = function
    | LLVMsyntax.Coq_const_select (c2_1, c2_2, c2_3) ->
        let s = h c2_1 in
        if s
        then let s0 = h0 c2_2 in if s0 then h1 c2_3 else false
        else false
    | _ -> false
  
  (** val const_mutrec_dec_subproof12 :
      LLVMsyntax.cond -> LLVMsyntax.const -> (LLVMsyntax.const -> bool) ->
      LLVMsyntax.const -> (LLVMsyntax.const -> bool) -> LLVMsyntax.const ->
      bool **)
  
  let const_mutrec_dec_subproof12 c c0 h c1 h0 = function
    | LLVMsyntax.Coq_const_icmp (cond5, c2_1, c2_2) ->
        let s = cond_dec c cond5 in
        if s then let s0 = h c2_1 in if s0 then h0 c2_2 else false else false
    | _ -> false
  
  (** val const_mutrec_dec_subproof13 :
      LLVMsyntax.fcond -> LLVMsyntax.const -> (LLVMsyntax.const -> bool) ->
      LLVMsyntax.const -> (LLVMsyntax.const -> bool) -> LLVMsyntax.const ->
      bool **)
  
  let const_mutrec_dec_subproof13 f13 c h c0 h0 = function
    | LLVMsyntax.Coq_const_fcmp (fcond5, c2_1, c2_2) ->
        let s = fcond_dec f13 fcond5 in
        if s then let s0 = h c2_1 in if s0 then h0 c2_2 else false else false
    | _ -> false
  
  (** val const_mutrec_dec_subproof14 :
      LLVMsyntax.const -> (LLVMsyntax.const -> bool) -> LLVMsyntax.const list
      -> (LLVMsyntax.const list -> bool) -> LLVMsyntax.const -> bool **)
  
  let const_mutrec_dec_subproof14 c h l0 h0 = function
    | LLVMsyntax.Coq_const_extractvalue (c3, l1) ->
        let s = h c3 in if s then h0 l1 else false
    | _ -> false
  
  (** val const_mutrec_dec_subproof15 :
      LLVMsyntax.const -> (LLVMsyntax.const -> bool) -> LLVMsyntax.const ->
      (LLVMsyntax.const -> bool) -> LLVMsyntax.const list ->
      (LLVMsyntax.const list -> bool) -> LLVMsyntax.const -> bool **)
  
  let const_mutrec_dec_subproof15 c h c0 h0 l0 h1 = function
    | LLVMsyntax.Coq_const_insertvalue (c2_1, c2_2, l1) ->
        let s = h c2_1 in
        if s then let s0 = h0 c2_2 in if s0 then h1 l1 else false else false
    | _ -> false
  
  (** val const_mutrec_dec_subproof16 :
      LLVMsyntax.bop -> LLVMsyntax.const -> (LLVMsyntax.const -> bool) ->
      LLVMsyntax.const -> (LLVMsyntax.const -> bool) -> LLVMsyntax.const ->
      bool **)
  
  let const_mutrec_dec_subproof16 b c h c0 h0 = function
    | LLVMsyntax.Coq_const_bop (bop5, c2_1, c2_2) ->
        let s = bop_dec b bop5 in
        if s then let s0 = h c2_1 in if s0 then h0 c2_2 else false else false
    | _ -> false
  
  (** val const_mutrec_dec_subproof17 :
      LLVMsyntax.fbop -> LLVMsyntax.const -> (LLVMsyntax.const -> bool) ->
      LLVMsyntax.const -> (LLVMsyntax.const -> bool) -> LLVMsyntax.const ->
      bool **)
  
  let const_mutrec_dec_subproof17 f17 c h c0 h0 = function
    | LLVMsyntax.Coq_const_fbop (fbop5, c2_1, c2_2) ->
        let s = fbop_dec f17 fbop5 in
        if s then let s0 = h c2_1 in if s0 then h0 c2_2 else false else false
    | _ -> false
  
  (** val const_mutrec_dec_subproof18 : LLVMsyntax.const list -> bool **)
  
  let const_mutrec_dec_subproof18 = function
    | [] -> true
    | c::lc3 -> false
  
  (** val const_mutrec_dec_subproof19 :
      LLVMsyntax.const -> (LLVMsyntax.const -> bool) -> LLVMsyntax.const list
      -> (LLVMsyntax.const list -> bool) -> LLVMsyntax.const list -> bool **)
  
  let const_mutrec_dec_subproof19 c h l0 h0 = function
    | [] -> false
    | c0::lc3 -> let s = h c0 in if s then h0 lc3 else false
  
  (** val const_mutrec_dec :
      (LLVMsyntax.const -> const_dec_prop)*(LLVMsyntax.const list ->
      list_const_dec_prop) **)
  
  let const_mutrec_dec =
    LLVMsyntax.const_mutrec (fun t c2 -> const_mutrec_dec_subproof t c2)
      (fun s i0 c2 -> const_mutrec_dec_subproof0 s i0 c2) (fun f1 f2 c2 ->
      const_mutrec_dec_subproof1 f1 f2 c2) (fun t c2 ->
      const_mutrec_dec_subproof2 t c2) (fun t c2 ->
      const_mutrec_dec_subproof3 t c2) (fun t l0 h c2 ->
      const_mutrec_dec_subproof4 t l0 h c2) (fun t l0 h c2 ->
      const_mutrec_dec_subproof5 t l0 h c2) (fun t i0 c2 ->
      const_mutrec_dec_subproof6 t i0 c2) (fun t c h t0 c2 ->
      const_mutrec_dec_subproof7 t c h t0 c2) (fun e c h t c2 ->
      const_mutrec_dec_subproof8 e c h t c2) (fun c c0 h t c2 ->
      const_mutrec_dec_subproof9 c c0 h t c2) (fun i0 c h l0 h0 c2 ->
      const_mutrec_dec_subproof10 i0 c h l0 h0 c2) (fun c h c0 h0 c1 h1 c2 ->
      const_mutrec_dec_subproof11 c h c0 h0 c1 h1 c2) (fun c c0 h c1 h0 c2 ->
      const_mutrec_dec_subproof12 c c0 h c1 h0 c2) (fun f13 c h c0 h0 c2 ->
      const_mutrec_dec_subproof13 f13 c h c0 h0 c2) (fun c h l0 h0 c2 ->
      const_mutrec_dec_subproof14 c h l0 h0 c2) (fun c h c0 h0 l0 h1 c2 ->
      const_mutrec_dec_subproof15 c h c0 h0 l0 h1 c2) (fun b c h c0 h0 c2 ->
      const_mutrec_dec_subproof16 b c h c0 h0 c2) (fun f17 c h c0 h0 c2 ->
      const_mutrec_dec_subproof17 f17 c h c0 h0 c2) (fun lc2 ->
      const_mutrec_dec_subproof18 lc2) (fun c h l0 h0 lc2 ->
      const_mutrec_dec_subproof19 c h l0 h0 lc2)
  
  (** val const_dec : LLVMsyntax.const -> LLVMsyntax.const -> bool **)
  
  let const_dec =
    let c,l0 = const_mutrec_dec in c
  
  (** val list_const_dec :
      LLVMsyntax.const list -> LLVMsyntax.const list -> bool **)
  
  let list_const_dec =
    let c,l0 = const_mutrec_dec in l0
  
  (** val value_dec : LLVMsyntax.value -> LLVMsyntax.value -> bool **)
  
  let value_dec v1 v2 =
    LLVMsyntax.value_rect (fun id5 v0 ->
      match v0 with
        | LLVMsyntax.Coq_value_id id0 -> AtomImpl.eq_atom_dec id5 id0
        | LLVMsyntax.Coq_value_const const5 -> false) (fun const5 v0 ->
      match v0 with
        | LLVMsyntax.Coq_value_id id5 -> false
        | LLVMsyntax.Coq_value_const const0 -> const_dec const5 const0) v1 v2
  
  (** val attribute_dec :
      LLVMsyntax.attribute -> LLVMsyntax.attribute -> bool **)
  
  let attribute_dec attr1 attr2 =
    LLVMsyntax.attribute_rect (fun attr0 ->
      match attr0 with
        | LLVMsyntax.Coq_attribute_zext -> true
        | _ -> false) (fun attr0 ->
      match attr0 with
        | LLVMsyntax.Coq_attribute_sext -> true
        | _ -> false) (fun attr0 ->
      match attr0 with
        | LLVMsyntax.Coq_attribute_noreturn -> true
        | _ -> false) (fun attr0 ->
      match attr0 with
        | LLVMsyntax.Coq_attribute_inreg -> true
        | _ -> false) (fun attr0 ->
      match attr0 with
        | LLVMsyntax.Coq_attribute_structret -> true
        | _ -> false) (fun attr0 ->
      match attr0 with
        | LLVMsyntax.Coq_attribute_nounwind -> true
        | _ -> false) (fun attr0 ->
      match attr0 with
        | LLVMsyntax.Coq_attribute_noalias -> true
        | _ -> false) (fun attr0 ->
      match attr0 with
        | LLVMsyntax.Coq_attribute_byval -> true
        | _ -> false) (fun attr0 ->
      match attr0 with
        | LLVMsyntax.Coq_attribute_nest -> true
        | _ -> false) (fun attr0 ->
      match attr0 with
        | LLVMsyntax.Coq_attribute_readnone -> true
        | _ -> false) (fun attr0 ->
      match attr0 with
        | LLVMsyntax.Coq_attribute_readonly -> true
        | _ -> false) (fun attr0 ->
      match attr0 with
        | LLVMsyntax.Coq_attribute_noinline -> true
        | _ -> false) (fun attr0 ->
      match attr0 with
        | LLVMsyntax.Coq_attribute_alwaysinline -> true
        | _ -> false) (fun attr0 ->
      match attr0 with
        | LLVMsyntax.Coq_attribute_optforsize -> true
        | _ -> false) (fun attr0 ->
      match attr0 with
        | LLVMsyntax.Coq_attribute_stackprotect -> true
        | _ -> false) (fun attr0 ->
      match attr0 with
        | LLVMsyntax.Coq_attribute_stackprotectreq -> true
        | _ -> false) (fun attr0 ->
      match attr0 with
        | LLVMsyntax.Coq_attribute_nocapture -> true
        | _ -> false) (fun attr0 ->
      match attr0 with
        | LLVMsyntax.Coq_attribute_noredzone -> true
        | _ -> false) (fun attr0 ->
      match attr0 with
        | LLVMsyntax.Coq_attribute_implicitfloat -> true
        | _ -> false) (fun attr0 ->
      match attr0 with
        | LLVMsyntax.Coq_attribute_naked -> true
        | _ -> false) attr1 attr2
  
  (** val attributes_dec :
      LLVMsyntax.attributes -> LLVMsyntax.attributes -> bool **)
  
  let rec attributes_dec l0 attrs0 =
    match l0 with
      | [] -> (match attrs0 with
                 | [] -> true
                 | a::l1 -> false)
      | y::l1 ->
          (match attrs0 with
             | [] -> false
             | a0::l2 ->
                 if attribute_dec y a0 then attributes_dec l1 l2 else false)
  
  (** val params_dec : LLVMsyntax.params -> LLVMsyntax.params -> bool **)
  
  let rec params_dec l0 p0 =
    match l0 with
      | [] -> (match p0 with
                 | [] -> true
                 | p::l1 -> false)
      | y::l1 ->
          (match p0 with
             | [] -> false
             | p::l2 ->
                 if let p1,x = y in
                    let t,a = p1 in
                    let p2,x0 = p in
                    let t0,a0 = p2 in
                    let s = typ_dec t t0 in
                    if s
                    then let s0 = attributes_dec a a0 in
                         if s0 then value_dec x x0 else false
                    else false
                 then params_dec l1 l2
                 else false)
  
  (** val list_value_l_dec :
      (LLVMsyntax.value*LLVMsyntax.l) list -> (LLVMsyntax.value*LLVMsyntax.l)
      list -> bool **)
  
  let rec list_value_l_dec l0 l1 =
    match l0 with
      | [] -> (match l1 with
                 | [] -> true
                 | p::l2 -> false)
      | y::l2 ->
          (match l1 with
             | [] -> false
             | p::l3 ->
                 if let x,x0 = y in
                    let v,l4 = p in
                    if LLVMsyntax.value_rect (fun id5 v0 ->
                         match v0 with
                           | LLVMsyntax.Coq_value_id id0 ->
                               AtomImpl.eq_atom_dec id5 id0
                           | LLVMsyntax.Coq_value_const const5 -> false)
                         (fun const5 v0 ->
                         match v0 with
                           | LLVMsyntax.Coq_value_id id5 -> false
                           | LLVMsyntax.Coq_value_const const0 ->
                               const_dec const5 const0) x v
                    then AtomImpl.eq_atom_dec x0 l4
                    else false
                 then list_value_l_dec l2 l3
                 else false)
  
  (** val list_value_dec :
      (LLVMsyntax.sz*LLVMsyntax.value) list ->
      (LLVMsyntax.sz*LLVMsyntax.value) list -> bool **)
  
  let rec list_value_dec l0 lv0 =
    match l0 with
      | [] -> (match lv0 with
                 | [] -> true
                 | p::l1 -> false)
      | y::l1 ->
          (match lv0 with
             | [] -> false
             | p::l2 ->
                 if let x,x0 = y in
                    let s,v = p in
                    if Size.dec x s then value_dec x0 v else false
                 then list_value_dec l1 l2
                 else false)
  
  (** val callconv_dec :
      LLVMsyntax.callconv -> LLVMsyntax.callconv -> bool **)
  
  let callconv_dec cc1 cc2 =
    LLVMsyntax.callconv_rect (fun cc0 ->
      match cc0 with
        | LLVMsyntax.Coq_callconv_ccc -> true
        | _ -> false) (fun cc0 ->
      match cc0 with
        | LLVMsyntax.Coq_callconv_fast -> true
        | _ -> false) (fun cc0 ->
      match cc0 with
        | LLVMsyntax.Coq_callconv_cold -> true
        | _ -> false) (fun cc0 ->
      match cc0 with
        | LLVMsyntax.Coq_callconv_x86_stdcall -> true
        | _ -> false) (fun cc0 ->
      match cc0 with
        | LLVMsyntax.Coq_callconv_x86_fastcall -> true
        | _ -> false) cc1 cc2
  
  (** val cmd_dec_subproof :
      LLVMsyntax.id -> LLVMsyntax.bop -> LLVMsyntax.sz -> LLVMsyntax.value ->
      LLVMsyntax.value -> LLVMsyntax.id -> LLVMsyntax.bop -> LLVMsyntax.sz ->
      LLVMsyntax.value -> LLVMsyntax.value -> bool **)
  
  let cmd_dec_subproof id5 bop5 sz5 value1 value2 id0 bop0 sz0 value0 value3 =
    let c = LLVMsyntax.Coq_insn_bop (id0, bop0, sz0, value0, value3) in
    (match c with
       | LLVMsyntax.Coq_insn_bop (id1, bop1, sz1, value4, value5) ->
           let s = id_dec id5 id1 in
           if s
           then let s0 = bop_dec bop5 bop1 in
                if s0
                then let s1 = Size.dec sz5 sz1 in
                     if s1
                     then let s2 = value_dec value1 value4 in
                          if s2 then value_dec value2 value5 else false
                     else false
                else false
           else false
       | _ -> false)
  
  (** val cmd_dec_subproof0 :
      LLVMsyntax.id -> LLVMsyntax.fbop -> LLVMsyntax.floating_point ->
      LLVMsyntax.value -> LLVMsyntax.value -> LLVMsyntax.id ->
      LLVMsyntax.fbop -> LLVMsyntax.floating_point -> LLVMsyntax.value ->
      LLVMsyntax.value -> bool **)
  
  let cmd_dec_subproof0 id5 fbop5 floating_point5 value1 value2 id0 fbop0 floating_point0 value0 value3 =
    let c = LLVMsyntax.Coq_insn_fbop (id0, fbop0, floating_point0, value0,
      value3)
    in
    (match c with
       | LLVMsyntax.Coq_insn_fbop
           (id1, fbop1, floating_point1, value4, value5) ->
           let s = id_dec id5 id1 in
           if s
           then let s0 = fbop_dec fbop5 fbop1 in
                if s0
                then let s1 =
                       floating_point_dec floating_point5 floating_point1
                     in
                     if s1
                     then let s2 = value_dec value1 value4 in
                          if s2 then value_dec value2 value5 else false
                     else false
                else false
           else false
       | _ -> false)
  
  (** val cmd_dec_subproof1 :
      LLVMsyntax.id -> LLVMsyntax.typ -> LLVMsyntax.value -> LLVMsyntax.const
      list -> LLVMsyntax.typ -> LLVMsyntax.id -> LLVMsyntax.typ ->
      LLVMsyntax.value -> LLVMsyntax.const list -> LLVMsyntax.typ -> bool **)
  
  let cmd_dec_subproof1 id5 typ5 value5 l0 typ' id0 typ0 value0 l1 typ'0 =
    let c = LLVMsyntax.Coq_insn_extractvalue (id0, typ0, value0, l1, typ'0)
    in
    (match c with
       | LLVMsyntax.Coq_insn_extractvalue (id1, typ1, value1, l2, typ'1) ->
           let s = id_dec id5 id1 in
           if s
           then let s0 = typ_dec typ5 typ1 in
                if s0
                then let s1 = value_dec value5 value1 in
                     if s1
                     then let s2 = list_const_dec l0 l2 in
                          if s2 then typ_dec typ' typ'1 else false
                     else false
                else false
           else false
       | _ -> false)
  
  (** val cmd_dec_subproof2 :
      LLVMsyntax.id -> LLVMsyntax.typ -> LLVMsyntax.value -> LLVMsyntax.typ
      -> LLVMsyntax.value -> LLVMsyntax.const list -> LLVMsyntax.id ->
      LLVMsyntax.typ -> LLVMsyntax.value -> LLVMsyntax.typ ->
      LLVMsyntax.value -> LLVMsyntax.const list -> bool **)
  
  let cmd_dec_subproof2 id5 typ5 value5 typ' value' l0 id0 typ0 value0 typ'0 value'0 l1 =
    let c = LLVMsyntax.Coq_insn_insertvalue (id0, typ0, value0, typ'0,
      value'0, l1)
    in
    (match c with
       | LLVMsyntax.Coq_insn_insertvalue
           (id1, typ1, value1, typ'1, value'1, l2) ->
           let s = id_dec id5 id1 in
           if s
           then let s0 = typ_dec typ5 typ1 in
                if s0
                then let s1 = value_dec value5 value1 in
                     if s1
                     then let s2 = typ_dec typ' typ'1 in
                          if s2
                          then let s3 = value_dec value' value'1 in
                               if s3 then list_const_dec l0 l2 else false
                          else false
                     else false
                else false
           else false
       | _ -> false)
  
  (** val cmd_dec_subproof3 :
      LLVMsyntax.id -> LLVMsyntax.typ -> LLVMsyntax.value -> LLVMsyntax.align
      -> LLVMsyntax.id -> LLVMsyntax.typ -> LLVMsyntax.value ->
      LLVMsyntax.align -> bool **)
  
  let cmd_dec_subproof3 id5 typ5 value5 align5 id0 typ0 value0 align0 =
    let c = LLVMsyntax.Coq_insn_malloc (id0, typ0, value0, align0) in
    (match c with
       | LLVMsyntax.Coq_insn_malloc (id1, typ1, value1, align1) ->
           let s = id_dec id5 id1 in
           if s
           then let s0 = typ_dec typ5 typ1 in
                if s0
                then let s1 = value_dec value5 value1 in
                     if s1 then Align.dec align5 align1 else false
                else false
           else false
       | _ -> false)
  
  (** val cmd_dec_subproof4 :
      LLVMsyntax.id -> LLVMsyntax.typ -> LLVMsyntax.value -> LLVMsyntax.id ->
      LLVMsyntax.typ -> LLVMsyntax.value -> bool **)
  
  let cmd_dec_subproof4 id5 typ5 value5 id0 typ0 value0 =
    let c = LLVMsyntax.Coq_insn_free (id0, typ0, value0) in
    (match c with
       | LLVMsyntax.Coq_insn_free (id1, typ1, value1) ->
           let s = id_dec id5 id1 in
           if s
           then let s0 = typ_dec typ5 typ1 in
                if s0 then value_dec value5 value1 else false
           else false
       | _ -> false)
  
  (** val cmd_dec_subproof5 :
      LLVMsyntax.id -> LLVMsyntax.typ -> LLVMsyntax.value -> LLVMsyntax.align
      -> LLVMsyntax.id -> LLVMsyntax.typ -> LLVMsyntax.value ->
      LLVMsyntax.align -> bool **)
  
  let cmd_dec_subproof5 id5 typ5 value5 align5 id0 typ0 value0 align0 =
    let c = LLVMsyntax.Coq_insn_alloca (id0, typ0, value0, align0) in
    (match c with
       | LLVMsyntax.Coq_insn_alloca (id1, typ1, value1, align1) ->
           let s = id_dec id5 id1 in
           if s
           then let s0 = typ_dec typ5 typ1 in
                if s0
                then let s1 = value_dec value5 value1 in
                     if s1 then Align.dec align5 align1 else false
                else false
           else false
       | _ -> false)
  
  (** val cmd_dec_subproof6 :
      LLVMsyntax.id -> LLVMsyntax.typ -> LLVMsyntax.value -> LLVMsyntax.align
      -> LLVMsyntax.id -> LLVMsyntax.typ -> LLVMsyntax.value ->
      LLVMsyntax.align -> bool **)
  
  let cmd_dec_subproof6 id5 typ5 value1 align5 id0 typ0 value0 align0 =
    let c = LLVMsyntax.Coq_insn_load (id0, typ0, value0, align0) in
    (match c with
       | LLVMsyntax.Coq_insn_load (id1, typ1, value2, align1) ->
           let s = id_dec id5 id1 in
           if s
           then let s0 = typ_dec typ5 typ1 in
                if s0
                then let s1 = value_dec value1 value2 in
                     if s1 then Align.dec align5 align1 else false
                else false
           else false
       | _ -> false)
  
  (** val cmd_dec_subproof7 :
      LLVMsyntax.id -> LLVMsyntax.typ -> LLVMsyntax.value -> LLVMsyntax.value
      -> LLVMsyntax.align -> LLVMsyntax.id -> LLVMsyntax.typ ->
      LLVMsyntax.value -> LLVMsyntax.value -> LLVMsyntax.align -> bool **)
  
  let cmd_dec_subproof7 id5 typ5 value1 value2 align5 id0 typ0 value0 value3 align0 =
    let c = LLVMsyntax.Coq_insn_store (id0, typ0, value0, value3, align0) in
    (match c with
       | LLVMsyntax.Coq_insn_store (id1, typ1, value4, value5, align1) ->
           let s = id_dec id5 id1 in
           if s
           then let s0 = typ_dec typ5 typ1 in
                if s0
                then let s1 = value_dec value1 value4 in
                     if s1
                     then let s2 = value_dec value2 value5 in
                          if s2 then Align.dec align5 align1 else false
                     else false
                else false
           else false
       | _ -> false)
  
  (** val cmd_dec_subproof8 :
      LLVMsyntax.id -> LLVMsyntax.inbounds -> LLVMsyntax.typ ->
      LLVMsyntax.value -> (LLVMsyntax.sz*LLVMsyntax.value) list ->
      LLVMsyntax.typ -> LLVMsyntax.id -> LLVMsyntax.inbounds ->
      LLVMsyntax.typ -> LLVMsyntax.value -> (LLVMsyntax.sz*LLVMsyntax.value)
      list -> LLVMsyntax.typ -> bool **)
  
  let cmd_dec_subproof8 id5 inbounds5 typ5 value_5 l0 typ' id0 inbounds0 typ0 value_0 l1 typ'0 =
    let c = LLVMsyntax.Coq_insn_gep (id0, inbounds0, typ0, value_0, l1,
      typ'0)
    in
    (match c with
       | LLVMsyntax.Coq_insn_gep
           (id1, inbounds1, typ1, value_1, l2, typ'1) ->
           let s = id_dec id5 id1 in
           if s
           then let s0 = inbounds_dec inbounds5 inbounds1 in
                if s0
                then let s1 = typ_dec typ5 typ1 in
                     if s1
                     then let s2 = value_dec value_5 value_1 in
                          if s2
                          then let s3 = list_value_dec l0 l2 in
                               if s3 then typ_dec typ' typ'1 else false
                          else false
                     else false
                else false
           else false
       | _ -> false)
  
  (** val cmd_dec_subproof9 :
      LLVMsyntax.id -> LLVMsyntax.truncop -> LLVMsyntax.typ ->
      LLVMsyntax.value -> LLVMsyntax.typ -> LLVMsyntax.id ->
      LLVMsyntax.truncop -> LLVMsyntax.typ -> LLVMsyntax.value ->
      LLVMsyntax.typ -> bool **)
  
  let cmd_dec_subproof9 id5 truncop5 typ1 value1 typ2 id0 truncop0 typ0 value0 typ3 =
    let c = LLVMsyntax.Coq_insn_trunc (id0, truncop0, typ0, value0, typ3) in
    (match c with
       | LLVMsyntax.Coq_insn_trunc (id1, truncop1, typ4, value2, typ5) ->
           let s = id_dec id5 id1 in
           if s
           then let s0 = truncop_dec truncop5 truncop1 in
                if s0
                then let s1 = typ_dec typ1 typ4 in
                     if s1
                     then let s2 = value_dec value1 value2 in
                          if s2 then typ_dec typ2 typ5 else false
                     else false
                else false
           else false
       | _ -> false)
  
  (** val cmd_dec_subproof10 :
      LLVMsyntax.id -> LLVMsyntax.extop -> LLVMsyntax.typ -> LLVMsyntax.value
      -> LLVMsyntax.typ -> LLVMsyntax.id -> LLVMsyntax.extop ->
      LLVMsyntax.typ -> LLVMsyntax.value -> LLVMsyntax.typ -> bool **)
  
  let cmd_dec_subproof10 id5 extop5 typ1 value5 typ2 id0 extop0 typ0 value0 typ3 =
    let c = LLVMsyntax.Coq_insn_ext (id0, extop0, typ0, value0, typ3) in
    (match c with
       | LLVMsyntax.Coq_insn_ext (id1, extop1, typ4, value1, typ5) ->
           let s = id_dec id5 id1 in
           if s
           then let s0 = extop_dec extop5 extop1 in
                if s0
                then let s1 = typ_dec typ1 typ4 in
                     if s1
                     then let s2 = value_dec value5 value1 in
                          if s2 then typ_dec typ2 typ5 else false
                     else false
                else false
           else false
       | _ -> false)
  
  (** val cmd_dec_subproof11 :
      LLVMsyntax.id -> LLVMsyntax.castop -> LLVMsyntax.typ ->
      LLVMsyntax.value -> LLVMsyntax.typ -> LLVMsyntax.id ->
      LLVMsyntax.castop -> LLVMsyntax.typ -> LLVMsyntax.value ->
      LLVMsyntax.typ -> bool **)
  
  let cmd_dec_subproof11 id5 castop5 typ1 value1 typ2 id0 castop0 typ0 value0 typ3 =
    let c = LLVMsyntax.Coq_insn_cast (id0, castop0, typ0, value0, typ3) in
    (match c with
       | LLVMsyntax.Coq_insn_cast (id1, castop1, typ4, value2, typ5) ->
           let s = id_dec id5 id1 in
           if s
           then let s0 = castop_dec castop5 castop1 in
                if s0
                then let s1 = typ_dec typ1 typ4 in
                     if s1
                     then let s2 = value_dec value1 value2 in
                          if s2 then typ_dec typ2 typ5 else false
                     else false
                else false
           else false
       | _ -> false)
  
  (** val cmd_dec_subproof12 :
      LLVMsyntax.id -> LLVMsyntax.cond -> LLVMsyntax.typ -> LLVMsyntax.value
      -> LLVMsyntax.value -> LLVMsyntax.id -> LLVMsyntax.cond ->
      LLVMsyntax.typ -> LLVMsyntax.value -> LLVMsyntax.value -> bool **)
  
  let cmd_dec_subproof12 id5 cond5 typ5 value1 value2 id0 cond0 typ0 value0 value3 =
    let c = LLVMsyntax.Coq_insn_icmp (id0, cond0, typ0, value0, value3) in
    (match c with
       | LLVMsyntax.Coq_insn_icmp (id1, cond1, typ1, value4, value5) ->
           let s = id_dec id5 id1 in
           if s
           then let s0 = cond_dec cond5 cond1 in
                if s0
                then let s1 = typ_dec typ5 typ1 in
                     if s1
                     then let s2 = value_dec value1 value4 in
                          if s2 then value_dec value2 value5 else false
                     else false
                else false
           else false
       | _ -> false)
  
  (** val cmd_dec_subproof13 :
      LLVMsyntax.id -> LLVMsyntax.fcond -> LLVMsyntax.floating_point ->
      LLVMsyntax.value -> LLVMsyntax.value -> LLVMsyntax.id ->
      LLVMsyntax.fcond -> LLVMsyntax.floating_point -> LLVMsyntax.value ->
      LLVMsyntax.value -> bool **)
  
  let cmd_dec_subproof13 id5 fcond5 floating_point5 value1 value2 id0 fcond0 floating_point0 value0 value3 =
    let c = LLVMsyntax.Coq_insn_fcmp (id0, fcond0, floating_point0, value0,
      value3)
    in
    (match c with
       | LLVMsyntax.Coq_insn_fcmp
           (id1, fcond1, floating_point1, value4, value5) ->
           let s = id_dec id5 id1 in
           if s
           then let s0 = fcond_dec fcond5 fcond1 in
                if s0
                then let s1 =
                       floating_point_dec floating_point5 floating_point1
                     in
                     if s1
                     then let s2 = value_dec value1 value4 in
                          if s2 then value_dec value2 value5 else false
                     else false
                else false
           else false
       | _ -> false)
  
  (** val cmd_dec_subproof14 :
      LLVMsyntax.id -> LLVMsyntax.value -> LLVMsyntax.typ -> LLVMsyntax.value
      -> LLVMsyntax.value -> LLVMsyntax.id -> LLVMsyntax.value ->
      LLVMsyntax.typ -> LLVMsyntax.value -> LLVMsyntax.value -> bool **)
  
  let cmd_dec_subproof14 id5 value0 typ5 value1 value2 id0 value3 typ0 value4 value5 =
    let c = LLVMsyntax.Coq_insn_select (id0, value3, typ0, value4, value5) in
    (match c with
       | LLVMsyntax.Coq_insn_select (id1, value6, typ1, value7, value8) ->
           let s = id_dec id5 id1 in
           if s
           then let s0 = value_dec value0 value6 in
                if s0
                then let s1 = typ_dec typ5 typ1 in
                     if s1
                     then let s2 = value_dec value1 value7 in
                          if s2 then value_dec value2 value8 else false
                     else false
                else false
           else false
       | _ -> false)
  
  (** val cmd_dec : LLVMsyntax.cmd -> LLVMsyntax.cmd -> bool **)
  
  let cmd_dec c1 c2 =
    match c1 with
      | LLVMsyntax.Coq_insn_bop (id5, bop5, sz5, value1, value2) ->
          (match c2 with
             | LLVMsyntax.Coq_insn_bop (id0, bop0, sz0, value0, value3) ->
                 cmd_dec_subproof id5 bop5 sz5 value1 value2 id0 bop0 sz0
                   value0 value3
             | _ -> false)
      | LLVMsyntax.Coq_insn_fbop
          (id5, fbop5, floating_point5, value1, value2) ->
          (match c2 with
             | LLVMsyntax.Coq_insn_fbop
                 (id0, fbop0, floating_point0, value0, value3) ->
                 cmd_dec_subproof0 id5 fbop5 floating_point5 value1 value2
                   id0 fbop0 floating_point0 value0 value3
             | _ -> false)
      | LLVMsyntax.Coq_insn_extractvalue (id5, typ5, value5, l0, typ') ->
          (match c2 with
             | LLVMsyntax.Coq_insn_extractvalue
                 (id0, typ0, value0, l1, typ'0) ->
                 cmd_dec_subproof1 id5 typ5 value5 l0 typ' id0 typ0 value0 l1
                   typ'0
             | _ -> false)
      | LLVMsyntax.Coq_insn_insertvalue
          (id5, typ5, value5, typ', value', l0) ->
          (match c2 with
             | LLVMsyntax.Coq_insn_insertvalue
                 (id0, typ0, value0, typ'0, value'0, l1) ->
                 cmd_dec_subproof2 id5 typ5 value5 typ' value' l0 id0 typ0
                   value0 typ'0 value'0 l1
             | _ -> false)
      | LLVMsyntax.Coq_insn_malloc (id5, typ5, value5, align5) ->
          (match c2 with
             | LLVMsyntax.Coq_insn_malloc (id0, typ0, value0, align0) ->
                 cmd_dec_subproof3 id5 typ5 value5 align5 id0 typ0 value0
                   align0
             | _ -> false)
      | LLVMsyntax.Coq_insn_free (id5, typ5, value5) ->
          (match c2 with
             | LLVMsyntax.Coq_insn_free (id0, typ0, value0) ->
                 cmd_dec_subproof4 id5 typ5 value5 id0 typ0 value0
             | _ -> false)
      | LLVMsyntax.Coq_insn_alloca (id5, typ5, value5, align5) ->
          (match c2 with
             | LLVMsyntax.Coq_insn_alloca (id0, typ0, value0, align0) ->
                 cmd_dec_subproof5 id5 typ5 value5 align5 id0 typ0 value0
                   align0
             | _ -> false)
      | LLVMsyntax.Coq_insn_load (id5, typ5, value1, align5) ->
          (match c2 with
             | LLVMsyntax.Coq_insn_load (id0, typ0, value0, align0) ->
                 cmd_dec_subproof6 id5 typ5 value1 align5 id0 typ0 value0
                   align0
             | _ -> false)
      | LLVMsyntax.Coq_insn_store (id5, typ5, value1, value2, align5) ->
          (match c2 with
             | LLVMsyntax.Coq_insn_store
                 (id0, typ0, value0, value3, align0) ->
                 cmd_dec_subproof7 id5 typ5 value1 value2 align5 id0 typ0
                   value0 value3 align0
             | _ -> false)
      | LLVMsyntax.Coq_insn_gep (id5, inbounds5, typ5, value_5, l0, typ') ->
          (match c2 with
             | LLVMsyntax.Coq_insn_gep
                 (id0, inbounds0, typ0, value_0, l1, typ'0) ->
                 cmd_dec_subproof8 id5 inbounds5 typ5 value_5 l0 typ' id0
                   inbounds0 typ0 value_0 l1 typ'0
             | _ -> false)
      | LLVMsyntax.Coq_insn_trunc (id5, truncop5, typ1, value1, typ2) ->
          (match c2 with
             | LLVMsyntax.Coq_insn_trunc
                 (id0, truncop0, typ0, value0, typ3) ->
                 cmd_dec_subproof9 id5 truncop5 typ1 value1 typ2 id0 truncop0
                   typ0 value0 typ3
             | _ -> false)
      | LLVMsyntax.Coq_insn_ext (id5, extop5, typ1, value5, typ2) ->
          (match c2 with
             | LLVMsyntax.Coq_insn_ext (id0, extop0, typ0, value0, typ3) ->
                 cmd_dec_subproof10 id5 extop5 typ1 value5 typ2 id0 extop0
                   typ0 value0 typ3
             | _ -> false)
      | LLVMsyntax.Coq_insn_cast (id5, castop5, typ1, value1, typ2) ->
          (match c2 with
             | LLVMsyntax.Coq_insn_cast (id0, castop0, typ0, value0, typ3) ->
                 cmd_dec_subproof11 id5 castop5 typ1 value1 typ2 id0 castop0
                   typ0 value0 typ3
             | _ -> false)
      | LLVMsyntax.Coq_insn_icmp (id5, cond5, typ5, value1, value2) ->
          (match c2 with
             | LLVMsyntax.Coq_insn_icmp (id0, cond0, typ0, value0, value3) ->
                 cmd_dec_subproof12 id5 cond5 typ5 value1 value2 id0 cond0
                   typ0 value0 value3
             | _ -> false)
      | LLVMsyntax.Coq_insn_fcmp
          (id5, fcond5, floating_point5, value1, value2) ->
          (match c2 with
             | LLVMsyntax.Coq_insn_fcmp
                 (id0, fcond0, floating_point0, value0, value3) ->
                 cmd_dec_subproof13 id5 fcond5 floating_point5 value1 value2
                   id0 fcond0 floating_point0 value0 value3
             | _ -> false)
      | LLVMsyntax.Coq_insn_select (id5, value0, typ5, value1, value2) ->
          (match c2 with
             | LLVMsyntax.Coq_insn_select
                 (id0, value3, typ0, value4, value5) ->
                 cmd_dec_subproof14 id5 value0 typ5 value1 value2 id0 value3
                   typ0 value4 value5
             | _ -> false)
      | LLVMsyntax.Coq_insn_call
          (id5, noret5, clattrs5, typ5, varg5, value0, params5) ->
          (match c2 with
             | LLVMsyntax.Coq_insn_call
                 (id0, noret0, clattrs0, typ0, varg0, value1, params0) ->
                 let s = id_dec id5 id0 in
                 if s
                 then let s0 = value_dec value0 value1 in
                      if s0
                      then let s1 = noret_dec noret5 noret0 in
                           if s1
                           then let s2 = typ_dec typ5 typ0 in
                                if s2
                                then let s3 = varg_dec varg5 varg0 in
                                     if s3
                                     then let s4 = params_dec params5 params0
                                          in
                                          if s4
                                          then let LLVMsyntax.Coq_clattrs_intro
                                                 (tailc5, callconv5,
                                                  attributes1, attributes2) =
                                                 clattrs5
                                               in
                                               let LLVMsyntax.Coq_clattrs_intro
                                                 (tailc0, callconv0,
                                                  attributes0, attributes3) =
                                                 clattrs0
                                               in
                                               let s5 =
                                                 tailc_dec tailc5 tailc0
                                               in
                                               if s5
                                               then 
                                                 let s6 =
                                                  callconv_dec callconv5
                                                  callconv0
                                                 in
                                                 if s6
                                                 then 
                                                  let s7 =
                                                  attributes_dec attributes1
                                                  attributes0
                                                  in
                                                  if s7
                                                  then 
                                                  attributes_dec attributes2
                                                  attributes3
                                                  else false
                                                 else false
                                               else false
                                          else false
                                     else false
                                else false
                           else false
                      else false
                 else false
             | _ -> false)
  
  (** val terminator_dec_subproof :
      LLVMsyntax.id -> LLVMsyntax.typ -> LLVMsyntax.value -> LLVMsyntax.id ->
      LLVMsyntax.typ -> LLVMsyntax.value -> bool **)
  
  let terminator_dec_subproof id5 typ5 value5 id0 typ0 value0 =
    let t = LLVMsyntax.Coq_insn_return (id0, typ0, value0) in
    (match t with
       | LLVMsyntax.Coq_insn_return (id1, typ1, value1) ->
           let s = id_dec id5 id1 in
           if s
           then let s0 = typ_dec typ5 typ1 in
                if s0 then value_dec value5 value1 else false
           else false
       | _ -> false)
  
  (** val terminator_dec_subproof0 :
      LLVMsyntax.id -> LLVMsyntax.id -> bool **)
  
  let terminator_dec_subproof0 id5 id0 =
    let t = LLVMsyntax.Coq_insn_return_void id0 in
    (match t with
       | LLVMsyntax.Coq_insn_return_void id1 -> id_dec id5 id1
       | _ -> false)
  
  (** val terminator_dec_subproof1 :
      LLVMsyntax.id -> LLVMsyntax.value -> LLVMsyntax.l -> LLVMsyntax.l ->
      LLVMsyntax.id -> LLVMsyntax.value -> LLVMsyntax.l -> LLVMsyntax.l ->
      bool **)
  
  let terminator_dec_subproof1 id5 value5 l1 l2 id0 value0 l0 l3 =
    let t = LLVMsyntax.Coq_insn_br (id0, value0, l0, l3) in
    (match t with
       | LLVMsyntax.Coq_insn_br (id1, value1, l4, l5) ->
           let s = id_dec id5 id1 in
           if s
           then let s0 = value_dec value5 value1 in
                if s0
                then let s1 = id_dec l1 l4 in
                     if s1 then id_dec l2 l5 else false
                else false
           else false
       | _ -> false)
  
  (** val terminator_dec_subproof2 :
      LLVMsyntax.id -> LLVMsyntax.l -> LLVMsyntax.id -> LLVMsyntax.l -> bool **)
  
  let terminator_dec_subproof2 id5 l5 id0 l0 =
    let t = LLVMsyntax.Coq_insn_br_uncond (id0, l0) in
    (match t with
       | LLVMsyntax.Coq_insn_br_uncond (id1, l1) ->
           let s = id_dec id5 id1 in if s then id_dec l5 l1 else false
       | _ -> false)
  
  (** val terminator_dec_subproof3 :
      LLVMsyntax.id -> LLVMsyntax.id -> bool **)
  
  let terminator_dec_subproof3 id5 id0 =
    let t = LLVMsyntax.Coq_insn_unreachable id0 in
    (match t with
       | LLVMsyntax.Coq_insn_unreachable id1 -> id_dec id5 id1
       | _ -> false)
  
  (** val terminator_dec :
      LLVMsyntax.terminator -> LLVMsyntax.terminator -> bool **)
  
  let terminator_dec tmn1 tmn2 =
    match tmn1 with
      | LLVMsyntax.Coq_insn_return (id5, typ5, value5) ->
          (match tmn2 with
             | LLVMsyntax.Coq_insn_return (id0, typ0, value0) ->
                 terminator_dec_subproof id5 typ5 value5 id0 typ0 value0
             | _ -> false)
      | LLVMsyntax.Coq_insn_return_void id5 ->
          (match tmn2 with
             | LLVMsyntax.Coq_insn_return_void id0 ->
                 terminator_dec_subproof0 id5 id0
             | _ -> false)
      | LLVMsyntax.Coq_insn_br (id5, value5, l1, l2) ->
          (match tmn2 with
             | LLVMsyntax.Coq_insn_br (id0, value0, l0, l3) ->
                 terminator_dec_subproof1 id5 value5 l1 l2 id0 value0 l0 l3
             | _ -> false)
      | LLVMsyntax.Coq_insn_br_uncond (id5, l5) ->
          (match tmn2 with
             | LLVMsyntax.Coq_insn_br_uncond (id0, l0) ->
                 terminator_dec_subproof2 id5 l5 id0 l0
             | _ -> false)
      | LLVMsyntax.Coq_insn_unreachable id5 ->
          (match tmn2 with
             | LLVMsyntax.Coq_insn_unreachable id0 ->
                 terminator_dec_subproof3 id5 id0
             | _ -> false)
  
  (** val phinode_dec : LLVMsyntax.phinode -> LLVMsyntax.phinode -> bool **)
  
  let phinode_dec p1 p2 =
    let LLVMsyntax.Coq_insn_phi (id5, typ5, l0) = p1 in
    let LLVMsyntax.Coq_insn_phi (id1, typ1, l2) = p2 in
    let s = id_dec id5 id1 in
    if s
    then let s0 = typ_dec typ5 typ1 in
         if s0 then list_value_l_dec l0 l2 else false
    else false
  
  (** val insn_dec : LLVMsyntax.insn -> LLVMsyntax.insn -> bool **)
  
  let insn_dec i1 i2 =
    match i1 with
      | LLVMsyntax.Coq_insn_phinode phinode5 ->
          (match i2 with
             | LLVMsyntax.Coq_insn_phinode phinode0 ->
                 phinode_dec phinode5 phinode0
             | _ -> false)
      | LLVMsyntax.Coq_insn_cmd cmd5 ->
          (match i2 with
             | LLVMsyntax.Coq_insn_cmd cmd0 -> cmd_dec cmd5 cmd0
             | _ -> false)
      | LLVMsyntax.Coq_insn_terminator terminator5 ->
          (match i2 with
             | LLVMsyntax.Coq_insn_terminator terminator0 ->
                 terminator_dec terminator5 terminator0
             | _ -> false)
  
  (** val cmds_dec : LLVMsyntax.cmd list -> LLVMsyntax.cmd list -> bool **)
  
  let rec cmds_dec l0 cs2 =
    match l0 with
      | [] -> (match cs2 with
                 | [] -> true
                 | c::cs3 -> false)
      | y::l1 ->
          (match cs2 with
             | [] -> false
             | c::cs3 ->
                 let s = cmd_dec y c in if s then cmds_dec l1 cs3 else false)
  
  (** val phinodes_dec :
      LLVMsyntax.phinode list -> LLVMsyntax.phinode list -> bool **)
  
  let rec phinodes_dec l0 ps2 =
    match l0 with
      | [] -> (match ps2 with
                 | [] -> true
                 | p::ps3 -> false)
      | y::l1 ->
          (match ps2 with
             | [] -> false
             | p::ps3 ->
                 let s = phinode_dec y p in
                 if s then phinodes_dec l1 ps3 else false)
  
  (** val block_dec : LLVMsyntax.block -> LLVMsyntax.block -> bool **)
  
  let block_dec b1 b2 =
    let LLVMsyntax.Coq_block_intro (l5, phinodes5, cmds5, terminator5) = b1
    in
    let LLVMsyntax.Coq_block_intro (l0, phinodes0, cmds0, terminator0) = b2
    in
    let s = id_dec l5 l0 in
    if s
    then let s0 = phinodes_dec phinodes5 phinodes0 in
         if s0
         then let s1 = cmds_dec cmds5 cmds0 in
              if s1 then terminator_dec terminator5 terminator0 else false
         else false
    else false
  
  (** val arg_dec : LLVMsyntax.arg -> LLVMsyntax.arg -> bool **)
  
  let arg_dec a1 a2 =
    let p,i0 = a1 in
    let p0,i1 = a2 in
    let s = id_dec i0 i1 in
    if s
    then let t,a = p in
         let t0,a0 = p0 in
         let s0 = attributes_dec a a0 in if s0 then typ_dec t t0 else false
    else false
  
  (** val args_dec : LLVMsyntax.args -> LLVMsyntax.args -> bool **)
  
  let rec args_dec l0 l2 =
    match l0 with
      | [] -> (match l2 with
                 | [] -> true
                 | p::l3 -> false)
      | y::l1 ->
          (match l2 with
             | [] -> false
             | p::l3 ->
                 let s = arg_dec y p in if s then args_dec l1 l3 else false)
  
  (** val visibility_dec :
      LLVMsyntax.visibility -> LLVMsyntax.visibility -> bool **)
  
  let visibility_dec vb1 vb2 =
    LLVMsyntax.visibility_rect (fun vb0 ->
      match vb0 with
        | LLVMsyntax.Coq_visibility_default -> true
        | _ -> false) (fun vb0 ->
      match vb0 with
        | LLVMsyntax.Coq_visibility_hidden -> true
        | _ -> false) (fun vb0 ->
      match vb0 with
        | LLVMsyntax.Coq_visibility_protected -> true
        | _ -> false) vb1 vb2
  
  (** val linkage_dec : LLVMsyntax.linkage -> LLVMsyntax.linkage -> bool **)
  
  let linkage_dec lk1 lk2 =
    LLVMsyntax.linkage_rect (fun lk0 ->
      match lk0 with
        | LLVMsyntax.Coq_linkage_external -> true
        | _ -> false) (fun lk0 ->
      match lk0 with
        | LLVMsyntax.Coq_linkage_available_externally -> true
        | _ -> false) (fun lk0 ->
      match lk0 with
        | LLVMsyntax.Coq_linkage_link_once -> true
        | _ -> false) (fun lk0 ->
      match lk0 with
        | LLVMsyntax.Coq_linkage_link_once_odr -> true
        | _ -> false) (fun lk0 ->
      match lk0 with
        | LLVMsyntax.Coq_linkage_weak -> true
        | _ -> false) (fun lk0 ->
      match lk0 with
        | LLVMsyntax.Coq_linkage_weak_odr -> true
        | _ -> false) (fun lk0 ->
      match lk0 with
        | LLVMsyntax.Coq_linkage_appending -> true
        | _ -> false) (fun lk0 ->
      match lk0 with
        | LLVMsyntax.Coq_linkage_internal -> true
        | _ -> false) (fun lk0 ->
      match lk0 with
        | LLVMsyntax.Coq_linkage_private -> true
        | _ -> false) (fun lk0 ->
      match lk0 with
        | LLVMsyntax.Coq_linkage_linker_private -> true
        | _ -> false) (fun lk0 ->
      match lk0 with
        | LLVMsyntax.Coq_linkage_dllimport -> true
        | _ -> false) (fun lk0 ->
      match lk0 with
        | LLVMsyntax.Coq_linkage_dllexport -> true
        | _ -> false) (fun lk0 ->
      match lk0 with
        | LLVMsyntax.Coq_linkage_external_weak -> true
        | _ -> false) (fun lk0 ->
      match lk0 with
        | LLVMsyntax.Coq_linkage_ghost -> true
        | _ -> false) (fun lk0 ->
      match lk0 with
        | LLVMsyntax.Coq_linkage_common -> true
        | _ -> false) lk1 lk2
  
  (** val fheader_dec : LLVMsyntax.fheader -> LLVMsyntax.fheader -> bool **)
  
  let fheader_dec f1 f2 =
    let LLVMsyntax.Coq_fheader_intro (fnattrs5, typ5, id5, args5, varg5) = f1
    in
    let LLVMsyntax.Coq_fheader_intro (fnattrs0, typ0, id0, args0, varg0) = f2
    in
    let s = typ_dec typ5 typ0 in
    if s
    then let s0 = id_dec id5 id0 in
         if s0
         then let LLVMsyntax.Coq_fnattrs_intro
                (linkage5, visibility5, callconv5, attributes1, attributes2) =
                fnattrs5
              in
              let LLVMsyntax.Coq_fnattrs_intro
                (linkage0, visibility0, callconv0, attributes0, attributes3) =
                fnattrs0
              in
              let s1 = visibility_dec visibility5 visibility0 in
              if s1
              then let s2 = varg_dec varg5 varg0 in
                   if s2
                   then let s3 = attributes_dec attributes1 attributes0 in
                        if s3
                        then let s4 = attributes_dec attributes2 attributes3
                             in
                             if s4
                             then let s5 = callconv_dec callconv5 callconv0
                                  in
                                  if s5
                                  then let s6 = linkage_dec linkage5 linkage0
                                       in
                                       if s6
                                       then args_dec args5 args0
                                       else false
                                  else false
                             else false
                        else false
                   else false
              else false
         else false
    else false
  
  (** val blocks_dec : LLVMsyntax.blocks -> LLVMsyntax.blocks -> bool **)
  
  let rec blocks_dec l0 lb' =
    match l0 with
      | [] -> (match lb' with
                 | [] -> true
                 | b::lb'0 -> false)
      | y::l1 ->
          (match lb' with
             | [] -> false
             | b::lb'0 ->
                 let s = block_dec y b in
                 if s then blocks_dec l1 lb'0 else false)
  
  (** val intrinsic_id_dec :
      LLVMsyntax.intrinsic_id -> LLVMsyntax.intrinsic_id -> bool **)
  
  let intrinsic_id_dec iid1 iid2 =
    LLVMsyntax.intrinsic_id_rect (fun iid0 ->
      match iid0 with
        | LLVMsyntax.Coq_iid_expect -> true
        | _ -> false) (fun iid0 ->
      match iid0 with
        | LLVMsyntax.Coq_iid_setjmp -> true
        | _ -> false) (fun iid0 ->
      match iid0 with
        | LLVMsyntax.Coq_iid_sigsetjmp -> true
        | _ -> false) (fun iid0 ->
      match iid0 with
        | LLVMsyntax.Coq_iid_longjmp -> true
        | _ -> false) (fun iid0 ->
      match iid0 with
        | LLVMsyntax.Coq_iid_siglongjmp -> true
        | _ -> false) (fun iid0 ->
      match iid0 with
        | LLVMsyntax.Coq_iid_ctpop -> true
        | _ -> false) (fun iid0 ->
      match iid0 with
        | LLVMsyntax.Coq_iid_bswap -> true
        | _ -> false) (fun iid0 ->
      match iid0 with
        | LLVMsyntax.Coq_iid_ctlz -> true
        | _ -> false) (fun iid0 ->
      match iid0 with
        | LLVMsyntax.Coq_iid_cttz -> true
        | _ -> false) (fun iid0 ->
      match iid0 with
        | LLVMsyntax.Coq_iid_stacksave -> true
        | _ -> false) (fun iid0 ->
      match iid0 with
        | LLVMsyntax.Coq_iid_stackrestore -> true
        | _ -> false) (fun iid0 ->
      match iid0 with
        | LLVMsyntax.Coq_iid_returnaddress -> true
        | _ -> false) (fun iid0 ->
      match iid0 with
        | LLVMsyntax.Coq_iid_frameaddress -> true
        | _ -> false) (fun iid0 ->
      match iid0 with
        | LLVMsyntax.Coq_iid_prefetch -> true
        | _ -> false) (fun iid0 ->
      match iid0 with
        | LLVMsyntax.Coq_iid_pcmarker -> true
        | _ -> false) (fun iid0 ->
      match iid0 with
        | LLVMsyntax.Coq_iid_readcyclecounter -> true
        | _ -> false) (fun iid0 ->
      match iid0 with
        | LLVMsyntax.Coq_iid_dbg_declare -> true
        | _ -> false) (fun iid0 ->
      match iid0 with
        | LLVMsyntax.Coq_iid_eh_exception -> true
        | _ -> false) (fun iid0 ->
      match iid0 with
        | LLVMsyntax.Coq_iid_eh_selector -> true
        | _ -> false) (fun iid0 ->
      match iid0 with
        | LLVMsyntax.Coq_iid_eh_typeidfor -> true
        | _ -> false) (fun iid0 ->
      match iid0 with
        | LLVMsyntax.Coq_iid_var_annotation -> true
        | _ -> false) (fun iid0 ->
      match iid0 with
        | LLVMsyntax.Coq_iid_memcpy -> true
        | _ -> false) (fun iid0 ->
      match iid0 with
        | LLVMsyntax.Coq_iid_memmove -> true
        | _ -> false) (fun iid0 ->
      match iid0 with
        | LLVMsyntax.Coq_iid_memset -> true
        | _ -> false) (fun iid0 ->
      match iid0 with
        | LLVMsyntax.Coq_iid_sqrt -> true
        | _ -> false) (fun iid0 ->
      match iid0 with
        | LLVMsyntax.Coq_iid_log -> true
        | _ -> false) (fun iid0 ->
      match iid0 with
        | LLVMsyntax.Coq_iid_log2 -> true
        | _ -> false) (fun iid0 ->
      match iid0 with
        | LLVMsyntax.Coq_iid_log10 -> true
        | _ -> false) (fun iid0 ->
      match iid0 with
        | LLVMsyntax.Coq_iid_exp -> true
        | _ -> false) (fun iid0 ->
      match iid0 with
        | LLVMsyntax.Coq_iid_exp2 -> true
        | _ -> false) (fun iid0 ->
      match iid0 with
        | LLVMsyntax.Coq_iid_pow -> true
        | _ -> false) (fun iid0 ->
      match iid0 with
        | LLVMsyntax.Coq_iid_flt_rounds -> true
        | _ -> false) (fun iid0 ->
      match iid0 with
        | LLVMsyntax.Coq_iid_invariantstart -> true
        | _ -> false) (fun iid0 ->
      match iid0 with
        | LLVMsyntax.Coq_iid_lifetimestart -> true
        | _ -> false) (fun iid0 ->
      match iid0 with
        | LLVMsyntax.Coq_iid_invariantend -> true
        | _ -> false) (fun iid0 ->
      match iid0 with
        | LLVMsyntax.Coq_iid_lifetimeend -> true
        | _ -> false) (fun iid0 ->
      match iid0 with
        | LLVMsyntax.Coq_iid_unsupported -> true
        | _ -> false) iid1 iid2
  
  (** val external_id_dec :
      LLVMsyntax.external_id -> LLVMsyntax.external_id -> bool **)
  
  let external_id_dec eid1 eid2 =
    LLVMsyntax.external_id_rect (fun eid0 ->
      match eid0 with
        | LLVMsyntax.Coq_eid_malloc -> true
        | _ -> false) (fun eid0 ->
      match eid0 with
        | LLVMsyntax.Coq_eid_free -> true
        | _ -> false) (fun eid0 ->
      match eid0 with
        | LLVMsyntax.Coq_eid_io -> true
        | _ -> false) (fun eid0 ->
      match eid0 with
        | LLVMsyntax.Coq_eid_other -> true
        | _ -> false) eid1 eid2
  
  (** val deckind_dec : LLVMsyntax.deckind -> LLVMsyntax.deckind -> bool **)
  
  let deckind_dec dck1 dck2 =
    match dck1 with
      | LLVMsyntax.Coq_deckind_intrinsic iid1 ->
          (match dck2 with
             | LLVMsyntax.Coq_deckind_intrinsic iid2 ->
                 intrinsic_id_dec iid1 iid2
             | LLVMsyntax.Coq_deckind_external eid2 -> false)
      | LLVMsyntax.Coq_deckind_external eid1 ->
          (match dck2 with
             | LLVMsyntax.Coq_deckind_intrinsic iid2 -> false
             | LLVMsyntax.Coq_deckind_external eid2 ->
                 external_id_dec eid1 eid2)
  
  (** val fdec_dec : LLVMsyntax.fdec -> LLVMsyntax.fdec -> bool **)
  
  let fdec_dec f1 f2 =
    let LLVMsyntax.Coq_fdec_intro (fheader5, dck5) = f1 in
    let LLVMsyntax.Coq_fdec_intro (fheader0, dck0) = f2 in
    let s = deckind_dec dck5 dck0 in
    if s then fheader_dec fheader5 fheader0 else false
  
  (** val fdef_dec : LLVMsyntax.fdef -> LLVMsyntax.fdef -> bool **)
  
  let fdef_dec f1 f2 =
    let LLVMsyntax.Coq_fdef_intro (fheader5, blocks5) = f1 in
    let LLVMsyntax.Coq_fdef_intro (fheader0, blocks0) = f2 in
    let s = fheader_dec fheader5 fheader0 in
    if s then blocks_dec blocks5 blocks0 else false
  
  (** val gvar_spec_dec :
      LLVMsyntax.gvar_spec -> LLVMsyntax.gvar_spec -> bool **)
  
  let gvar_spec_dec g1 g2 =
    LLVMsyntax.gvar_spec_rect (fun g0 ->
      match g0 with
        | LLVMsyntax.Coq_gvar_spec_global -> true
        | LLVMsyntax.Coq_gvar_spec_constant -> false) (fun g0 ->
      match g0 with
        | LLVMsyntax.Coq_gvar_spec_global -> false
        | LLVMsyntax.Coq_gvar_spec_constant -> true) g1 g2
  
  (** val gvar_dec : LLVMsyntax.gvar -> LLVMsyntax.gvar -> bool **)
  
  let gvar_dec g1 g2 =
    match g1 with
      | LLVMsyntax.Coq_gvar_intro (i0, l0, g, t, c, a) ->
          (match g2 with
             | LLVMsyntax.Coq_gvar_intro (i1, l1, g0, t0, c0, a0) ->
                 let s = id_dec i0 i1 in
                 if s
                 then let s0 = linkage_dec l0 l1 in
                      if s0
                      then let s1 = gvar_spec_dec g g0 in
                           if s1
                           then let s2 = typ_dec t t0 in
                                if s2
                                then let s3 = const_dec c c0 in
                                     if s3 then Align.dec a a0 else false
                                else false
                           else false
                      else false
                 else false
             | LLVMsyntax.Coq_gvar_external (i1, g0, t0) -> false)
      | LLVMsyntax.Coq_gvar_external (i0, g, t) ->
          (match g2 with
             | LLVMsyntax.Coq_gvar_intro (i1, l1, g0, t0, c0, a0) -> false
             | LLVMsyntax.Coq_gvar_external (i1, g0, t0) ->
                 let s = id_dec i0 i1 in
                 if s
                 then let s0 = gvar_spec_dec g g0 in
                      if s0 then typ_dec t t0 else false
                 else false)
  
  (** val product_dec : LLVMsyntax.product -> LLVMsyntax.product -> bool **)
  
  let product_dec p p' =
    match p with
      | LLVMsyntax.Coq_product_gvar g ->
          (match p' with
             | LLVMsyntax.Coq_product_gvar g0 -> gvar_dec g g0
             | _ -> false)
      | LLVMsyntax.Coq_product_fdec f ->
          (match p' with
             | LLVMsyntax.Coq_product_fdec f0 -> fdec_dec f f0
             | _ -> false)
      | LLVMsyntax.Coq_product_fdef f ->
          (match p' with
             | LLVMsyntax.Coq_product_fdef f0 -> fdef_dec f f0
             | _ -> false)
  
  (** val products_dec :
      LLVMsyntax.products -> LLVMsyntax.products -> bool **)
  
  let rec products_dec l0 lp' =
    match l0 with
      | [] -> (match lp' with
                 | [] -> true
                 | p::lp'0 -> false)
      | y::l1 ->
          (match lp' with
             | [] -> false
             | p::lp'0 ->
                 let s = product_dec y p in
                 if s then products_dec l1 lp'0 else false)
  
  (** val namedt_dec : LLVMsyntax.namedt -> LLVMsyntax.namedt -> bool **)
  
  let namedt_dec nt1 nt2 =
    let id5,l0 = nt1 in
    let id0,l1 = nt2 in
    let s = id_dec id5 id0 in if s then list_typ_dec l0 l1 else false
  
  (** val namedts_dec : LLVMsyntax.namedts -> LLVMsyntax.namedts -> bool **)
  
  let rec namedts_dec l0 nts' =
    match l0 with
      | [] -> (match nts' with
                 | [] -> true
                 | n::nts'0 -> false)
      | y::l1 ->
          (match nts' with
             | [] -> false
             | n::nts'0 ->
                 let s = namedt_dec y n in
                 if s then namedts_dec l1 nts'0 else false)
  
  (** val layout_dec : LLVMsyntax.layout -> LLVMsyntax.layout -> bool **)
  
  let layout_dec l1 l2 =
    match l1 with
      | LLVMsyntax.Coq_layout_be ->
          (match l2 with
             | LLVMsyntax.Coq_layout_be -> true
             | _ -> false)
      | LLVMsyntax.Coq_layout_le ->
          (match l2 with
             | LLVMsyntax.Coq_layout_le -> true
             | _ -> false)
      | LLVMsyntax.Coq_layout_ptr (sz5, align0, align1) ->
          (match l2 with
             | LLVMsyntax.Coq_layout_ptr (sz0, align2, align3) ->
                 let l0 = LLVMsyntax.Coq_layout_ptr (sz0, align2, align3) in
                 (match l0 with
                    | LLVMsyntax.Coq_layout_ptr (sz1, align4, align5) ->
                        let s = Size.dec sz5 sz1 in
                        if s
                        then let s0 = Align.dec align0 align4 in
                             if s0 then Align.dec align1 align5 else false
                        else false
                    | _ -> false)
             | _ -> false)
      | LLVMsyntax.Coq_layout_int (sz5, align0, align1) ->
          (match l2 with
             | LLVMsyntax.Coq_layout_int (sz0, align2, align3) ->
                 let l0 = LLVMsyntax.Coq_layout_int (sz0, align2, align3) in
                 (match l0 with
                    | LLVMsyntax.Coq_layout_int (sz1, align4, align5) ->
                        let s = Size.dec sz5 sz1 in
                        if s
                        then let s0 = Align.dec align0 align4 in
                             if s0 then Align.dec align1 align5 else false
                        else false
                    | _ -> false)
             | _ -> false)
      | LLVMsyntax.Coq_layout_float (sz5, align0, align1) ->
          (match l2 with
             | LLVMsyntax.Coq_layout_float (sz0, align2, align3) ->
                 let l0 = LLVMsyntax.Coq_layout_float (sz0, align2, align3)
                 in
                 (match l0 with
                    | LLVMsyntax.Coq_layout_float (
                        sz1, align4, align5) ->
                        let s = Size.dec sz5 sz1 in
                        if s
                        then let s0 = Align.dec align0 align4 in
                             if s0 then Align.dec align1 align5 else false
                        else false
                    | _ -> false)
             | _ -> false)
      | LLVMsyntax.Coq_layout_aggr (sz5, align0, align1) ->
          (match l2 with
             | LLVMsyntax.Coq_layout_aggr (sz0, align2, align3) ->
                 let l0 = LLVMsyntax.Coq_layout_aggr (sz0, align2, align3) in
                 (match l0 with
                    | LLVMsyntax.Coq_layout_aggr (sz1, align4, align5) ->
                        let s = Size.dec sz5 sz1 in
                        if s
                        then let s0 = Align.dec align0 align4 in
                             if s0 then Align.dec align1 align5 else false
                        else false
                    | _ -> false)
             | _ -> false)
      | LLVMsyntax.Coq_layout_stack (sz5, align0, align1) ->
          (match l2 with
             | LLVMsyntax.Coq_layout_stack (sz0, align2, align3) ->
                 let l0 = LLVMsyntax.Coq_layout_stack (sz0, align2, align3)
                 in
                 (match l0 with
                    | LLVMsyntax.Coq_layout_stack (
                        sz1, align4, align5) ->
                        let s = Size.dec sz5 sz1 in
                        if s
                        then let s0 = Align.dec align0 align4 in
                             if s0 then Align.dec align1 align5 else false
                        else false
                    | _ -> false)
             | _ -> false)
      | LLVMsyntax.Coq_layout_vector (sz5, align0, align1) ->
          (match l2 with
             | LLVMsyntax.Coq_layout_vector (sz0, align2, align3) ->
                 let l0 = LLVMsyntax.Coq_layout_vector (sz0, align2, align3)
                 in
                 (match l0 with
                    | LLVMsyntax.Coq_layout_vector (
                        sz1, align4, align5) ->
                        let s = Size.dec sz5 sz1 in
                        if s
                        then let s0 = Align.dec align0 align4 in
                             if s0 then Align.dec align1 align5 else false
                        else false
                    | _ -> false)
             | _ -> false)
  
  (** val layouts_dec : LLVMsyntax.layouts -> LLVMsyntax.layouts -> bool **)
  
  let rec layouts_dec l0 l2 =
    match l0 with
      | [] -> (match l2 with
                 | [] -> true
                 | l1::l3 -> false)
      | y::l1 ->
          (match l2 with
             | [] -> false
             | l3::l4 ->
                 let s = layout_dec y l3 in
                 if s then layouts_dec l1 l4 else false)
  
  (** val module_dec :
      LLVMsyntax.coq_module -> LLVMsyntax.coq_module -> bool **)
  
  let module_dec m m' =
    let LLVMsyntax.Coq_module_intro (l0, n, p) = m in
    let LLVMsyntax.Coq_module_intro (l1, n0, p0) = m' in
    let s = layouts_dec l0 l1 in
    if s
    then let s0 = namedts_dec n n0 in if s0 then products_dec p p0 else false
    else false
  
  (** val modules_dec : LLVMsyntax.modules -> LLVMsyntax.modules -> bool **)
  
  let rec modules_dec l0 lm' =
    match l0 with
      | [] -> (match lm' with
                 | [] -> true
                 | m::lm'0 -> false)
      | y::l1 ->
          (match lm' with
             | [] -> false
             | m::lm'0 ->
                 let s = module_dec y m in
                 if s then modules_dec l1 lm'0 else false)
  
  (** val system_dec : LLVMsyntax.system -> LLVMsyntax.system -> bool **)
  
  let system_dec =
    modules_dec
  
  (** val typEqB : LLVMsyntax.typ -> LLVMsyntax.typ -> bool **)
  
  let typEqB t1 t2 =
    sumbool2bool (typ_dec t1 t2)
  
  (** val list_typEqB :
      LLVMsyntax.typ list -> LLVMsyntax.typ list -> bool **)
  
  let list_typEqB lt1 lt2 =
    sumbool2bool (list_typ_dec lt1 lt2)
  
  (** val idEqB : LLVMsyntax.id -> LLVMsyntax.id -> bool **)
  
  let idEqB i0 i' =
    sumbool2bool (id_dec i0 i')
  
  (** val constEqB : LLVMsyntax.const -> LLVMsyntax.const -> bool **)
  
  let constEqB c1 c2 =
    sumbool2bool (const_dec c1 c2)
  
  (** val list_constEqB :
      LLVMsyntax.const list -> LLVMsyntax.const list -> bool **)
  
  let list_constEqB lc1 lc2 =
    sumbool2bool (list_const_dec lc1 lc2)
  
  (** val valueEqB : LLVMsyntax.value -> LLVMsyntax.value -> bool **)
  
  let valueEqB v v' =
    sumbool2bool (value_dec v v')
  
  (** val paramsEqB : LLVMsyntax.params -> LLVMsyntax.params -> bool **)
  
  let paramsEqB lp lp' =
    sumbool2bool (params_dec lp lp')
  
  (** val lEqB : LLVMsyntax.l -> LLVMsyntax.l -> bool **)
  
  let lEqB i0 i' =
    sumbool2bool (l_dec i0 i')
  
  (** val list_value_lEqB :
      (LLVMsyntax.value*LLVMsyntax.l) list -> (LLVMsyntax.value*LLVMsyntax.l)
      list -> bool **)
  
  let list_value_lEqB idls idls' =
    sumbool2bool (list_value_l_dec idls idls')
  
  (** val list_valueEqB :
      (LLVMsyntax.sz*LLVMsyntax.value) list ->
      (LLVMsyntax.sz*LLVMsyntax.value) list -> bool **)
  
  let list_valueEqB idxs idxs' =
    sumbool2bool (list_value_dec idxs idxs')
  
  (** val bopEqB : LLVMsyntax.bop -> LLVMsyntax.bop -> bool **)
  
  let bopEqB op op' =
    sumbool2bool (bop_dec op op')
  
  (** val extopEqB : LLVMsyntax.extop -> LLVMsyntax.extop -> bool **)
  
  let extopEqB op op' =
    sumbool2bool (extop_dec op op')
  
  (** val condEqB : LLVMsyntax.cond -> LLVMsyntax.cond -> bool **)
  
  let condEqB c c' =
    sumbool2bool (cond_dec c c')
  
  (** val castopEqB : LLVMsyntax.castop -> LLVMsyntax.castop -> bool **)
  
  let castopEqB c c' =
    sumbool2bool (castop_dec c c')
  
  (** val cmdEqB : LLVMsyntax.cmd -> LLVMsyntax.cmd -> bool **)
  
  let cmdEqB i0 i' =
    sumbool2bool (cmd_dec i0 i')
  
  (** val cmdsEqB : LLVMsyntax.cmd list -> LLVMsyntax.cmd list -> bool **)
  
  let cmdsEqB cs1 cs2 =
    sumbool2bool (cmds_dec cs1 cs2)
  
  (** val terminatorEqB :
      LLVMsyntax.terminator -> LLVMsyntax.terminator -> bool **)
  
  let terminatorEqB i0 i' =
    sumbool2bool (terminator_dec i0 i')
  
  (** val phinodeEqB : LLVMsyntax.phinode -> LLVMsyntax.phinode -> bool **)
  
  let phinodeEqB i0 i' =
    sumbool2bool (phinode_dec i0 i')
  
  (** val phinodesEqB :
      LLVMsyntax.phinode list -> LLVMsyntax.phinode list -> bool **)
  
  let phinodesEqB ps1 ps2 =
    sumbool2bool (phinodes_dec ps1 ps2)
  
  (** val blockEqB : LLVMsyntax.block -> LLVMsyntax.block -> bool **)
  
  let blockEqB b1 b2 =
    sumbool2bool (block_dec b1 b2)
  
  (** val blocksEqB : LLVMsyntax.blocks -> LLVMsyntax.blocks -> bool **)
  
  let blocksEqB lb lb' =
    sumbool2bool (blocks_dec lb lb')
  
  (** val argsEqB : LLVMsyntax.args -> LLVMsyntax.args -> bool **)
  
  let argsEqB la la' =
    sumbool2bool (args_dec la la')
  
  (** val fheaderEqB : LLVMsyntax.fheader -> LLVMsyntax.fheader -> bool **)
  
  let fheaderEqB fh fh' =
    sumbool2bool (fheader_dec fh fh')
  
  (** val fdecEqB : LLVMsyntax.fdec -> LLVMsyntax.fdec -> bool **)
  
  let fdecEqB fd fd' =
    sumbool2bool (fdec_dec fd fd')
  
  (** val fdefEqB : LLVMsyntax.fdef -> LLVMsyntax.fdef -> bool **)
  
  let fdefEqB fd fd' =
    sumbool2bool (fdef_dec fd fd')
  
  (** val gvarEqB : LLVMsyntax.gvar -> LLVMsyntax.gvar -> bool **)
  
  let gvarEqB gv gv' =
    sumbool2bool (gvar_dec gv gv')
  
  (** val productEqB : LLVMsyntax.product -> LLVMsyntax.product -> bool **)
  
  let productEqB p p' =
    sumbool2bool (product_dec p p')
  
  (** val productsEqB :
      LLVMsyntax.products -> LLVMsyntax.products -> bool **)
  
  let productsEqB lp lp' =
    sumbool2bool (products_dec lp lp')
  
  (** val layoutEqB : LLVMsyntax.layout -> LLVMsyntax.layout -> bool **)
  
  let layoutEqB o o' =
    sumbool2bool (layout_dec o o')
  
  (** val layoutsEqB : LLVMsyntax.layouts -> LLVMsyntax.layouts -> bool **)
  
  let layoutsEqB lo lo' =
    sumbool2bool (layouts_dec lo lo')
  
  (** val moduleEqB :
      LLVMsyntax.coq_module -> LLVMsyntax.coq_module -> bool **)
  
  let moduleEqB m m' =
    sumbool2bool (module_dec m m')
  
  (** val modulesEqB : LLVMsyntax.modules -> LLVMsyntax.modules -> bool **)
  
  let modulesEqB lm lm' =
    sumbool2bool (modules_dec lm lm')
  
  (** val systemEqB : LLVMsyntax.system -> LLVMsyntax.system -> bool **)
  
  let systemEqB s s' =
    sumbool2bool (system_dec s s')
  
  (** val attributeEqB :
      LLVMsyntax.attribute -> LLVMsyntax.attribute -> bool **)
  
  let attributeEqB attr attr' =
    sumbool2bool (attribute_dec attr attr')
  
  (** val attributesEqB :
      LLVMsyntax.attributes -> LLVMsyntax.attributes -> bool **)
  
  let attributesEqB attrs attrs' =
    sumbool2bool (attributes_dec attrs attrs')
  
  (** val linkageEqB : LLVMsyntax.linkage -> LLVMsyntax.linkage -> bool **)
  
  let linkageEqB lk lk' =
    sumbool2bool (linkage_dec lk lk')
  
  (** val visibilityEqB :
      LLVMsyntax.visibility -> LLVMsyntax.visibility -> bool **)
  
  let visibilityEqB v v' =
    sumbool2bool (visibility_dec v v')
  
  (** val callconvEqB :
      LLVMsyntax.callconv -> LLVMsyntax.callconv -> bool **)
  
  let callconvEqB cc cc' =
    sumbool2bool (callconv_dec cc cc')
  
  (** val coq_InCmdsB : LLVMsyntax.cmd -> LLVMsyntax.cmds -> bool **)
  
  let rec coq_InCmdsB i0 = function
    | [] -> false
    | i'::li' -> if cmdEqB i0 i' then true else coq_InCmdsB i0 li'
  
  (** val coq_InPhiNodesB :
      LLVMsyntax.phinode -> LLVMsyntax.phinodes -> bool **)
  
  let rec coq_InPhiNodesB i0 = function
    | [] -> false
    | i'::li' -> if phinodeEqB i0 i' then true else coq_InPhiNodesB i0 li'
  
  (** val cmdInBlockB : LLVMsyntax.cmd -> LLVMsyntax.block -> bool **)
  
  let cmdInBlockB i0 = function
    | LLVMsyntax.Coq_block_intro (l0, phinodes5, cmds0, terminator5) ->
        coq_InCmdsB i0 cmds0
  
  (** val phinodeInBlockB :
      LLVMsyntax.phinode -> LLVMsyntax.block -> bool **)
  
  let phinodeInBlockB i0 = function
    | LLVMsyntax.Coq_block_intro (l0, ps, cmds5, terminator5) ->
        coq_InPhiNodesB i0 ps
  
  (** val terminatorInBlockB :
      LLVMsyntax.terminator -> LLVMsyntax.block -> bool **)
  
  let terminatorInBlockB i0 = function
    | LLVMsyntax.Coq_block_intro (l0, phinodes5, cmds5, t) ->
        terminatorEqB i0 t
  
  (** val coq_InArgsB : LLVMsyntax.arg -> LLVMsyntax.args -> bool **)
  
  let rec coq_InArgsB a = function
    | [] -> false
    | a'::la' ->
        if let p,id0 = a in
           let t,attrs = p in
           let p0,id' = a' in
           let t',attrs' = p0 in
           if if typEqB t t' then attributesEqB attrs attrs' else false
           then idEqB id0 id'
           else false
        then true
        else coq_InArgsB a la'
  
  (** val argInFheaderB : LLVMsyntax.arg -> LLVMsyntax.fheader -> bool **)
  
  let argInFheaderB a = function
    | LLVMsyntax.Coq_fheader_intro (fnattrs5, t, id0, la, varg5) ->
        coq_InArgsB a la
  
  (** val argInFdecB : LLVMsyntax.arg -> LLVMsyntax.fdec -> bool **)
  
  let argInFdecB a = function
    | LLVMsyntax.Coq_fdec_intro (fh, deckind5) -> argInFheaderB a fh
  
  (** val argInFdefB : LLVMsyntax.arg -> LLVMsyntax.fdef -> bool **)
  
  let argInFdefB a = function
    | LLVMsyntax.Coq_fdef_intro (fh, lb) -> argInFheaderB a fh
  
  (** val coq_InBlocksB : LLVMsyntax.block -> LLVMsyntax.blocks -> bool **)
  
  let rec coq_InBlocksB b = function
    | [] -> false
    | b'::lb' -> if blockEqB b b' then true else coq_InBlocksB b lb'
  
  (** val blockInFdefB : LLVMsyntax.block -> LLVMsyntax.fdef -> bool **)
  
  let blockInFdefB b = function
    | LLVMsyntax.Coq_fdef_intro (fh, lb) -> coq_InBlocksB b lb
  
  (** val coq_InProductsB :
      LLVMsyntax.product -> LLVMsyntax.products -> bool **)
  
  let rec coq_InProductsB p = function
    | [] -> false
    | p'::lp' -> if productEqB p p' then true else coq_InProductsB p lp'
  
  (** val productInModuleB :
      LLVMsyntax.product -> LLVMsyntax.coq_module -> bool **)
  
  let productInModuleB p = function
    | LLVMsyntax.Coq_module_intro (os, nts, ps) -> coq_InProductsB p ps
  
  (** val coq_InModulesB :
      LLVMsyntax.coq_module -> LLVMsyntax.modules -> bool **)
  
  let rec coq_InModulesB m = function
    | [] -> false
    | m'::lm' -> if moduleEqB m m' then true else coq_InModulesB m lm'
  
  (** val moduleInSystemB :
      LLVMsyntax.coq_module -> LLVMsyntax.system -> bool **)
  
  let moduleInSystemB m s =
    coq_InModulesB m s
  
  (** val productInSystemModuleB :
      LLVMsyntax.product -> LLVMsyntax.system -> LLVMsyntax.coq_module ->
      bool **)
  
  let productInSystemModuleB p s m =
    if moduleInSystemB m s then productInModuleB p m else false
  
  (** val blockInSystemModuleFdefB :
      LLVMsyntax.block -> LLVMsyntax.system -> LLVMsyntax.coq_module ->
      LLVMsyntax.fdef -> bool **)
  
  let blockInSystemModuleFdefB b s m f =
    if blockInFdefB b f
    then productInSystemModuleB (LLVMsyntax.Coq_product_fdef f) s m
    else false
  
  (** val cmdInSystemModuleFdefBlockB :
      LLVMsyntax.cmd -> LLVMsyntax.system -> LLVMsyntax.coq_module ->
      LLVMsyntax.fdef -> LLVMsyntax.block -> bool **)
  
  let cmdInSystemModuleFdefBlockB i0 s m f b =
    if cmdInBlockB i0 b then blockInSystemModuleFdefB b s m f else false
  
  (** val phinodeInSystemModuleFdefBlockB :
      LLVMsyntax.phinode -> LLVMsyntax.system -> LLVMsyntax.coq_module ->
      LLVMsyntax.fdef -> LLVMsyntax.block -> bool **)
  
  let phinodeInSystemModuleFdefBlockB i0 s m f b =
    if phinodeInBlockB i0 b then blockInSystemModuleFdefB b s m f else false
  
  (** val terminatorInSystemModuleFdefBlockB :
      LLVMsyntax.terminator -> LLVMsyntax.system -> LLVMsyntax.coq_module ->
      LLVMsyntax.fdef -> LLVMsyntax.block -> bool **)
  
  let terminatorInSystemModuleFdefBlockB i0 s m f b =
    if terminatorInBlockB i0 b
    then blockInSystemModuleFdefB b s m f
    else false
  
  (** val insnInSystemModuleFdefBlockB :
      LLVMsyntax.insn -> LLVMsyntax.system -> LLVMsyntax.coq_module ->
      LLVMsyntax.fdef -> LLVMsyntax.block -> bool **)
  
  let insnInSystemModuleFdefBlockB i0 s m f b =
    match i0 with
      | LLVMsyntax.Coq_insn_phinode p ->
          phinodeInSystemModuleFdefBlockB p s m f b
      | LLVMsyntax.Coq_insn_cmd c -> cmdInSystemModuleFdefBlockB c s m f b
      | LLVMsyntax.Coq_insn_terminator t ->
          terminatorInSystemModuleFdefBlockB t s m f b
  
  (** val insnInBlockB : LLVMsyntax.insn -> LLVMsyntax.block -> bool **)
  
  let insnInBlockB i0 b =
    match i0 with
      | LLVMsyntax.Coq_insn_phinode p -> phinodeInBlockB p b
      | LLVMsyntax.Coq_insn_cmd c -> cmdInBlockB c b
      | LLVMsyntax.Coq_insn_terminator t -> terminatorInBlockB t b
  
  (** val cmdInFdefBlockB :
      LLVMsyntax.cmd -> LLVMsyntax.fdef -> LLVMsyntax.block -> bool **)
  
  let cmdInFdefBlockB i0 f b =
    if cmdInBlockB i0 b then blockInFdefB b f else false
  
  (** val phinodeInFdefBlockB :
      LLVMsyntax.phinode -> LLVMsyntax.fdef -> LLVMsyntax.block -> bool **)
  
  let phinodeInFdefBlockB i0 f b =
    if phinodeInBlockB i0 b then blockInFdefB b f else false
  
  (** val terminatorInFdefBlockB :
      LLVMsyntax.terminator -> LLVMsyntax.fdef -> LLVMsyntax.block -> bool **)
  
  let terminatorInFdefBlockB i0 f b =
    if terminatorInBlockB i0 b then blockInFdefB b f else false
  
  (** val insnInFdefBlockB :
      LLVMsyntax.insn -> LLVMsyntax.fdef -> LLVMsyntax.block -> bool **)
  
  let insnInFdefBlockB i0 f b =
    match i0 with
      | LLVMsyntax.Coq_insn_phinode p ->
          if phinodeInBlockB p b then blockInFdefB b f else false
      | LLVMsyntax.Coq_insn_cmd c ->
          if cmdInBlockB c b then blockInFdefB b f else false
      | LLVMsyntax.Coq_insn_terminator t ->
          if terminatorInBlockB t b then blockInFdefB b f else false
  
  (** val cmdInBlockB_dec : LLVMsyntax.cmd -> LLVMsyntax.block -> bool **)
  
  let cmdInBlockB_dec i0 b =
    let b0 = cmdInBlockB i0 b in if b0 then true else false
  
  (** val phinodeInBlockB_dec :
      LLVMsyntax.phinode -> LLVMsyntax.block -> bool **)
  
  let phinodeInBlockB_dec i0 b =
    let b0 = phinodeInBlockB i0 b in if b0 then true else false
  
  (** val terminatorInBlockB_dec :
      LLVMsyntax.terminator -> LLVMsyntax.block -> bool **)
  
  let terminatorInBlockB_dec i0 b =
    let b0 = terminatorInBlockB i0 b in if b0 then true else false
  
  (** val getParentOfCmdFromBlocks :
      LLVMsyntax.cmd -> LLVMsyntax.blocks -> LLVMsyntax.block option **)
  
  let rec getParentOfCmdFromBlocks i0 = function
    | [] -> None
    | b::lb' ->
        if cmdInBlockB_dec i0 b
        then Some b
        else getParentOfCmdFromBlocks i0 lb'
  
  (** val getParentOfCmdFromFdef :
      LLVMsyntax.cmd -> LLVMsyntax.fdef -> LLVMsyntax.block option **)
  
  let getParentOfCmdFromFdef i0 = function
    | LLVMsyntax.Coq_fdef_intro (fheader5, lb) ->
        getParentOfCmdFromBlocks i0 lb
  
  (** val getParentOfCmdFromProduct :
      LLVMsyntax.cmd -> LLVMsyntax.product -> LLVMsyntax.block option **)
  
  let getParentOfCmdFromProduct i0 = function
    | LLVMsyntax.Coq_product_fdef fd -> getParentOfCmdFromFdef i0 fd
    | _ -> None
  
  (** val getParentOfCmdFromProducts :
      LLVMsyntax.cmd -> LLVMsyntax.products -> LLVMsyntax.block option **)
  
  let rec getParentOfCmdFromProducts i0 = function
    | [] -> None
    | p::lp' ->
        (match getParentOfCmdFromProduct i0 p with
           | Some b -> Some b
           | None -> getParentOfCmdFromProducts i0 lp')
  
  (** val getParentOfCmdFromModule :
      LLVMsyntax.cmd -> LLVMsyntax.coq_module -> LLVMsyntax.block option **)
  
  let getParentOfCmdFromModule i0 = function
    | LLVMsyntax.Coq_module_intro (os, nts, ps) ->
        getParentOfCmdFromProducts i0 ps
  
  (** val getParentOfCmdFromModules :
      LLVMsyntax.cmd -> LLVMsyntax.modules -> LLVMsyntax.block option **)
  
  let rec getParentOfCmdFromModules i0 = function
    | [] -> None
    | m::lm' ->
        (match getParentOfCmdFromModule i0 m with
           | Some b -> Some b
           | None -> getParentOfCmdFromModules i0 lm')
  
  (** val getParentOfCmdFromSystem :
      LLVMsyntax.cmd -> LLVMsyntax.system -> LLVMsyntax.block option **)
  
  let getParentOfCmdFromSystem i0 s =
    getParentOfCmdFromModules i0 s
  
  (** val cmdHasParent : LLVMsyntax.cmd -> LLVMsyntax.system -> bool **)
  
  let cmdHasParent i0 s =
    match getParentOfCmdFromSystem i0 s with
      | Some b -> true
      | None -> false
  
  (** val getParentOfPhiNodeFromBlocks :
      LLVMsyntax.phinode -> LLVMsyntax.blocks -> LLVMsyntax.block option **)
  
  let rec getParentOfPhiNodeFromBlocks i0 = function
    | [] -> None
    | b::lb' ->
        if phinodeInBlockB_dec i0 b
        then Some b
        else getParentOfPhiNodeFromBlocks i0 lb'
  
  (** val getParentOfPhiNodeFromFdef :
      LLVMsyntax.phinode -> LLVMsyntax.fdef -> LLVMsyntax.block option **)
  
  let getParentOfPhiNodeFromFdef i0 = function
    | LLVMsyntax.Coq_fdef_intro (fheader5, lb) ->
        getParentOfPhiNodeFromBlocks i0 lb
  
  (** val getParentOfPhiNodeFromProduct :
      LLVMsyntax.phinode -> LLVMsyntax.product -> LLVMsyntax.block option **)
  
  let getParentOfPhiNodeFromProduct i0 = function
    | LLVMsyntax.Coq_product_fdef fd -> getParentOfPhiNodeFromFdef i0 fd
    | _ -> None
  
  (** val getParentOfPhiNodeFromProducts :
      LLVMsyntax.phinode -> LLVMsyntax.products -> LLVMsyntax.block option **)
  
  let rec getParentOfPhiNodeFromProducts i0 = function
    | [] -> None
    | p::lp' ->
        (match getParentOfPhiNodeFromProduct i0 p with
           | Some b -> Some b
           | None -> getParentOfPhiNodeFromProducts i0 lp')
  
  (** val getParentOfPhiNodeFromModule :
      LLVMsyntax.phinode -> LLVMsyntax.coq_module -> LLVMsyntax.block option **)
  
  let getParentOfPhiNodeFromModule i0 = function
    | LLVMsyntax.Coq_module_intro (os, nts, ps) ->
        getParentOfPhiNodeFromProducts i0 ps
  
  (** val getParentOfPhiNodeFromModules :
      LLVMsyntax.phinode -> LLVMsyntax.modules -> LLVMsyntax.block option **)
  
  let rec getParentOfPhiNodeFromModules i0 = function
    | [] -> None
    | m::lm' ->
        (match getParentOfPhiNodeFromModule i0 m with
           | Some b -> Some b
           | None -> getParentOfPhiNodeFromModules i0 lm')
  
  (** val getParentOfPhiNodeFromSystem :
      LLVMsyntax.phinode -> LLVMsyntax.system -> LLVMsyntax.block option **)
  
  let getParentOfPhiNodeFromSystem i0 s =
    getParentOfPhiNodeFromModules i0 s
  
  (** val phinodeHasParent :
      LLVMsyntax.phinode -> LLVMsyntax.system -> bool **)
  
  let phinodeHasParent i0 s =
    match getParentOfPhiNodeFromSystem i0 s with
      | Some b -> true
      | None -> false
  
  (** val getParentOfTerminatorFromBlocks :
      LLVMsyntax.terminator -> LLVMsyntax.blocks -> LLVMsyntax.block option **)
  
  let rec getParentOfTerminatorFromBlocks i0 = function
    | [] -> None
    | b::lb' ->
        if terminatorInBlockB_dec i0 b
        then Some b
        else getParentOfTerminatorFromBlocks i0 lb'
  
  (** val getParentOfTerminatorFromFdef :
      LLVMsyntax.terminator -> LLVMsyntax.fdef -> LLVMsyntax.block option **)
  
  let getParentOfTerminatorFromFdef i0 = function
    | LLVMsyntax.Coq_fdef_intro (fheader5, lb) ->
        getParentOfTerminatorFromBlocks i0 lb
  
  (** val getParentOfTerminatorFromProduct :
      LLVMsyntax.terminator -> LLVMsyntax.product -> LLVMsyntax.block option **)
  
  let getParentOfTerminatorFromProduct i0 = function
    | LLVMsyntax.Coq_product_fdef fd -> getParentOfTerminatorFromFdef i0 fd
    | _ -> None
  
  (** val getParentOfTerminatorFromProducts :
      LLVMsyntax.terminator -> LLVMsyntax.products -> LLVMsyntax.block option **)
  
  let rec getParentOfTerminatorFromProducts i0 = function
    | [] -> None
    | p::lp' ->
        (match getParentOfTerminatorFromProduct i0 p with
           | Some b -> Some b
           | None -> getParentOfTerminatorFromProducts i0 lp')
  
  (** val getParentOfTerminatorFromModule :
      LLVMsyntax.terminator -> LLVMsyntax.coq_module -> LLVMsyntax.block
      option **)
  
  let getParentOfTerminatorFromModule i0 = function
    | LLVMsyntax.Coq_module_intro (os, nts, ps) ->
        getParentOfTerminatorFromProducts i0 ps
  
  (** val getParentOfTerminatorFromModules :
      LLVMsyntax.terminator -> LLVMsyntax.modules -> LLVMsyntax.block option **)
  
  let rec getParentOfTerminatorFromModules i0 = function
    | [] -> None
    | m::lm' ->
        (match getParentOfTerminatorFromModule i0 m with
           | Some b -> Some b
           | None -> getParentOfTerminatorFromModules i0 lm')
  
  (** val getParentOfTerminatorFromSystem :
      LLVMsyntax.terminator -> LLVMsyntax.system -> LLVMsyntax.block option **)
  
  let getParentOfTerminatorFromSystem i0 s =
    getParentOfTerminatorFromModules i0 s
  
  (** val terminatoreHasParent :
      LLVMsyntax.terminator -> LLVMsyntax.system -> bool **)
  
  let terminatoreHasParent i0 s =
    match getParentOfTerminatorFromSystem i0 s with
      | Some b -> true
      | None -> false
  
  (** val productInModuleB_dec :
      LLVMsyntax.product -> LLVMsyntax.coq_module -> bool **)
  
  let productInModuleB_dec b m =
    let b0 = productInModuleB b m in if b0 then true else false
  
  (** val getParentOfFdefFromModules :
      LLVMsyntax.fdef -> LLVMsyntax.modules -> LLVMsyntax.coq_module option **)
  
  let rec getParentOfFdefFromModules fd = function
    | [] -> None
    | m::lm' ->
        if productInModuleB_dec (LLVMsyntax.Coq_product_fdef fd) m
        then Some m
        else getParentOfFdefFromModules fd lm'
  
  (** val getParentOfFdefFromSystem :
      LLVMsyntax.fdef -> LLVMsyntax.system -> LLVMsyntax.coq_module option **)
  
  let getParentOfFdefFromSystem fd s =
    getParentOfFdefFromModules fd s
  
  (** val lookupIdsViaLabelFromIdls :
      (LLVMsyntax.value*LLVMsyntax.l) list -> LLVMsyntax.l -> LLVMsyntax.id
      list **)
  
  let rec lookupIdsViaLabelFromIdls idls l0 =
    match idls with
      | [] -> []
      | p::idls' ->
          let v,l1 = p in
          (match v with
             | LLVMsyntax.Coq_value_id id1 ->
                 if eq_dec (coq_EqDec_eq_of_EqDec coq_EqDec_atom) l0 l1
                 then set_add (eq_dec (coq_EqDec_eq_of_EqDec coq_EqDec_atom))
                        id1 (lookupIdsViaLabelFromIdls idls' l0)
                 else lookupIdsViaLabelFromIdls idls' l0
             | LLVMsyntax.Coq_value_const const5 ->
                 lookupIdsViaLabelFromIdls idls' l0)
  
  module type SigValue = 
   sig 
    val getNumOperands : LLVMsyntax.insn -> nat
   end
  
  module type SigUser = 
   sig 
    val getNumOperands : LLVMsyntax.insn -> nat
   end
  
  module type SigConstant = 
   sig 
    val getNumOperands : LLVMsyntax.insn -> nat
    
    val getTyp : LLVMsyntax.const -> LLVMsyntax.typ option
   end
  
  module type SigGlobalValue = 
   sig 
    val getNumOperands : LLVMsyntax.insn -> nat
    
    val getTyp : LLVMsyntax.const -> LLVMsyntax.typ option
   end
  
  module type SigFunction = 
   sig 
    val getNumOperands : LLVMsyntax.insn -> nat
    
    val getTyp : LLVMsyntax.const -> LLVMsyntax.typ option
    
    val getDefReturnType : LLVMsyntax.fdef -> LLVMsyntax.typ
    
    val getDefFunctionType : LLVMsyntax.fdef -> LLVMsyntax.typ
    
    val def_arg_size : LLVMsyntax.fdef -> nat
    
    val getDecReturnType : LLVMsyntax.fdec -> LLVMsyntax.typ
    
    val getDecFunctionType : LLVMsyntax.fdec -> LLVMsyntax.typ
    
    val dec_arg_size : LLVMsyntax.fdec -> nat
   end
  
  module type SigInstruction = 
   sig 
    val getNumOperands : LLVMsyntax.insn -> nat
    
    val isCallInst : LLVMsyntax.cmd -> bool
   end
  
  module type SigReturnInst = 
   sig 
    val getNumOperands : LLVMsyntax.insn -> nat
    
    val isCallInst : LLVMsyntax.cmd -> bool
    
    val hasReturnType : LLVMsyntax.terminator -> bool
    
    val getReturnType : LLVMsyntax.terminator -> LLVMsyntax.typ option
   end
  
  module type SigCallSite = 
   sig 
    val getFdefTyp : LLVMsyntax.fdef -> LLVMsyntax.typ
    
    val arg_size : LLVMsyntax.fdef -> nat
    
    val getArgument : LLVMsyntax.fdef -> nat -> LLVMsyntax.arg option
    
    val getArgumentType : LLVMsyntax.fdef -> nat -> LLVMsyntax.typ option
   end
  
  module type SigCallInst = 
   sig 
    val getNumOperands : LLVMsyntax.insn -> nat
    
    val isCallInst : LLVMsyntax.cmd -> bool
   end
  
  module type SigBinaryOperator = 
   sig 
    val getNumOperands : LLVMsyntax.insn -> nat
    
    val isCallInst : LLVMsyntax.cmd -> bool
    
    val getFirstOperandType :
      LLVMsyntax.fdef -> LLVMsyntax.cmd -> LLVMsyntax.typ option
    
    val getSecondOperandType :
      LLVMsyntax.fdef -> LLVMsyntax.cmd -> LLVMsyntax.typ option
    
    val getResultType : LLVMsyntax.cmd -> LLVMsyntax.typ option
   end
  
  module type SigPHINode = 
   sig 
    val getNumOperands : LLVMsyntax.insn -> nat
    
    val isCallInst : LLVMsyntax.cmd -> bool
    
    val getNumIncomingValues : LLVMsyntax.phinode -> nat
    
    val getIncomingValueType :
      LLVMsyntax.fdef -> LLVMsyntax.phinode -> LLVMsyntax.i -> LLVMsyntax.typ
      option
   end
  
  module type SigType = 
   sig 
    val isIntOrIntVector : LLVMsyntax.typ -> bool
    
    val isInteger : LLVMsyntax.typ -> bool
    
    val isSized : LLVMsyntax.typ -> bool
    
    val getPrimitiveSizeInBits : LLVMsyntax.typ -> LLVMsyntax.sz
   end
  
  module type SigDerivedType = 
   sig 
    val isIntOrIntVector : LLVMsyntax.typ -> bool
    
    val isInteger : LLVMsyntax.typ -> bool
    
    val isSized : LLVMsyntax.typ -> bool
    
    val getPrimitiveSizeInBits : LLVMsyntax.typ -> LLVMsyntax.sz
   end
  
  module type SigFunctionType = 
   sig 
    val isIntOrIntVector : LLVMsyntax.typ -> bool
    
    val isInteger : LLVMsyntax.typ -> bool
    
    val isSized : LLVMsyntax.typ -> bool
    
    val getPrimitiveSizeInBits : LLVMsyntax.typ -> LLVMsyntax.sz
    
    val getNumParams : LLVMsyntax.typ -> nat option
    
    val isVarArg : LLVMsyntax.typ -> bool
    
    val getParamType : LLVMsyntax.typ -> nat -> LLVMsyntax.typ option
   end
  
  module type SigCompositeType = 
   sig 
    val isIntOrIntVector : LLVMsyntax.typ -> bool
    
    val isInteger : LLVMsyntax.typ -> bool
    
    val isSized : LLVMsyntax.typ -> bool
    
    val getPrimitiveSizeInBits : LLVMsyntax.typ -> LLVMsyntax.sz
   end
  
  module type SigSequentialType = 
   sig 
    val isIntOrIntVector : LLVMsyntax.typ -> bool
    
    val isInteger : LLVMsyntax.typ -> bool
    
    val isSized : LLVMsyntax.typ -> bool
    
    val getPrimitiveSizeInBits : LLVMsyntax.typ -> LLVMsyntax.sz
    
    val hasElementType : LLVMsyntax.typ -> bool
    
    val getElementType : LLVMsyntax.typ -> LLVMsyntax.typ option
   end
  
  module type SigArrayType = 
   sig 
    val isIntOrIntVector : LLVMsyntax.typ -> bool
    
    val isInteger : LLVMsyntax.typ -> bool
    
    val isSized : LLVMsyntax.typ -> bool
    
    val getPrimitiveSizeInBits : LLVMsyntax.typ -> LLVMsyntax.sz
    
    val hasElementType : LLVMsyntax.typ -> bool
    
    val getElementType : LLVMsyntax.typ -> LLVMsyntax.typ option
    
    val getNumElements : LLVMsyntax.typ -> nat
   end
  
  module Value = 
   struct 
    (** val getNumOperands : LLVMsyntax.insn -> nat **)
    
    let getNumOperands i0 =
      length (getInsnOperands i0)
   end
  
  module User = 
   struct 
    (** val getNumOperands : LLVMsyntax.insn -> nat **)
    
    let getNumOperands i0 =
      length (getInsnOperands i0)
   end
  
  module Constant = 
   struct 
    (** val getNumOperands : LLVMsyntax.insn -> nat **)
    
    let getNumOperands i0 =
      length (getInsnOperands i0)
    
    (** val getTyp : LLVMsyntax.const -> LLVMsyntax.typ option **)
    
    let rec getTyp = function
      | LLVMsyntax.Coq_const_zeroinitializer t -> Some t
      | LLVMsyntax.Coq_const_int (sz0, int5) -> Some (LLVMsyntax.Coq_typ_int
          sz0)
      | LLVMsyntax.Coq_const_floatpoint (fp, float5) -> Some
          (LLVMsyntax.Coq_typ_floatpoint fp)
      | LLVMsyntax.Coq_const_undef t -> Some t
      | LLVMsyntax.Coq_const_null t -> Some (LLVMsyntax.Coq_typ_pointer t)
      | LLVMsyntax.Coq_const_arr (t, lc) -> Some
          (match lc with
             | [] -> LLVMsyntax.Coq_typ_array (Size.coq_Zero, t)
             | c'::lc' -> LLVMsyntax.Coq_typ_array
                 ((Size.from_nat (length lc)), t))
      | LLVMsyntax.Coq_const_struct (t, lc) -> Some t
      | LLVMsyntax.Coq_const_gid (t, id5) -> Some (LLVMsyntax.Coq_typ_pointer
          t)
      | LLVMsyntax.Coq_const_truncop (truncop5, const5, t) -> Some t
      | LLVMsyntax.Coq_const_extop (extop5, const5, t) -> Some t
      | LLVMsyntax.Coq_const_castop (castop5, const5, t) -> Some t
      | LLVMsyntax.Coq_const_gep (inbounds5, c0, idxs) ->
          (match getTyp c0 with
             | Some t -> getConstGEPTyp idxs t
             | None -> None)
      | LLVMsyntax.Coq_const_select (c0, c1, c2) -> getTyp c1
      | LLVMsyntax.Coq_const_extractvalue (c0, idxs) ->
          (match getTyp c0 with
             | Some t -> getSubTypFromConstIdxs idxs t
             | None -> None)
      | LLVMsyntax.Coq_const_insertvalue (c0, c', lc) -> getTyp c0
      | LLVMsyntax.Coq_const_bop (bop5, c1, c2) -> getTyp c1
      | LLVMsyntax.Coq_const_fbop (fbop5, c1, c2) -> getTyp c1
      | _ -> Some (LLVMsyntax.Coq_typ_int Size.coq_One)
    
    (** val gen_utyps_maps_aux_ :
        (LLVMsyntax.id -> (LLVMsyntax.id*LLVMsyntax.typ) list ->
        LLVMsyntax.typ -> LLVMsyntax.typ option) -> LLVMsyntax.id ->
        (LLVMsyntax.id*LLVMsyntax.typ) list -> LLVMsyntax.typ list ->
        LLVMsyntax.typ list option **)
    
    let rec gen_utyps_maps_aux_ gen_utyp_maps_aux0 cid m = function
      | [] -> Some []
      | t0::ts0 ->
          mbind (fun ut0 ->
            mbind (fun uts0 -> Some (ut0::uts0))
              (gen_utyps_maps_aux_ gen_utyp_maps_aux0 cid m ts0))
            (gen_utyp_maps_aux0 cid m t0)
    
    (** val gen_utyp_maps_aux :
        LLVMsyntax.id -> (LLVMsyntax.id*LLVMsyntax.typ) list ->
        LLVMsyntax.typ -> LLVMsyntax.typ option **)
    
    let rec gen_utyp_maps_aux cid m t = match t with
      | LLVMsyntax.Coq_typ_array (s, t0) ->
          mbind (fun ut0 -> Some (LLVMsyntax.Coq_typ_array (s, ut0)))
            (gen_utyp_maps_aux cid m t0)
      | LLVMsyntax.Coq_typ_function (t0, ts0, va) ->
          mbind (fun ut0 ->
            mbind (fun uts0 -> Some (LLVMsyntax.Coq_typ_function (ut0, uts0,
              va))) (gen_utyps_maps_aux_ gen_utyp_maps_aux cid m ts0))
            (gen_utyp_maps_aux cid m t0)
      | LLVMsyntax.Coq_typ_struct ts0 ->
          mbind (fun uts0 -> Some (LLVMsyntax.Coq_typ_struct uts0))
            (gen_utyps_maps_aux_ gen_utyp_maps_aux cid m ts0)
      | LLVMsyntax.Coq_typ_pointer t0 ->
          (match gen_utyp_maps_aux cid m t0 with
             | Some ut0 -> Some (LLVMsyntax.Coq_typ_pointer ut0)
             | None ->
                 (match t0 with
                    | LLVMsyntax.Coq_typ_namedt i0 ->
                        if AtomImpl.eq_atom_dec i0 cid then Some t else None
                    | _ -> None))
      | LLVMsyntax.Coq_typ_namedt i0 -> lookupAL m i0
      | x -> Some x
    
    (** val gen_utyps_maps_aux :
        LLVMsyntax.id -> (LLVMsyntax.id*LLVMsyntax.typ) list ->
        LLVMsyntax.typ list -> LLVMsyntax.typ list option **)
    
    let gen_utyps_maps_aux =
      gen_utyps_maps_aux_ gen_utyp_maps_aux
    
    (** val gen_utyp_maps :
        LLVMsyntax.namedts -> (LLVMsyntax.id*LLVMsyntax.typ) list **)
    
    let rec gen_utyp_maps = function
      | [] -> []
      | n::nts' ->
          let id0,t = n in
          let results = gen_utyp_maps nts' in
          (match gen_utyp_maps_aux id0 results (LLVMsyntax.Coq_typ_struct t) with
             | Some r -> (id0,r)::results
             | None -> results)
    
    (** val typs2utyps_aux_ :
        ((LLVMsyntax.id*LLVMsyntax.typ) list -> LLVMsyntax.typ ->
        LLVMsyntax.typ option) -> (LLVMsyntax.id*LLVMsyntax.typ) list ->
        LLVMsyntax.typ list -> LLVMsyntax.typ list option **)
    
    let rec typs2utyps_aux_ typ2utyp_aux0 m = function
      | [] -> Some []
      | t0::ts0 ->
          mbind (fun ut0 ->
            mbind (fun uts0 -> Some (ut0::uts0))
              (typs2utyps_aux_ typ2utyp_aux0 m ts0)) 
            (typ2utyp_aux0 m t0)
    
    (** val typ2utyp_aux :
        (LLVMsyntax.id*LLVMsyntax.typ) list -> LLVMsyntax.typ ->
        LLVMsyntax.typ option **)
    
    let rec typ2utyp_aux m = function
      | LLVMsyntax.Coq_typ_array (s, t0) ->
          mbind (fun ut0 -> Some (LLVMsyntax.Coq_typ_array (s, ut0)))
            (typ2utyp_aux m t0)
      | LLVMsyntax.Coq_typ_function (t0, ts0, va) ->
          mbind (fun ut0 ->
            mbind (fun uts0 -> Some (LLVMsyntax.Coq_typ_function (ut0, uts0,
              va))) (typs2utyps_aux_ typ2utyp_aux m ts0)) 
            (typ2utyp_aux m t0)
      | LLVMsyntax.Coq_typ_struct ts0 ->
          mbind (fun uts0 -> Some (LLVMsyntax.Coq_typ_struct uts0))
            (typs2utyps_aux_ typ2utyp_aux m ts0)
      | LLVMsyntax.Coq_typ_pointer t0 ->
          mbind (fun ut0 -> Some (LLVMsyntax.Coq_typ_pointer ut0))
            (typ2utyp_aux m t0)
      | LLVMsyntax.Coq_typ_namedt i0 -> lookupAL m i0
      | x -> Some x
    
    (** val typs2utyps_aux :
        (LLVMsyntax.id*LLVMsyntax.typ) list -> LLVMsyntax.typ list ->
        LLVMsyntax.typ list option **)
    
    let typs2utyps_aux =
      typs2utyps_aux_ typ2utyp_aux
    
    (** val typ2utyp' :
        LLVMsyntax.namedts -> LLVMsyntax.typ -> LLVMsyntax.typ option **)
    
    let typ2utyp' nts t =
      let m = gen_utyp_maps (rev nts) in typ2utyp_aux m t
    
    (** val subst_typ :
        LLVMsyntax.id -> LLVMsyntax.typ -> LLVMsyntax.typ -> LLVMsyntax.typ **)
    
    let rec subst_typ i' t' t =
      let subst_typs =
        let rec subst_typs i'0 t'0 = function
          | [] -> []
          | t0::ts0 ->
              (subst_typ i'0 t'0 t0)::(Obj.magic subst_typs i'0 t'0 ts0)
        in subst_typs
      in
      (match t with
         | LLVMsyntax.Coq_typ_array (s, t0) -> LLVMsyntax.Coq_typ_array (s,
             (subst_typ i' t' t0))
         | LLVMsyntax.Coq_typ_function (t0, ts0, va) ->
             LLVMsyntax.Coq_typ_function ((subst_typ i' t' t0),
             (subst_typs i' t' ts0), va)
         | LLVMsyntax.Coq_typ_struct ts0 -> LLVMsyntax.Coq_typ_struct
             (subst_typs i' t' ts0)
         | LLVMsyntax.Coq_typ_pointer t0 -> LLVMsyntax.Coq_typ_pointer
             (subst_typ i' t' t0)
         | LLVMsyntax.Coq_typ_namedt i0 ->
             if AtomImpl.eq_atom_dec i0 i' then t' else t
         | _ -> t)
    
    (** val subst_typ_by_nts :
        LLVMsyntax.namedts -> LLVMsyntax.typ -> LLVMsyntax.typ **)
    
    let rec subst_typ_by_nts nts t =
      match nts with
        | [] -> t
        | n::nts' ->
            let id',ts' = n in
            subst_typ_by_nts nts'
              (subst_typ id' (LLVMsyntax.Coq_typ_struct ts') t)
    
    (** val subst_nts_by_nts :
        LLVMsyntax.namedts -> LLVMsyntax.namedts ->
        (LLVMsyntax.id*LLVMsyntax.typ) list **)
    
    let rec subst_nts_by_nts nts0 = function
      | [] -> []
      | n::nts' ->
          let id',t' = n in
          (id',(subst_typ_by_nts nts0 (LLVMsyntax.Coq_typ_struct t')))::
          (subst_nts_by_nts nts0 nts')
    
    (** val typ2utyp :
        LLVMsyntax.namedts -> LLVMsyntax.typ -> LLVMsyntax.typ option **)
    
    let typ2utyp nts t =
      let m = subst_nts_by_nts nts nts in typ2utyp_aux m t
   end
  
  module GlobalValue = 
   struct 
    (** val getNumOperands : LLVMsyntax.insn -> nat **)
    
    let getNumOperands i0 =
      length (getInsnOperands i0)
    
    (** val getTyp : LLVMsyntax.const -> LLVMsyntax.typ option **)
    
    let rec getTyp = function
      | LLVMsyntax.Coq_const_zeroinitializer t -> Some t
      | LLVMsyntax.Coq_const_int (sz0, int5) -> Some (LLVMsyntax.Coq_typ_int
          sz0)
      | LLVMsyntax.Coq_const_floatpoint (fp, float5) -> Some
          (LLVMsyntax.Coq_typ_floatpoint fp)
      | LLVMsyntax.Coq_const_undef t -> Some t
      | LLVMsyntax.Coq_const_null t -> Some (LLVMsyntax.Coq_typ_pointer t)
      | LLVMsyntax.Coq_const_arr (t, lc) -> Some
          (match lc with
             | [] -> LLVMsyntax.Coq_typ_array (Size.coq_Zero, t)
             | c'::lc' -> LLVMsyntax.Coq_typ_array
                 ((Size.from_nat (length lc)), t))
      | LLVMsyntax.Coq_const_struct (t, lc) -> Some t
      | LLVMsyntax.Coq_const_gid (t, id5) -> Some (LLVMsyntax.Coq_typ_pointer
          t)
      | LLVMsyntax.Coq_const_truncop (truncop5, const5, t) -> Some t
      | LLVMsyntax.Coq_const_extop (extop5, const5, t) -> Some t
      | LLVMsyntax.Coq_const_castop (castop5, const5, t) -> Some t
      | LLVMsyntax.Coq_const_gep (inbounds5, c0, idxs) ->
          (match getTyp c0 with
             | Some t -> getConstGEPTyp idxs t
             | None -> None)
      | LLVMsyntax.Coq_const_select (c0, c1, c2) -> getTyp c1
      | LLVMsyntax.Coq_const_extractvalue (c0, idxs) ->
          (match getTyp c0 with
             | Some t -> getSubTypFromConstIdxs idxs t
             | None -> None)
      | LLVMsyntax.Coq_const_insertvalue (c0, c', lc) -> getTyp c0
      | LLVMsyntax.Coq_const_bop (bop5, c1, c2) -> getTyp c1
      | LLVMsyntax.Coq_const_fbop (fbop5, c1, c2) -> getTyp c1
      | _ -> Some (LLVMsyntax.Coq_typ_int Size.coq_One)
    
    (** val gen_utyps_maps_aux_ :
        (LLVMsyntax.id -> (LLVMsyntax.id*LLVMsyntax.typ) list ->
        LLVMsyntax.typ -> LLVMsyntax.typ option) -> LLVMsyntax.id ->
        (LLVMsyntax.id*LLVMsyntax.typ) list -> LLVMsyntax.typ list ->
        LLVMsyntax.typ list option **)
    
    let rec gen_utyps_maps_aux_ gen_utyp_maps_aux0 cid m = function
      | [] -> Some []
      | t0::ts0 ->
          mbind (fun ut0 ->
            mbind (fun uts0 -> Some (ut0::uts0))
              (gen_utyps_maps_aux_ gen_utyp_maps_aux0 cid m ts0))
            (gen_utyp_maps_aux0 cid m t0)
    
    (** val gen_utyp_maps_aux :
        LLVMsyntax.id -> (LLVMsyntax.id*LLVMsyntax.typ) list ->
        LLVMsyntax.typ -> LLVMsyntax.typ option **)
    
    let rec gen_utyp_maps_aux cid m t = match t with
      | LLVMsyntax.Coq_typ_array (s, t0) ->
          mbind (fun ut0 -> Some (LLVMsyntax.Coq_typ_array (s, ut0)))
            (gen_utyp_maps_aux cid m t0)
      | LLVMsyntax.Coq_typ_function (t0, ts0, va) ->
          mbind (fun ut0 ->
            mbind (fun uts0 -> Some (LLVMsyntax.Coq_typ_function (ut0, uts0,
              va))) (gen_utyps_maps_aux_ gen_utyp_maps_aux cid m ts0))
            (gen_utyp_maps_aux cid m t0)
      | LLVMsyntax.Coq_typ_struct ts0 ->
          mbind (fun uts0 -> Some (LLVMsyntax.Coq_typ_struct uts0))
            (gen_utyps_maps_aux_ gen_utyp_maps_aux cid m ts0)
      | LLVMsyntax.Coq_typ_pointer t0 ->
          (match gen_utyp_maps_aux cid m t0 with
             | Some ut0 -> Some (LLVMsyntax.Coq_typ_pointer ut0)
             | None ->
                 (match t0 with
                    | LLVMsyntax.Coq_typ_namedt i0 ->
                        if AtomImpl.eq_atom_dec i0 cid then Some t else None
                    | _ -> None))
      | LLVMsyntax.Coq_typ_namedt i0 -> lookupAL m i0
      | x -> Some x
    
    (** val gen_utyps_maps_aux :
        LLVMsyntax.id -> (LLVMsyntax.id*LLVMsyntax.typ) list ->
        LLVMsyntax.typ list -> LLVMsyntax.typ list option **)
    
    let gen_utyps_maps_aux =
      gen_utyps_maps_aux_ gen_utyp_maps_aux
    
    (** val gen_utyp_maps :
        LLVMsyntax.namedts -> (LLVMsyntax.id*LLVMsyntax.typ) list **)
    
    let rec gen_utyp_maps = function
      | [] -> []
      | n::nts' ->
          let id0,t = n in
          let results = gen_utyp_maps nts' in
          (match gen_utyp_maps_aux id0 results (LLVMsyntax.Coq_typ_struct t) with
             | Some r -> (id0,r)::results
             | None -> results)
    
    (** val typs2utyps_aux_ :
        ((LLVMsyntax.id*LLVMsyntax.typ) list -> LLVMsyntax.typ ->
        LLVMsyntax.typ option) -> (LLVMsyntax.id*LLVMsyntax.typ) list ->
        LLVMsyntax.typ list -> LLVMsyntax.typ list option **)
    
    let rec typs2utyps_aux_ typ2utyp_aux0 m = function
      | [] -> Some []
      | t0::ts0 ->
          mbind (fun ut0 ->
            mbind (fun uts0 -> Some (ut0::uts0))
              (typs2utyps_aux_ typ2utyp_aux0 m ts0)) 
            (typ2utyp_aux0 m t0)
    
    (** val typ2utyp_aux :
        (LLVMsyntax.id*LLVMsyntax.typ) list -> LLVMsyntax.typ ->
        LLVMsyntax.typ option **)
    
    let rec typ2utyp_aux m = function
      | LLVMsyntax.Coq_typ_array (s, t0) ->
          mbind (fun ut0 -> Some (LLVMsyntax.Coq_typ_array (s, ut0)))
            (typ2utyp_aux m t0)
      | LLVMsyntax.Coq_typ_function (t0, ts0, va) ->
          mbind (fun ut0 ->
            mbind (fun uts0 -> Some (LLVMsyntax.Coq_typ_function (ut0, uts0,
              va))) (typs2utyps_aux_ typ2utyp_aux m ts0)) 
            (typ2utyp_aux m t0)
      | LLVMsyntax.Coq_typ_struct ts0 ->
          mbind (fun uts0 -> Some (LLVMsyntax.Coq_typ_struct uts0))
            (typs2utyps_aux_ typ2utyp_aux m ts0)
      | LLVMsyntax.Coq_typ_pointer t0 ->
          mbind (fun ut0 -> Some (LLVMsyntax.Coq_typ_pointer ut0))
            (typ2utyp_aux m t0)
      | LLVMsyntax.Coq_typ_namedt i0 -> lookupAL m i0
      | x -> Some x
    
    (** val typs2utyps_aux :
        (LLVMsyntax.id*LLVMsyntax.typ) list -> LLVMsyntax.typ list ->
        LLVMsyntax.typ list option **)
    
    let typs2utyps_aux =
      typs2utyps_aux_ typ2utyp_aux
    
    (** val typ2utyp' :
        LLVMsyntax.namedts -> LLVMsyntax.typ -> LLVMsyntax.typ option **)
    
    let typ2utyp' nts t =
      let m = gen_utyp_maps (rev nts) in typ2utyp_aux m t
    
    (** val subst_typ :
        LLVMsyntax.id -> LLVMsyntax.typ -> LLVMsyntax.typ -> LLVMsyntax.typ **)
    
    let rec subst_typ i' t' t =
      let subst_typs =
        let rec subst_typs i'0 t'0 = function
          | [] -> []
          | t0::ts0 ->
              (subst_typ i'0 t'0 t0)::(Obj.magic subst_typs i'0 t'0 ts0)
        in subst_typs
      in
      (match t with
         | LLVMsyntax.Coq_typ_array (s, t0) -> LLVMsyntax.Coq_typ_array (s,
             (subst_typ i' t' t0))
         | LLVMsyntax.Coq_typ_function (t0, ts0, va) ->
             LLVMsyntax.Coq_typ_function ((subst_typ i' t' t0),
             (subst_typs i' t' ts0), va)
         | LLVMsyntax.Coq_typ_struct ts0 -> LLVMsyntax.Coq_typ_struct
             (subst_typs i' t' ts0)
         | LLVMsyntax.Coq_typ_pointer t0 -> LLVMsyntax.Coq_typ_pointer
             (subst_typ i' t' t0)
         | LLVMsyntax.Coq_typ_namedt i0 ->
             if AtomImpl.eq_atom_dec i0 i' then t' else t
         | _ -> t)
    
    (** val subst_typ_by_nts :
        LLVMsyntax.namedts -> LLVMsyntax.typ -> LLVMsyntax.typ **)
    
    let rec subst_typ_by_nts nts t =
      match nts with
        | [] -> t
        | n::nts' ->
            let id',ts' = n in
            subst_typ_by_nts nts'
              (subst_typ id' (LLVMsyntax.Coq_typ_struct ts') t)
    
    (** val subst_nts_by_nts :
        LLVMsyntax.namedts -> LLVMsyntax.namedts ->
        (LLVMsyntax.id*LLVMsyntax.typ) list **)
    
    let rec subst_nts_by_nts nts0 = function
      | [] -> []
      | n::nts' ->
          let id',t' = n in
          (id',(subst_typ_by_nts nts0 (LLVMsyntax.Coq_typ_struct t')))::
          (subst_nts_by_nts nts0 nts')
    
    (** val typ2utyp :
        LLVMsyntax.namedts -> LLVMsyntax.typ -> LLVMsyntax.typ option **)
    
    let typ2utyp nts t =
      let m = subst_nts_by_nts nts nts in typ2utyp_aux m t
   end
  
  module Function = 
   struct 
    (** val getNumOperands : LLVMsyntax.insn -> nat **)
    
    let getNumOperands i0 =
      length (getInsnOperands i0)
    
    (** val getTyp : LLVMsyntax.const -> LLVMsyntax.typ option **)
    
    let rec getTyp = function
      | LLVMsyntax.Coq_const_zeroinitializer t -> Some t
      | LLVMsyntax.Coq_const_int (sz0, int5) -> Some (LLVMsyntax.Coq_typ_int
          sz0)
      | LLVMsyntax.Coq_const_floatpoint (fp, float5) -> Some
          (LLVMsyntax.Coq_typ_floatpoint fp)
      | LLVMsyntax.Coq_const_undef t -> Some t
      | LLVMsyntax.Coq_const_null t -> Some (LLVMsyntax.Coq_typ_pointer t)
      | LLVMsyntax.Coq_const_arr (t, lc) -> Some
          (match lc with
             | [] -> LLVMsyntax.Coq_typ_array (Size.coq_Zero, t)
             | c'::lc' -> LLVMsyntax.Coq_typ_array
                 ((Size.from_nat (length lc)), t))
      | LLVMsyntax.Coq_const_struct (t, lc) -> Some t
      | LLVMsyntax.Coq_const_gid (t, id5) -> Some (LLVMsyntax.Coq_typ_pointer
          t)
      | LLVMsyntax.Coq_const_truncop (truncop5, const5, t) -> Some t
      | LLVMsyntax.Coq_const_extop (extop5, const5, t) -> Some t
      | LLVMsyntax.Coq_const_castop (castop5, const5, t) -> Some t
      | LLVMsyntax.Coq_const_gep (inbounds5, c0, idxs) ->
          (match getTyp c0 with
             | Some t -> getConstGEPTyp idxs t
             | None -> None)
      | LLVMsyntax.Coq_const_select (c0, c1, c2) -> getTyp c1
      | LLVMsyntax.Coq_const_extractvalue (c0, idxs) ->
          (match getTyp c0 with
             | Some t -> getSubTypFromConstIdxs idxs t
             | None -> None)
      | LLVMsyntax.Coq_const_insertvalue (c0, c', lc) -> getTyp c0
      | LLVMsyntax.Coq_const_bop (bop5, c1, c2) -> getTyp c1
      | LLVMsyntax.Coq_const_fbop (fbop5, c1, c2) -> getTyp c1
      | _ -> Some (LLVMsyntax.Coq_typ_int Size.coq_One)
    
    (** val gen_utyps_maps_aux_ :
        (LLVMsyntax.id -> (LLVMsyntax.id*LLVMsyntax.typ) list ->
        LLVMsyntax.typ -> LLVMsyntax.typ option) -> LLVMsyntax.id ->
        (LLVMsyntax.id*LLVMsyntax.typ) list -> LLVMsyntax.typ list ->
        LLVMsyntax.typ list option **)
    
    let rec gen_utyps_maps_aux_ gen_utyp_maps_aux0 cid m = function
      | [] -> Some []
      | t0::ts0 ->
          mbind (fun ut0 ->
            mbind (fun uts0 -> Some (ut0::uts0))
              (gen_utyps_maps_aux_ gen_utyp_maps_aux0 cid m ts0))
            (gen_utyp_maps_aux0 cid m t0)
    
    (** val gen_utyp_maps_aux :
        LLVMsyntax.id -> (LLVMsyntax.id*LLVMsyntax.typ) list ->
        LLVMsyntax.typ -> LLVMsyntax.typ option **)
    
    let rec gen_utyp_maps_aux cid m t = match t with
      | LLVMsyntax.Coq_typ_array (s, t0) ->
          mbind (fun ut0 -> Some (LLVMsyntax.Coq_typ_array (s, ut0)))
            (gen_utyp_maps_aux cid m t0)
      | LLVMsyntax.Coq_typ_function (t0, ts0, va) ->
          mbind (fun ut0 ->
            mbind (fun uts0 -> Some (LLVMsyntax.Coq_typ_function (ut0, uts0,
              va))) (gen_utyps_maps_aux_ gen_utyp_maps_aux cid m ts0))
            (gen_utyp_maps_aux cid m t0)
      | LLVMsyntax.Coq_typ_struct ts0 ->
          mbind (fun uts0 -> Some (LLVMsyntax.Coq_typ_struct uts0))
            (gen_utyps_maps_aux_ gen_utyp_maps_aux cid m ts0)
      | LLVMsyntax.Coq_typ_pointer t0 ->
          (match gen_utyp_maps_aux cid m t0 with
             | Some ut0 -> Some (LLVMsyntax.Coq_typ_pointer ut0)
             | None ->
                 (match t0 with
                    | LLVMsyntax.Coq_typ_namedt i0 ->
                        if AtomImpl.eq_atom_dec i0 cid then Some t else None
                    | _ -> None))
      | LLVMsyntax.Coq_typ_namedt i0 -> lookupAL m i0
      | x -> Some x
    
    (** val gen_utyps_maps_aux :
        LLVMsyntax.id -> (LLVMsyntax.id*LLVMsyntax.typ) list ->
        LLVMsyntax.typ list -> LLVMsyntax.typ list option **)
    
    let gen_utyps_maps_aux =
      gen_utyps_maps_aux_ gen_utyp_maps_aux
    
    (** val gen_utyp_maps :
        LLVMsyntax.namedts -> (LLVMsyntax.id*LLVMsyntax.typ) list **)
    
    let rec gen_utyp_maps = function
      | [] -> []
      | n::nts' ->
          let id0,t = n in
          let results = gen_utyp_maps nts' in
          (match gen_utyp_maps_aux id0 results (LLVMsyntax.Coq_typ_struct t) with
             | Some r -> (id0,r)::results
             | None -> results)
    
    (** val typs2utyps_aux_ :
        ((LLVMsyntax.id*LLVMsyntax.typ) list -> LLVMsyntax.typ ->
        LLVMsyntax.typ option) -> (LLVMsyntax.id*LLVMsyntax.typ) list ->
        LLVMsyntax.typ list -> LLVMsyntax.typ list option **)
    
    let rec typs2utyps_aux_ typ2utyp_aux0 m = function
      | [] -> Some []
      | t0::ts0 ->
          mbind (fun ut0 ->
            mbind (fun uts0 -> Some (ut0::uts0))
              (typs2utyps_aux_ typ2utyp_aux0 m ts0)) 
            (typ2utyp_aux0 m t0)
    
    (** val typ2utyp_aux :
        (LLVMsyntax.id*LLVMsyntax.typ) list -> LLVMsyntax.typ ->
        LLVMsyntax.typ option **)
    
    let rec typ2utyp_aux m = function
      | LLVMsyntax.Coq_typ_array (s, t0) ->
          mbind (fun ut0 -> Some (LLVMsyntax.Coq_typ_array (s, ut0)))
            (typ2utyp_aux m t0)
      | LLVMsyntax.Coq_typ_function (t0, ts0, va) ->
          mbind (fun ut0 ->
            mbind (fun uts0 -> Some (LLVMsyntax.Coq_typ_function (ut0, uts0,
              va))) (typs2utyps_aux_ typ2utyp_aux m ts0)) 
            (typ2utyp_aux m t0)
      | LLVMsyntax.Coq_typ_struct ts0 ->
          mbind (fun uts0 -> Some (LLVMsyntax.Coq_typ_struct uts0))
            (typs2utyps_aux_ typ2utyp_aux m ts0)
      | LLVMsyntax.Coq_typ_pointer t0 ->
          mbind (fun ut0 -> Some (LLVMsyntax.Coq_typ_pointer ut0))
            (typ2utyp_aux m t0)
      | LLVMsyntax.Coq_typ_namedt i0 -> lookupAL m i0
      | x -> Some x
    
    (** val typs2utyps_aux :
        (LLVMsyntax.id*LLVMsyntax.typ) list -> LLVMsyntax.typ list ->
        LLVMsyntax.typ list option **)
    
    let typs2utyps_aux =
      typs2utyps_aux_ typ2utyp_aux
    
    (** val typ2utyp' :
        LLVMsyntax.namedts -> LLVMsyntax.typ -> LLVMsyntax.typ option **)
    
    let typ2utyp' nts t =
      let m = gen_utyp_maps (rev nts) in typ2utyp_aux m t
    
    (** val subst_typ :
        LLVMsyntax.id -> LLVMsyntax.typ -> LLVMsyntax.typ -> LLVMsyntax.typ **)
    
    let rec subst_typ i' t' t =
      let subst_typs =
        let rec subst_typs i'0 t'0 = function
          | [] -> []
          | t0::ts0 ->
              (subst_typ i'0 t'0 t0)::(Obj.magic subst_typs i'0 t'0 ts0)
        in subst_typs
      in
      (match t with
         | LLVMsyntax.Coq_typ_array (s, t0) -> LLVMsyntax.Coq_typ_array (s,
             (subst_typ i' t' t0))
         | LLVMsyntax.Coq_typ_function (t0, ts0, va) ->
             LLVMsyntax.Coq_typ_function ((subst_typ i' t' t0),
             (subst_typs i' t' ts0), va)
         | LLVMsyntax.Coq_typ_struct ts0 -> LLVMsyntax.Coq_typ_struct
             (subst_typs i' t' ts0)
         | LLVMsyntax.Coq_typ_pointer t0 -> LLVMsyntax.Coq_typ_pointer
             (subst_typ i' t' t0)
         | LLVMsyntax.Coq_typ_namedt i0 ->
             if AtomImpl.eq_atom_dec i0 i' then t' else t
         | _ -> t)
    
    (** val subst_typ_by_nts :
        LLVMsyntax.namedts -> LLVMsyntax.typ -> LLVMsyntax.typ **)
    
    let rec subst_typ_by_nts nts t =
      match nts with
        | [] -> t
        | n::nts' ->
            let id',ts' = n in
            subst_typ_by_nts nts'
              (subst_typ id' (LLVMsyntax.Coq_typ_struct ts') t)
    
    (** val subst_nts_by_nts :
        LLVMsyntax.namedts -> LLVMsyntax.namedts ->
        (LLVMsyntax.id*LLVMsyntax.typ) list **)
    
    let rec subst_nts_by_nts nts0 = function
      | [] -> []
      | n::nts' ->
          let id',t' = n in
          (id',(subst_typ_by_nts nts0 (LLVMsyntax.Coq_typ_struct t')))::
          (subst_nts_by_nts nts0 nts')
    
    (** val typ2utyp :
        LLVMsyntax.namedts -> LLVMsyntax.typ -> LLVMsyntax.typ option **)
    
    let typ2utyp nts t =
      let m = subst_nts_by_nts nts nts in typ2utyp_aux m t
    
    (** val getDefReturnType : LLVMsyntax.fdef -> LLVMsyntax.typ **)
    
    let getDefReturnType = function
      | LLVMsyntax.Coq_fdef_intro (fheader5, blocks5) ->
          let LLVMsyntax.Coq_fheader_intro (fnattrs5, t, id5, args5, varg5) =
            fheader5
          in
          t
    
    (** val getDefFunctionType : LLVMsyntax.fdef -> LLVMsyntax.typ **)
    
    let getDefFunctionType fd =
      getFdefTyp fd
    
    (** val def_arg_size : LLVMsyntax.fdef -> nat **)
    
    let def_arg_size = function
      | LLVMsyntax.Coq_fdef_intro (fheader5, blocks5) ->
          let LLVMsyntax.Coq_fheader_intro (fnattrs5, typ5, id5, la, varg5) =
            fheader5
          in
          length la
    
    (** val getDecReturnType : LLVMsyntax.fdec -> LLVMsyntax.typ **)
    
    let getDecReturnType = function
      | LLVMsyntax.Coq_fdec_intro (fheader5, deckind5) ->
          let LLVMsyntax.Coq_fheader_intro (fnattrs5, t, id5, args5, varg5) =
            fheader5
          in
          t
    
    (** val getDecFunctionType : LLVMsyntax.fdec -> LLVMsyntax.typ **)
    
    let getDecFunctionType fd =
      getFdecTyp fd
    
    (** val dec_arg_size : LLVMsyntax.fdec -> nat **)
    
    let dec_arg_size = function
      | LLVMsyntax.Coq_fdec_intro (fheader5, deckind5) ->
          let LLVMsyntax.Coq_fheader_intro (fnattrs5, typ5, id5, la, varg5) =
            fheader5
          in
          length la
   end
  
  module Instruction = 
   struct 
    (** val getNumOperands : LLVMsyntax.insn -> nat **)
    
    let getNumOperands i0 =
      length (getInsnOperands i0)
    
    (** val isCallInst : LLVMsyntax.cmd -> bool **)
    
    let isCallInst i0 =
      _isCallInsnB i0
   end
  
  module ReturnInst = 
   struct 
    (** val getNumOperands : LLVMsyntax.insn -> nat **)
    
    let getNumOperands i0 =
      length (getInsnOperands i0)
    
    (** val isCallInst : LLVMsyntax.cmd -> bool **)
    
    let isCallInst i0 =
      _isCallInsnB i0
    
    (** val hasReturnType : LLVMsyntax.terminator -> bool **)
    
    let hasReturnType = function
      | LLVMsyntax.Coq_insn_return (id5, t, v) -> true
      | _ -> false
    
    (** val getReturnType :
        LLVMsyntax.terminator -> LLVMsyntax.typ option **)
    
    let getReturnType = function
      | LLVMsyntax.Coq_insn_return (id5, t, v) -> Some t
      | _ -> None
   end
  
  module CallSite = 
   struct 
    (** val getFdefTyp : LLVMsyntax.fdef -> LLVMsyntax.typ **)
    
    let getFdefTyp fd =
      getFdefTyp fd
    
    (** val arg_size : LLVMsyntax.fdef -> nat **)
    
    let arg_size = function
      | LLVMsyntax.Coq_fdef_intro (fheader5, blocks5) ->
          let LLVMsyntax.Coq_fheader_intro (fnattrs5, typ5, id5, la, varg5) =
            fheader5
          in
          length la
    
    (** val getArgument : LLVMsyntax.fdef -> nat -> LLVMsyntax.arg option **)
    
    let getArgument fd i0 =
      let LLVMsyntax.Coq_fdef_intro (fheader5, blocks5) = fd in
      let LLVMsyntax.Coq_fheader_intro (fnattrs5, typ5, id5, la, varg5) =
        fheader5
      in
      nth_error la i0
    
    (** val getArgumentType :
        LLVMsyntax.fdef -> nat -> LLVMsyntax.typ option **)
    
    let getArgumentType fd i0 =
      match getArgument fd i0 with
        | Some a -> let p,i1 = a in let t,a0 = p in Some t
        | None -> None
   end
  
  module CallInst = 
   struct 
    (** val getNumOperands : LLVMsyntax.insn -> nat **)
    
    let getNumOperands i0 =
      length (getInsnOperands i0)
    
    (** val isCallInst : LLVMsyntax.cmd -> bool **)
    
    let isCallInst i0 =
      _isCallInsnB i0
   end
  
  module BinaryOperator = 
   struct 
    (** val getNumOperands : LLVMsyntax.insn -> nat **)
    
    let getNumOperands i0 =
      length (getInsnOperands i0)
    
    (** val isCallInst : LLVMsyntax.cmd -> bool **)
    
    let isCallInst i0 =
      _isCallInsnB i0
    
    (** val getFirstOperandType :
        LLVMsyntax.fdef -> LLVMsyntax.cmd -> LLVMsyntax.typ option **)
    
    let getFirstOperandType f = function
      | LLVMsyntax.Coq_insn_bop (id5, bop5, sz5, v1, value2) ->
          (match v1 with
             | LLVMsyntax.Coq_value_id id1 -> lookupTypViaIDFromFdef f id1
             | LLVMsyntax.Coq_value_const c -> Constant.getTyp c)
      | _ -> None
    
    (** val getSecondOperandType :
        LLVMsyntax.fdef -> LLVMsyntax.cmd -> LLVMsyntax.typ option **)
    
    let getSecondOperandType f = function
      | LLVMsyntax.Coq_insn_bop (id5, bop5, sz5, value1, v2) ->
          (match v2 with
             | LLVMsyntax.Coq_value_id id2 -> lookupTypViaIDFromFdef f id2
             | LLVMsyntax.Coq_value_const c -> Constant.getTyp c)
      | _ -> None
    
    (** val getResultType : LLVMsyntax.cmd -> LLVMsyntax.typ option **)
    
    let getResultType i0 =
      getCmdTyp i0
   end
  
  module PHINode = 
   struct 
    (** val getNumOperands : LLVMsyntax.insn -> nat **)
    
    let getNumOperands i0 =
      length (getInsnOperands i0)
    
    (** val isCallInst : LLVMsyntax.cmd -> bool **)
    
    let isCallInst i0 =
      _isCallInsnB i0
    
    (** val getNumIncomingValues : LLVMsyntax.phinode -> nat **)
    
    let getNumIncomingValues = function
      | LLVMsyntax.Coq_insn_phi (id5, typ5, ln) -> length ln
    
    (** val getIncomingValueType :
        LLVMsyntax.fdef -> LLVMsyntax.phinode -> nat -> LLVMsyntax.typ option **)
    
    let getIncomingValueType f i0 n =
      let LLVMsyntax.Coq_insn_phi (id5, typ5, ln) = i0 in
      (match nth_error ln n with
         | Some p ->
             let v,l0 = p in
             (match v with
                | LLVMsyntax.Coq_value_id id0 -> lookupTypViaIDFromFdef f id0
                | LLVMsyntax.Coq_value_const c -> Constant.getTyp c)
         | None -> None)
   end
  
  module Typ = 
   struct 
    (** val isIntOrIntVector : LLVMsyntax.typ -> bool **)
    
    let isIntOrIntVector = function
      | LLVMsyntax.Coq_typ_int sz5 -> true
      | _ -> false
    
    (** val isInteger : LLVMsyntax.typ -> bool **)
    
    let isInteger = function
      | LLVMsyntax.Coq_typ_int sz5 -> true
      | _ -> false
    
    (** val isSized : LLVMsyntax.typ -> bool **)
    
    let rec isSized t =
      let isSizedListTyp =
        let rec isSizedListTyp = function
          | [] -> true
          | t0::lt' -> if isSized t0 then isSizedListTyp lt' else false
        in isSizedListTyp
      in
      (match t with
         | LLVMsyntax.Coq_typ_int sz5 -> true
         | LLVMsyntax.Coq_typ_floatpoint floating_point5 -> true
         | LLVMsyntax.Coq_typ_array (sz5, t') -> isSized t'
         | LLVMsyntax.Coq_typ_struct lt -> isSizedListTyp lt
         | LLVMsyntax.Coq_typ_pointer typ5 -> true
         | _ -> false)
    
    (** val getPrimitiveSizeInBits : LLVMsyntax.typ -> LLVMsyntax.sz **)
    
    let getPrimitiveSizeInBits = function
      | LLVMsyntax.Coq_typ_int sz0 -> sz0
      | _ -> Size.coq_Zero
   end
  
  module DerivedType = 
   struct 
    (** val isIntOrIntVector : LLVMsyntax.typ -> bool **)
    
    let isIntOrIntVector = function
      | LLVMsyntax.Coq_typ_int sz5 -> true
      | _ -> false
    
    (** val isInteger : LLVMsyntax.typ -> bool **)
    
    let isInteger = function
      | LLVMsyntax.Coq_typ_int sz5 -> true
      | _ -> false
    
    (** val isSized : LLVMsyntax.typ -> bool **)
    
    let rec isSized t =
      let isSizedListTyp =
        let rec isSizedListTyp = function
          | [] -> true
          | t0::lt' -> if isSized t0 then isSizedListTyp lt' else false
        in isSizedListTyp
      in
      (match t with
         | LLVMsyntax.Coq_typ_int sz5 -> true
         | LLVMsyntax.Coq_typ_floatpoint floating_point5 -> true
         | LLVMsyntax.Coq_typ_array (sz5, t') -> isSized t'
         | LLVMsyntax.Coq_typ_struct lt -> isSizedListTyp lt
         | LLVMsyntax.Coq_typ_pointer typ5 -> true
         | _ -> false)
    
    (** val getPrimitiveSizeInBits : LLVMsyntax.typ -> LLVMsyntax.sz **)
    
    let getPrimitiveSizeInBits = function
      | LLVMsyntax.Coq_typ_int sz0 -> sz0
      | _ -> Size.coq_Zero
   end
  
  module FunctionType = 
   struct 
    (** val isIntOrIntVector : LLVMsyntax.typ -> bool **)
    
    let isIntOrIntVector = function
      | LLVMsyntax.Coq_typ_int sz5 -> true
      | _ -> false
    
    (** val isInteger : LLVMsyntax.typ -> bool **)
    
    let isInteger = function
      | LLVMsyntax.Coq_typ_int sz5 -> true
      | _ -> false
    
    (** val isSized : LLVMsyntax.typ -> bool **)
    
    let rec isSized t =
      let isSizedListTyp =
        let rec isSizedListTyp = function
          | [] -> true
          | t0::lt' -> if isSized t0 then isSizedListTyp lt' else false
        in isSizedListTyp
      in
      (match t with
         | LLVMsyntax.Coq_typ_int sz5 -> true
         | LLVMsyntax.Coq_typ_floatpoint floating_point5 -> true
         | LLVMsyntax.Coq_typ_array (sz5, t') -> isSized t'
         | LLVMsyntax.Coq_typ_struct lt -> isSizedListTyp lt
         | LLVMsyntax.Coq_typ_pointer typ5 -> true
         | _ -> false)
    
    (** val getPrimitiveSizeInBits : LLVMsyntax.typ -> LLVMsyntax.sz **)
    
    let getPrimitiveSizeInBits = function
      | LLVMsyntax.Coq_typ_int sz0 -> sz0
      | _ -> Size.coq_Zero
    
    (** val getNumParams : LLVMsyntax.typ -> nat option **)
    
    let getNumParams = function
      | LLVMsyntax.Coq_typ_function (typ_5, lt, varg5) -> Some (length lt)
      | _ -> None
    
    (** val isVarArg : LLVMsyntax.typ -> bool **)
    
    let isVarArg t =
      false
    
    (** val getParamType : LLVMsyntax.typ -> nat -> LLVMsyntax.typ option **)
    
    let getParamType t i0 =
      match t with
        | LLVMsyntax.Coq_typ_function (typ_5, lt, varg5) -> nth_error lt i0
        | _ -> None
   end
  
  module CompositeType = 
   struct 
    (** val isIntOrIntVector : LLVMsyntax.typ -> bool **)
    
    let isIntOrIntVector = function
      | LLVMsyntax.Coq_typ_int sz5 -> true
      | _ -> false
    
    (** val isInteger : LLVMsyntax.typ -> bool **)
    
    let isInteger = function
      | LLVMsyntax.Coq_typ_int sz5 -> true
      | _ -> false
    
    (** val isSized : LLVMsyntax.typ -> bool **)
    
    let rec isSized t =
      let isSizedListTyp =
        let rec isSizedListTyp = function
          | [] -> true
          | t0::lt' -> if isSized t0 then isSizedListTyp lt' else false
        in isSizedListTyp
      in
      (match t with
         | LLVMsyntax.Coq_typ_int sz5 -> true
         | LLVMsyntax.Coq_typ_floatpoint floating_point5 -> true
         | LLVMsyntax.Coq_typ_array (sz5, t') -> isSized t'
         | LLVMsyntax.Coq_typ_struct lt -> isSizedListTyp lt
         | LLVMsyntax.Coq_typ_pointer typ5 -> true
         | _ -> false)
    
    (** val getPrimitiveSizeInBits : LLVMsyntax.typ -> LLVMsyntax.sz **)
    
    let getPrimitiveSizeInBits = function
      | LLVMsyntax.Coq_typ_int sz0 -> sz0
      | _ -> Size.coq_Zero
   end
  
  module SequentialType = 
   struct 
    (** val isIntOrIntVector : LLVMsyntax.typ -> bool **)
    
    let isIntOrIntVector = function
      | LLVMsyntax.Coq_typ_int sz5 -> true
      | _ -> false
    
    (** val isInteger : LLVMsyntax.typ -> bool **)
    
    let isInteger = function
      | LLVMsyntax.Coq_typ_int sz5 -> true
      | _ -> false
    
    (** val isSized : LLVMsyntax.typ -> bool **)
    
    let rec isSized t =
      let isSizedListTyp =
        let rec isSizedListTyp = function
          | [] -> true
          | t0::lt' -> if isSized t0 then isSizedListTyp lt' else false
        in isSizedListTyp
      in
      (match t with
         | LLVMsyntax.Coq_typ_int sz5 -> true
         | LLVMsyntax.Coq_typ_floatpoint floating_point5 -> true
         | LLVMsyntax.Coq_typ_array (sz5, t') -> isSized t'
         | LLVMsyntax.Coq_typ_struct lt -> isSizedListTyp lt
         | LLVMsyntax.Coq_typ_pointer typ5 -> true
         | _ -> false)
    
    (** val getPrimitiveSizeInBits : LLVMsyntax.typ -> LLVMsyntax.sz **)
    
    let getPrimitiveSizeInBits = function
      | LLVMsyntax.Coq_typ_int sz0 -> sz0
      | _ -> Size.coq_Zero
    
    (** val hasElementType : LLVMsyntax.typ -> bool **)
    
    let hasElementType = function
      | LLVMsyntax.Coq_typ_array (sz5, t') -> true
      | _ -> false
    
    (** val getElementType : LLVMsyntax.typ -> LLVMsyntax.typ option **)
    
    let getElementType = function
      | LLVMsyntax.Coq_typ_array (sz5, t') -> Some t'
      | _ -> None
   end
  
  module ArrayType = 
   struct 
    (** val isIntOrIntVector : LLVMsyntax.typ -> bool **)
    
    let isIntOrIntVector = function
      | LLVMsyntax.Coq_typ_int sz5 -> true
      | _ -> false
    
    (** val isInteger : LLVMsyntax.typ -> bool **)
    
    let isInteger = function
      | LLVMsyntax.Coq_typ_int sz5 -> true
      | _ -> false
    
    (** val isSized : LLVMsyntax.typ -> bool **)
    
    let rec isSized t =
      let isSizedListTyp =
        let rec isSizedListTyp = function
          | [] -> true
          | t0::lt' -> if isSized t0 then isSizedListTyp lt' else false
        in isSizedListTyp
      in
      (match t with
         | LLVMsyntax.Coq_typ_int sz5 -> true
         | LLVMsyntax.Coq_typ_floatpoint floating_point5 -> true
         | LLVMsyntax.Coq_typ_array (sz5, t') -> isSized t'
         | LLVMsyntax.Coq_typ_struct lt -> isSizedListTyp lt
         | LLVMsyntax.Coq_typ_pointer typ5 -> true
         | _ -> false)
    
    (** val getPrimitiveSizeInBits : LLVMsyntax.typ -> LLVMsyntax.sz **)
    
    let getPrimitiveSizeInBits = function
      | LLVMsyntax.Coq_typ_int sz0 -> sz0
      | _ -> Size.coq_Zero
    
    (** val hasElementType : LLVMsyntax.typ -> bool **)
    
    let hasElementType = function
      | LLVMsyntax.Coq_typ_array (sz5, t') -> true
      | _ -> false
    
    (** val getElementType : LLVMsyntax.typ -> LLVMsyntax.typ option **)
    
    let getElementType = function
      | LLVMsyntax.Coq_typ_array (sz5, t') -> Some t'
      | _ -> None
    
    (** val getNumElements : LLVMsyntax.typ -> nat **)
    
    let getNumElements = function
      | LLVMsyntax.Coq_typ_array (n, typ5) -> Size.to_nat n
      | _ -> O
   end
  
  (** val typ2memory_chunk : LLVMsyntax.typ -> memory_chunk option **)
  
  let typ2memory_chunk = function
    | LLVMsyntax.Coq_typ_int bsz -> Some (Mint
        (minus (Size.to_nat bsz) (S O)))
    | LLVMsyntax.Coq_typ_floatpoint floating_point5 ->
        (match floating_point5 with
           | LLVMsyntax.Coq_fp_float -> Some Mfloat32
           | LLVMsyntax.Coq_fp_double -> Some Mfloat64
           | _ -> None)
    | LLVMsyntax.Coq_typ_pointer typ5 -> Some (Mint (S (S (S (S (S (S (S (S
        (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S
        O))))))))))))))))))))))))))))))))
    | _ -> None
  
  (** val typ_eq_list_typ :
      LLVMsyntax.namedts -> LLVMsyntax.typ -> LLVMsyntax.typ list -> bool **)
  
  let typ_eq_list_typ nts t1 ts2 =
    match t1 with
      | LLVMsyntax.Coq_typ_struct ts1 -> proj_sumbool (list_typ_dec ts1 ts2)
      | LLVMsyntax.Coq_typ_namedt nid1 ->
          (match lookupAL nts nid1 with
             | Some ts1 -> proj_sumbool (list_typ_dec ts1 ts2)
             | None -> false)
      | _ -> false
  
  type reflect =
    | ReflectT
    | ReflectF
  
  (** val reflect_rect :
      (__ -> 'a1) -> (__ -> 'a1) -> bool -> reflect -> 'a1 **)
  
  let reflect_rect f f0 b = function
    | ReflectT -> f __
    | ReflectF -> f0 __
  
  (** val reflect_rec :
      (__ -> 'a1) -> (__ -> 'a1) -> bool -> reflect -> 'a1 **)
  
  let reflect_rec f f0 b = function
    | ReflectT -> f __
    | ReflectF -> f0 __
 end

